<?php

$couponsObj = new coupons();

class coupons {

    public $mDb;
    public $mConfig;
    public $dateTime;
    public $lang_code;
    public $productsObj;

    public function __construct() {
        global $Config;

        $this->mDb = new iplus();
        $this->mConfig = $Config;
        $this->dateTime = date('Y-m-d H:i:s');
        $this->lang_code = LANGUAGE; // تأكد من أن LANGUAGE مُعرف
        $this->productsObj = new Products();
    }

    function getCoupons($aStart, $aLimit, $sort, $type, $searchTitle, $searchCouponStartDate, $searchCouponEndDate, $searchMarketingCoupon, $searchCouponStatus, $searchAffiliator_id, $searchServiceId) {




        $sql = "SELECT p.*,count(cu.coupon_id) as count_coupon_used ,pl.title ,pl.description , pl.attachment_single , u.user_name AS 'addedBy' , u2.user_name AS 'affiliator_name',mcn.user_name AS 'marketer_client_name'  FROM coupons p";
        $sql .= " LEFT JOIN `coupon_langs` pl ON p.id = pl.coupon_id AND pl.lang_code ='{$this->lang_code}' ";
        $sql .= " LEFT JOIN `coupons_used` cu ON p.id = cu.coupon_id ";
        $sql .= " LEFT JOIN `users` u ON u.id = p.admin_id ";
        $sql .= " LEFT JOIN `users` u2 ON u2.id = p.affiliator_id ";
        $sql .= " LEFT JOIN `users` mcn ON mcn.id = p.marketer_client_id ";

        $sql .= " WHERE p.id > 0    ";

        $sql .= $searchTitle ? ' AND pl.title like "%' . $searchTitle . '%" ' : '';
        $sql .= $searchMarketingCoupon != '' ? " AND p.marketing_coupon ='{$searchMarketingCoupon}' " : '';
        $sql .= $searchCouponStatus != '' ? " AND p.coupon_status ='{$searchCouponStatus}' " : '';
        $sql .= $searchAffiliator_id ? " AND p.`affiliator_id` ='{$searchAffiliator_id}' " : " ";
        $sql .= $searchCouponStartDate ? " AND p.`coupon_start_date`   >= '{$searchCouponStartDate}' " : "";
        $sql .= $searchCouponEndDate ? " AND p.`coupon_end_date`  <= '{$searchCouponEndDate}' " : "";

        $sql .= " Group by p.id  ORDER BY p.{$sort} {$type}";

        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';

//           echo $sql."<hr>";


        $res = $this->mDb->getAll($sql);

        return $res;
    }

    function getSearchCouponsCount($sort, $type, $searchTitle, $searchCouponStartDate, $searchCouponEndDate, $searchMarketingCoupon, $searchCouponStatus, $searchAffiliator_id, $searchServiceId) {



        $sql = "SELECT COUNT(DISTINCT  `p`.`id`) as 'result_count' FROM coupons p";
        $sql .= " LEFT JOIN `coupon_langs` pl ON p.id = pl.coupon_id ";

        $sql .= " WHERE p.`id` > 0";
        $sql .= $searchTitle ? ' AND pl.`title` like "%' . $searchTitle . '%"' : '';
        $sql .= $searchMarketingCoupon != '' ? " AND p.marketing_coupon ='{$searchMarketingCoupon}' " : '';
        $sql .= $searchCouponStatus != '' ? " AND p.coupon_status ='{$searchCouponStatus}' " : '';
        $sql .= $searchAffiliator_id ? " AND p.`affiliator_id` ='{$searchAffiliator_id}' " : " ";
        $sql .= $searchCouponStartDate ? " AND p.`coupon_start_date`   >= '{$searchCouponStartDate}' " : "";
        $sql .= $searchCouponEndDate ? " AND p.`coupon_end_date`  <= '{$searchCouponEndDate}' " : "";

        $sql .= " ORDER BY p.{$sort} {$type}";

//       echo $sql."<hr>";

        return $this->mDb->getOne($sql);
    }

    function getCouponUsed($id) {

        $sql = "SELECT cu.*,u.user_name FROM coupons_used cu ";
        $sql .= " LEFT JOIN `users` u ON u.id = cu.client_id ";
        $sql .= " WHERE  cu.coupon_id ='{$id}' ";
        $sql .= " ORDER BY cu.date_added";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
//        echo $sql."<hr>";
        $res = $this->mDb->getAll($sql);

        return $res;
    }

    function getCouponsCount() {
        $sql = "SELECT COUNT(DISTINCT `id`) as 'count' FROM `coupons`";
        return $this->mDb->getOne($sql);
    }

    function getAllcoupon_showing_type_options() {

        $sql = "SELECT * FROM offer_showing_type_options  ";
        // echo $sql; die();
        return $this->mDb->getAll($sql);
    }

    function addDiscountCoupon($temp, $id, $type) {



        $temp['ids'] = "," . fetchArrayValue_from_dataBase($temp['ids'], 'id') . ",";
        $temp['maximum_discount_value'] = $type == 'discount_percentage' ? $temp['maximum_discount_value'] : '0';
        $sql = "INSERT INTO `coupon_discount` SET ";
        foreach ($this->mDb->getCols('coupon_discount', $temp) as $k => $v) {
            $sql .= ($k == 'lang_Details' || $k == 'lang_parameter' || $k == 'coupon_id') ? "" : "`{$k}`='{$v}',";
        }
        $sql .= " `coupon_id` = '{$id}'";
        // echo $sql ; die();
        $this->mDb->query($sql);
    }

    function addEditCoupon($temp) {
        $temp['client_type_id'] = $temp['client_type_id_new'];
        $temp['active'] = $temp['active'] ? '1' : '0';
        $temp['coupon_status'] = 'valid';
        $temp['except_discounted_products'] = $temp['except_discounted_products'] ? '1' : '0';
        $temp['show_coupon_banner'] = $temp['show_coupon_banner'] ? '1' : '0';
        $temp['marketing_coupon'] = $temp['marketing_coupon'] ? '1' : '0';
        $temp['show_end_date'] = $temp['show_end_date'] ? '1' : '0';
        $temp['sort'] = $temp['sort'] ? $temp['sort'] : '0';

        $temp['show_on_places'] = implode(",", $temp['show_on_places']);

        if ($temp['coupon_start_date']) {
            $temp['coupon_start_date'] = date_format(date_create($temp['coupon_start_date']), "Y-m-d");
        } else {
            unset($temp['coupon_start_date']);
        }
        if ($temp['coupon_end_date']) {
            $temp['coupon_end_date'] = date_format(date_create($temp['coupon_end_date']), "Y-m-d");
        } else {
            unset($temp['coupon_end_date']);
        }


        if ($temp['id'] === null || $temp['id'] === '') {
            // add

            $sql = "INSERT INTO `coupons` SET ";
            foreach ($this->mDb->getCols('coupons', $temp) as $k => $v) {
                $sql .= ($k == 'lang_Details' || $k == 'lang_parameter') ? "" : "`{$k}`='{$v}',";
            }
            $sql .= " `date_added` = '{$this->dateTime}'";
//               echo  $sql."<hr>";
//              die();
            $res = $this->mDb->query($sql);
            if ($res) {
                $id = $this->mDb->getLastInsertId();
                //enter lang_details
                foreach ($temp['lang_Details'] as $k => $v) {
                    $sql = " INSERT INTO `coupon_langs` SET  lang_code = '{$v['lang_code']}'  , title = '{$v['details']['title']}' , coupon_id='{$id}'  , description = '{$v['details']['description']}' , attachment_single = '{$v['details']['attachment_single']}'   ";
                    //   echo "$sql";die();
                    $res2 = $this->mDb->query($sql);
                }



                if ($temp['coupon_type'] == 'discount_percentage' || $temp['coupon_type'] == 'discount_constant') {
                    $this->addDiscountCoupon($temp['coupon_discount'], $id, $temp['coupon_type']);
                }
                # code...
            }
            return $res;
        } else {

            // edit
            if ($temp['image'] == '') { //remove image if we removed
                $image = $this->getimg($temp['id']);
                $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . DEALERUPLOAD . '/coupons/' . $image;
                if (file_exists($old_img)) {
                    @unlink($old_img);
                }
            }
            $sql = "UPDATE `coupons` SET ";
            foreach ($this->mDb->getCols('coupons', $temp) as $k => $v) {
                $sql .= ($k == 'lang_Details' || $k == 'id' || $k == 'lang_parameter') ? "" : "`{$k}`='{$v}',";
            }
            $sql = substr($sql, 0, -1);
            $sql .= " WHERE `id` = '{$temp['id']}'";
//            echo $sql."<hr>";
            $res = $this->mDb->query($sql);
            if ($res) {





                $this->deleteDiscountCoupon($temp['id']);

                if ($temp['coupon_type'] == 'discount_percentage' || $temp['coupon_type'] == 'discount_constant') {
                    $this->addDiscountCoupon($temp['coupon_discount'], $temp['id'], $temp['coupon_type']);
                }
                //delete lang_details
                $sql = "DELETE FROM `coupon_langs` ";
                $sql .= " WHERE coupon_id='{$temp['id']}'  ";
                $res2 = $this->mDb->query($sql);

                //enter lang_details
                foreach ($temp['lang_Details'] as $k => $v) {
                    $sql = " INSERT INTO `coupon_langs` SET  lang_code = '{$v['lang_code']}' , title = '{$v['details']['title']}'   ,coupon_id='{$temp['id']}'  , description = '{$v['details']['description']}' , attachment_single = '{$v['details']['attachment_single']}'    ";
                    // echo "$sql";die();
                    $res2 = $this->mDb->query($sql);
                }

                # code...
            }

            return $res;
        }
    }

    public function getCouponUsedInfo($mode_id, $mode) {
        $sql = "SELECT cu.*,c.marketing_coupon,c.marketer_client_id,c.marketer_commission_type,c.marketer_commission FROM `coupons_used` cu ";
        $sql .= " LEFT JOIN `coupons` c ON  cu.coupon_id =c.id  ";
        $sql .= " WHERE cu.mode_id = '{$mode_id}' and cu.mode='{$mode}' ";
//        echo $sql."<hr>";
        $res = $this->mDb->getRow($sql);

        return $res ? $res : '';
    }

    public function deleteDiscountCoupon($coupon_id) {
        $sql = "DELETE From `{$this->mPrefix}coupon_discount`   ";
        $sql .= "where coupon_id ='{$coupon_id}'   ";
        $this->mDb->query($sql);
    }

      public function getOneCoupon($id) {
        $sql = "SELECT 
                    b.* , 
                    u2.user_name AS 'affiliator_name', 
                    uc.user_name AS 'client_name' ,
                    mcn.user_name AS 'marketer_client_name'  
                FROM coupons b
                LEFT JOIN users u2 ON u2.id = b.affiliator_id
                LEFT JOIN users uc ON uc.id = b.client_type_id
                LEFT JOIN users mcn ON mcn.id = b.marketer_client_id
                WHERE b.id = :id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':id', $id);
        $stmt->execute();
        $res = $stmt->fetch(PDO::FETCH_ASSOC);
        if ($res) {
            $sql = "SELECT 
                        lang_code ,
                        title , 
                        description ,
                        attachment_single 
                    FROM coupon_langs
                    WHERE coupon_id = :id";
            $stmt = $this->mDb->connect()->prepare($sql);
            $stmt->bindParam(':id', $id);
            $stmt->execute();
            $res['lang_parameter'] = $stmt->fetchAll(PDO::FETCH_ASSOC);
            $res['client_type_array'] = [];
            if ($res['client_type'] == 'specific_clients') {
                $res['client_type_array'] = $this->getClientsInIds('', $res['client_type_id']);
            } elseif ($res['client_type'] == 'group') {
                $res['client_type_array'] = $this->getClientGroupsInIds($res['client_type_id']);
            }
            if ($res['coupon_type'] == 'discount_percentage' || $res['coupon_type'] == 'discount_constant') {

                $sql = "SELECT *   
                        FROM coupon_discount
                        WHERE coupon_id = :id";
                $stmt = $this->mDb->connect()->prepare($sql);
                $stmt->bindParam(':id', $id);
                $stmt->execute();
                $res['coupon_discount'] = $stmt->fetch(PDO::FETCH_ASSOC);
                if ($res['coupon_discount']) {
                    if ($res['coupon_discount']['apply_type_conditions'] == 'products') {
                        $res['coupon_discount']['ids'] = $this->get_products_name_by_ids($res['coupon_discount']['ids']);
                    } else if ($res['coupon_discount']['apply_type_conditions'] == 'services') {
                        $res['coupon_discount']['ids'] = $this->get_services_name_by_ids($res['coupon_discount']['ids']);
                    } else if ($res['coupon_discount']['apply_type_conditions'] == 'trademarks') {
                        $res['coupon_discount']['ids'] = $this->get_trademarks_name_by_ids($res['coupon_discount']['ids']);
                    } else if ($res['coupon_discount']['apply_type_conditions'] == 'tags') {
                        $res['coupon_discount']['ids'] = $this->get_tags_name_by_ids($res['coupon_discount']['ids']);
                    } else if ($res['coupon_discount']['apply_type_conditions'] == 'product_group') {
                        $res['coupon_discount']['ids'] = $this->get_products_groups_name_by_ids($res['coupon_discount']['ids']);
                    }
                }
            }

            $res['show_on_places'] = explode(",", $res['show_on_places']);
        }
        return $res;
    }
    
    public function getClientsInIds($searchAffiliator_id, $ids) {
        $ids = trim($ids, ',');
        $sql = "SELECT u.id,  u.user_name , u.last_name ";
        $sql .= " FROM `users` u ";
        $sql .= " WHERE u.id > 0 and u.id IN({$ids})";
        $sql .= " AND u.`user_level` = '3000'";
        $sql .= $searchAffiliator_id ? " AND u.`affiliator_id` = '{$searchAffiliator_id}' " : "";
//        echo $sql . "<hr>";
        $res = $this->mDb->getAll($sql);
        if ($res) {
            for ($i = 0; $i < count($res); $i++) {
                $res[$i]['user_name'] = $res[$i]['user_name'] . ' ' . $res[$i]['last_name'];
            }
        }
        return $res;
    }

    public function getClientGroupsInIds($ids) {
        $ids = trim($ids, ',');
        $sql = "SELECT cg.id, cg.name ";
        $sql .= " FROM `clients_groups` cg ";
        $sql .= " WHERE cg.id > 0 and cg.id IN({$ids}) ";

//        echo $sql . "<hr>";

        return $this->mDb->getAll($sql);
    }

    public function checkIfExistPriority($affiliator_id, $priority, $id) {
        $sql = "SELECT priority FROM  `coupons`  where id  >  0 ";
        $sql .= $affiliator_id ? " AND `affiliator_id` ='{$affiliator_id}' " : " ";
        $sql .= $id ? " AND `id` !='{$id}' " : " ";
        $sql .= " order by priority asc   ";

        $res['priorities'] = $this->mDb->getAll($sql);
        $res['is_exist'] = array_search($priority, array_column($res['priorities'], 'priority'));
        $res['priorities_string'] = fetchArrayValue_from_dataBase($res['priorities'], 'priority');
        // p($res);
        // echo $sql;
        // die();
        return $res ? $res : array();
    }

    public function checkCode($affiliator_id, $id) {
        $sql = "SELECT code FROM  `coupons`  where id  >  0 ";
        $sql .= $affiliator_id ? " AND `affiliator_id` ='{$affiliator_id}' " : " ";
        $sql .= $id ? " AND `id` !='{$id}' " : " ";
        $sql .= " order by id asc   ";

        $res = $this->mDb->getOne($sql);

        // p($res);
        // echo $sql;
        // die();
        return $res;
    }

    public function get_trademarks_name_by_ids($ids) {
        $ids = substr($ids, 1);
        $ids = substr($ids, 0, -1);
        $sql = "SELECT title , trademark_id as id  FROM  `trademark_langs`  ";
        $sql .= " WHERE  trademark_id  in  ({$ids})   and  lang_code = '{$this->lang_code}'    ";
        $res = $this->mDb->getAll($sql);
        //  echo $sql;
        //   die();
        return $res ? $res : array();
    }

    public function get_services_name_by_ids($ids) {
        $ids = substr($ids, 1);
        $ids = substr($ids, 0, -1);
        $sql = "SELECT ser_name , service_id as id  FROM  `service_langs`  ";
        $sql .= " WHERE  service_id  in  ({$ids})   and  lang_code = '{$this->lang_code}'    ";
        $res = $this->mDb->getAll($sql);
        //  echo $sql;
        //   die();
        return $res ? $res : array();
    }

    public function get_products_name_by_ids($ids) {


        $ids = substr($ids, 1);
        $ids = substr($ids, 0, -1);
        $sql = "SELECT  pl.name ,p.price_one , p.price_multi ,p.id  FROM  `products` p  ";
        $sql .= " LEFT JOIN `product_langs` pl ON pl.product_id = p.id  AND  pl.lang_code = 'ar'";

        $sql .= " WHERE  p.id  in  ({$ids}) ";
        $res = $this->mDb->getAll($sql);
        for ($i = 0; $i < count($res); $i++) {
            $res[$i]['store_amounts'] = $this->productsObj->getProductStoreAmounts($res[$i]['id']);
            $res[$i]['images'] = $this->productsObj->getProductimgs($res[$i]['id']);
            $res[$i]['image'] = $res[$i]['images'][0]['name'];
        }
        //  echo $sql;
        return $res ? $res : array();
    }

    function getimg($id) {
        $sql = "SELECT `image` FROM `coupons`";
        $sql .= " WHERE `id` = '{$id}' ";
        return $this->mDb->getOne($sql);
    }

    function deleteCoupon($ids) {

        $sql = "DELETE FROM `coupons` ";
        $sql .= " WHERE `id` = 0";
        foreach ($ids as $id) {
            $image = $this->getimg($id);
            $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . DEALERUPLOAD . '/coupons/' . $image;

            if (file_exists($old_img)) {
                @unlink($old_img);
            }
            $sql .= " || `id` = '{$id}' ";
        }
        // echo "$sql";die();

        return $this->mDb->query($sql);
    }

    public function get_tags_name_by_ids($ids) {
        $ids = trim($ids, '()');
        $idsArray = explode(',', $ids);
        $placeholders = implode(',', array_map(function ($key) {
                    return ":id" . $key;
                }, array_keys($idsArray)));
        $sql = "SELECT label , tag_id as id 
                FROM tags_langs 
                WHERE tag_id IN ($placeholders) 
                AND lang_code = :lang_code";
        $stmt = $this->mDb->connect()->prepare($sql);
        foreach ($idsArray as $key => $id) {
            $stmt->bindValue(":id" . $key, trim($id), PDO::PARAM_INT);
        }
        $stmt->bindValue(":lang_code", $this->lang_code, PDO::PARAM_STR);
        $stmt->execute();
        $res = $stmt->fetchAll(PDO::FETCH_ASSOC);
        return $res ? $res : [];
    }

    public function get_products_groups_name_by_ids($ids) {
        $ids = trim($ids, '()');
        $idsArray = explode(',', $ids);
        $placeholders = implode(',', array_map(function ($key) {
                    return ":id" . $key;
                }, array_keys($idsArray)));
        $sql = "SELECT name , p_id as id 
                FROM groups_langs 
                WHERE p_id IN ($placeholders) 
                AND lang_code = :lang_code";
        $stmt = $this->mDb->connect()->prepare($sql);
        foreach ($idsArray as $key => $id) {
            $stmt->bindValue(":id" . $key, trim($id), PDO::PARAM_INT);
        }
        $stmt->bindValue(":lang_code", $this->lang_code, PDO::PARAM_STR);
        $stmt->execute();
        $res = $stmt->fetchAll(PDO::FETCH_ASSOC);
        return $res ? $res : [];
    }
}
