<?php

/* * *************************************************************************
 *
 *   PROJECT:  Aramedical system
 *   powerd by  IT PLUS
 *   Copyright 2013 IT Plus Inc
 *   http://it-plus.co/
 *
 * ************************************************************************* */
$settings = new Configuration();

class Configuration {

    public $mDb;
    public $masterDb;
    public $mMailer;
    public $prefix;
    public $mConfig;
    public $mDsp;
    public $config_file = "../includes/config.inc.php";
    public $dateTime;
    public $mPrefix;

    public function __construct() {
        global $Config;
        $this->mDb = new iplus(); // تأكد من أن كائن iplus يتم تهيئته بشكل صحيح
        $this->masterDb = new iplusMaster();
        $this->mMailer = new Mailer();
//        $this->mMailer->mConfig = $Config;
        $this->prefix = $Config['prefix'];
        $this->mConfig = $Config;
        $this->dateTime = date('Y-m-d H:i:s');
        $this->mPrefix = $Config['prefix'] ?? '';
    }

    /**
     * Saves configuration to a file
     *
     * @param array $aConfigs modified configuration array
     *
     * @return bool
     */
    function saveConfig($aConfigs) {
        $aConfigs['show_products_quantity_to_affilators'] = $aConfigs['show_products_quantity_to_affilators'] ? '1' : '0';

        $configs = $this->mergeConfig($aConfigs);

        /** now build string that will be written to config file * */
        $out_config = "<?php\n";
        foreach ($configs as $key => $value) {


            $out_config .= '$Config[\'' . $key . "'] = '" . addslashes($value) . "';\n";
        }
        $out_config .= "?>";

        /** write configuration to a file * */
        $f = fopen($this->config_file, 'w');
        // echo "<pre>ddd";print_r($this->config_file); die();
        if (!$f)
            return false;
        if (0 != get_magic_quotes_gpc()) {
            $out_config = $out_config;
        }
        fwrite($f, $out_config);
        fclose($f);

        return true;
    }

    /**
     * Compares current config and changed one
     *
     * @param arr $aConfigs modified configuration array
     *
     * @return arr
     */
    function mergeConfig($aConfigs) {
        global $Config;

        $merged = array_merge($Config, $aConfigs);

        foreach ($merged as $key => $value) {
            $config[$key] = stripslashes($value);
        }

        return $config;
    }

    function getAutoLoadSettings($dealer_id = '') {
        global $dealerObj;
        $sql = " SELECT name,value ";
        $sql .= " FROM `{$this->mPrefix}settings` ";
        $sql .= " WHERE `autoload`='1' ";

        $res = $this->mDb->getAll($sql);
        foreach ($res as $k => $v) {
            $temp[$v['name']] = $v['value'];
        }
        $temp['CurrenciesItem'] = $this->getAllCurrencies();
        $temp['country_id'] = $this->getCountryIdByDealerId($dealer_id);

        $temp['subscription_info'] = $dealerObj->getSubscriptionPeriod($dealer_id);
        $temp['subscription_info']['balance'] = $dealerObj->getBalanceSumByDealer($dealer_id);

        $temp['currency'] = $this->getCurrencyDefault($temp['country_id']);

        $temp['country_info'] = $this->getCountryById($temp['country_id']);

        return $temp;
    }

    public function getCountryById($id) {

        $sql = "SELECT p.id ,p.country_code ,p.image ,pl.pla_name as name,p.mobile_length,p.mobile_keys  FROM places p ";
        $sql .= " LEFT JOIN `place_langs` pl ON p.id = pl.place_id  AND pl.lang_code = 'ar' ";
        $sql .= " WHERE p.id ='{$id}' AND p.active = '1'  ";
        $res = $this->masterDb->getRow($sql);

        return $res ? $res : '';
        //  echo $sql;
        //   die();
    }

    public function getCurrencyDefault($country_id) {
        $sql = "SELECT pl.`currency` FROM `place_langs` pl ";
        $sql .= " LEFT JOIN `places` p ON pl.place_id = p.id  ";
        $sql .= " WHERE p.`id` ='{$country_id}' and pl.lang_code='ar'";
//     echo $sql."<hr>";
        $res = $this->masterDb->getOne($sql);
//        $ret = array();
//        for ($i = 0; $i < count($res); $i++) {
//            $ret[$res[$i]['lang_code']] = $res[$i]['currency'];
//        }
        return $res;
    }

    public function getCountryIdByDealerId($dealer_id) {
        $sql = "SELECT `country_id` FROM `{$this->mPrefix}master_dealers`  ";
        $sql .= " WHERE `id` ='{$dealer_id}' ";
//     echo $sql."<hr>";
        $res = $this->masterDb->getOne($sql);

        return $res;
    }

    function getGeneralSettingsRow($row) {
        $sql = "SELECT $row ";
        $sql .= "FROM `{$this->mPrefix}settings` ";
        $sql .= "WHERE `id`='1' ";

        return $this->mDb->getOne($sql);
    }

    function updateEditPriceExchange() {

        $sql = "UPDATE `{$this->mPrefix}products` SET ";
        $sql .= "`edit_price_exchange`='1' ";
        $sql .= "WHERE `edit_price_exchange`='0' ";

        return $this->mDb->query($sql);
    }

    function updateSettings($data) {
        $data['show_products_quantity_to_affilators'] = $data['show_products_quantity_to_affilators'] ? '1' : '0';

        foreach ($data as $k => $v) {
            if ($k != 'edit') {
                $sql = "UPDATE `{$this->mPrefix}settings` SET ";
                $sql .= "`value`='{$v}' ";
                $sql .= "WHERE `name`='{$k}' ";

                $res = $this->mDb->query($sql);
            }
        }
        if ($res) {
            foreach ($data['CurrenciesItem'] as $k_ => $v_) {
                $v_['default'] = $v_['default'] ? '1' : '0';
                if ($v_['id']) {
                    if ($v_['del'] == '0') {
                        $sql = "UPDATE `{$this->mPrefix}currencies` SET ";
                        $sql .= "`name_ar`='{$v_['name_ar']}' ";
                        $sql .= ",`name_en`='{$v_['name_en']}' ";
                        $sql .= ",`price`='{$v_['price']}' ";
                        $sql .= ",`default`='{$v_['default']}' ";
                        $sql .= "WHERE `id`='{$v_['id']}' ";
//                        echo $sql."<hr>";
                        $res = $this->mDb->query($sql);
                    } else {
                        $sql = "DELETE FROM `{$this->mPrefix}currencies` ";
                        $sql .= " WHERE  `id` = '{$v_['id']}' ";
//        echo $sql."<hr>";
                        $res = $this->mDb->query($sql);
                    }
                } else {
                    $sql = "INSERT INTO currencies   SET  ";
                    $sql .= "`name_ar`='{$v_['name_ar']}' ";
                    $sql .= ",`name_en`='{$v_['name_en']}' ";
                    $sql .= ",`price`='{$v_['price']}' ";
                    $sql .= ",`default`='{$v_['default']}' ";
                    $sql .= " ,`date_added` = '{$this->dateTime}'";
                    // echo $sql; die();
                    $res = $this->mDb->query($sql);
                }
            }
            return $this->updateEditPriceExchange();
//            unset($data['edit']);
//            return $this->saveConfig($data);
        }
    }

    public function getlastTypeIdFromByTableName($Req) {

        $sql = " SELECT  `{$Req['column_name']}` as last_item  ";
        $sql .= " FROM `{$this->mPrefix}{$Req['table_name']}` ";
        $sql .= " WHERE `{$Req['column_type']}`='{$Req['type_value']}' order by " . $Req['column_name'] . " DESC  Limit  1  ";
        // echo "<pre> ";
        // print_r($res);
        // die();
        $res = $this->mDb->getAll($sql);

        if ($res) {
            return $res[0]['last_item'];
        } else {
            return 900;
        }
    }

    public function getlastIdFromByTableName($Req) {

        $sql = " SELECT  `{$Req['column_name']}` ";
        $sql .= " FROM `{$this->mPrefix}{$Req['table_name']}` ";
        $sql .= "  order by " . $Req['column_name'] . " DESC  Limit  1  ";
        $res = $this->mDb->getOne($sql);

        if ($res) {
            return $res;
        } else {
            return 1000;
        }
    }

    function getAllCurrencies($aStart = '0', $aLimit = '0', $sort = 'id', $type = 'DESC', $searchName = '') {

        $sql = "SELECT * FROM currencies  ";
        $sql .= " ORDER BY  {$sort} {$type} ";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';

        // echo $sql; die();
        return $this->mDb->getAll($sql);
    }

    function getAllCountries($sort = 'id', $type = 'DESC', $searchName = '', $id = '', $page_name = '') {

        $sql = "SELECT p.id,p.country_code,pl.pla_name FROM places p  ";
        $sql .= " LEFT JOIN `place_langs` pl ON p.id = pl.place_id and pl.lang_code='ar' ";
        $sql .= " WHERE p.`country_id` = '0' ";
        $sql .= $id && $page_name != 'dealer' ? " and p.`id` = '{$id}' " : "";

        $sql .= " ORDER BY  {$sort} {$type} ";

        // echo $sql; die();
        return $this->masterDb->getAll($sql);
    }

    function getAllPaymentGateways($sort = 'id', $type = 'DESC') {
        $sql = "SELECT id,name FROM payment_gateways   ";
        $sql .= " ORDER BY  {$sort} {$type} ";
        // echo $sql; die();
        return $this->mDb->getAll($sql);
    }

    function getAllPlans($sort = 'id', $type = 'DESC', $searchName = '') {
        $sql = "SELECT id,name FROM master_dealers_plans    ";
        $sql .= " WHERE id >  '0' ";
        $sql .= " ORDER BY  {$sort} {$type} ";
        // echo $sql; die();
        return $this->mDb->getAll($sql);
    }

    function checkSecritKeyIsExist($key) {
        $sql = "SELECT secrit_key FROM api_secrit_keys where secrit_key ='{$key}'  ";
        // echo $sql; die();
        return $this->mDb->getOne($sql);
    }

    function insertSecritKey($key) {
        $sql = "INSERT INTO api_secrit_keys   SET secrit_key ='{$key}'   ";
        // echo $sql; die();
        return $this->mDb->query($sql);
    }

    // $is_exist = $settings->checkSecritKeyIsExist($apiSeritKey);
}
