<?php

$storeOpenCartsObj = new storeOpenCarts();

class StoreOpenCarts
{
    public $mDb;
    public $mConfig;
    public $dateTime;
    public $lang_code;
    public $userObj;

    public function __construct()
    {
        global $Config;
        $this->mDb = new iplus();
        $this->userObj = new Users(); // Make sure Users is capitalized if it's a class name
        $this->mConfig = $Config;
        $this->dateTime = date('Y-m-d H:i:s');
        $this->lang_code = LANGUAGE;
    }

    function getStoreOpenCarts($aStart, $aLimit, $sort, $type, $searchName) {

        $sql = "SELECT s.* ,sl.name, u.user_name AS 'addedBy' , cpg.name as price_type_name , cpg.key FROM store_open_carts s";
        $sql .= " LEFT JOIN `store_open_cart_langs` sl ON s.id = sl.store_open_cart_id ";
        $sql .= " LEFT JOIN `customer_price_groups`  cpg ON cpg.id = s.customer_price_id ";

        $sql .= " LEFT JOIN `users` u ON u.id = s.admin_id ";

        $sql .= " WHERE  s.`id` is not null and   sl.lang_code ='{$this->lang_code}'  ";

        $sql .= $searchName ? ' AND (sl.name like "%' . $searchName . '%" ||  s.url like "%' . $searchName . '%" ) ' : '';

        $sql .= $sort == 'name' ? " ORDER BY sl.{$sort} {$type} " : " ORDER BY s.{$sort} {$type} ";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';

        //   echo $sql; die();

        return $this->mDb->getAll($sql);
    }

    function getSearchStoreOpenCartsCount($sort, $type, $searchName) {
        $sql = "SELECT COUNT(DISTINCT s.`id`) as 'result_count' FROM store_open_carts s ";
        $sql .= " LEFT JOIN `store_open_cart_langs` sl ON s.id = sl.store_open_cart_id ";

        $sql .= " WHERE s.`id` is not null ";

        $sql .= $searchName ? ' AND ( sl.name like "%' . $searchName . '%" ||  s.url like "%' . $searchName . '%" ) ' : '';


        //echo $sql; die();

        return $this->mDb->getOne($sql);
    }

    function getStoreOpenCartsCount() {
        $sql = "SELECT COUNT(DISTINCT `id`) as 'count' FROM store_open_carts";
        return $this->mDb->getOne($sql);
    }

    function getlastOpenCartId() {
        $sql = "SELECT  id   FROM store_open_carts order By id desc";
        $res = $this->mDb->getAll($sql);

        return $res ? $res[0]['id'] + 1 : 1;
    }

    function addEditStoreOpenCart($temp) {
        $temp['sort'] = $temp['sort'] ? $temp['sort'] : '0';


        if ($temp['id'] === null || $temp['id'] === '') {

            $temp['id'] = $this->getlastOpenCartId();

            $sql = "INSERT INTO store_open_carts SET ";
            foreach ($this->mDb->getCols('store_open_carts', $temp) as $k => $v) {
                $sql .= ($k == 'lang_Details' || $k == 'lang_parameter') ? "" : "`{$k}`='{$v}',";
            }
            $sql .= " `date_added` = '{$this->dateTime}'";
            // echo "$sql";
            // die();
            $res = $this->mDb->query($sql);
            if ($res) {

                //enter lang_details
                foreach ($temp['lang_Details'] as $k => $v) {
                    $sql = " INSERT INTO `store_open_cart_langs` SET  lang_code = '{$v['lang_code']}'  , name = '{$v['details']['name']}'  , store_open_cart_id='{$temp['id']}' ";
                    // echo "$sql";die();
                    $this->mDb->query($sql);
                }
                $user['user_level'] = '3002'; //**VIP***
                $user['user_name'] = ' مدير متجر رقم ' . $temp['id'];
                $user['email'] = $temp['id'] . 'example@example.com';
                $user['mobile'] = '0100000000' . $temp['id'];
                $user['password'] = '147147';
                $user['admin_id'] = $temp['admin_id'];
                $user['active'] = true;
                $user['admin_cart_id'] = $temp['id'];
                // country_code: '02',
                $this->userObj->addEditUser($user);

                # code...
            }
            return $res;
        } else {


            $sql = "UPDATE store_open_carts SET ";
            foreach ($this->mDb->getCols('store_open_carts', $temp) as $k => $v) {
                $sql .= ($k == 'lang_Details' || $k == 'id' || $k == 'lang_parameter') ? "" : "`{$k}`='{$v}',";
            }
            $sql = substr($sql, 0, -1);
            $sql .= " WHERE `id` = '{$temp['id']}'";
            $res = $this->mDb->query($sql);
            if ($res) {

                //delete lang_details
                $sql = "DELETE FROM `store_open_cart_langs` ";
                $sql .= " WHERE store_open_cart_id='{$temp['id']}'  ";
                $this->mDb->query($sql);

                //enter lang_details
                foreach ($temp['lang_Details'] as $k => $v) {
                    $sql = " INSERT INTO `store_open_cart_langs` SET  lang_code = '{$v['lang_code']}' , name = '{$v['details']['name']}'   ,store_open_cart_id='{$temp['id']}' ";
                    // echo "$sql";die();
                    $this->mDb->query($sql);
                }

                # code...
            }

            return $res;
        }
    }

    function getOneStoreOpenCart($id) {
        $sql = "SELECT * FROM store_open_carts";
        $sql .= " WHERE `id` = '{$id}' ";
        $res = $this->mDb->getRow($sql);
        if ($res) {
            $sql = "SELECT lang_code ,name FROM `store_open_cart_langs`";
            $sql .= " WHERE `store_open_cart_id` = '{$id}' ";
            $res['lang_parameter'] = $this->mDb->getAll($sql);
        }
        // echo "<pre>";print_r($res);die();
        return $res;
    }

    function deleteStoreOpenCart($ids) {
        $sql = "DELETE FROM store_open_carts ";
        $sql .= " WHERE `id` = -1 ";
        foreach ($ids as $id) {
            $sql .= " || `id` = '{$id}' ";
            $sql2 = "DELETE FROM store_open_cart_langs ";
            $sql2 .= " WHERE `store_open_cart_id` = '{$id}' ";
            $this->mDb->query($sql2);

            $this->deleteAdminStoreOpen($id);
        }

        return $this->mDb->query($sql);
    }

    function deleteAdminStoreOpen($cart_id) {
        $sql = "DELETE FROM `users` ";
        $sql .= " WHERE admin_cart_id='{$cart_id}'  ";
        // echo $sql;
        // die();
        $this->mDb->query($sql);
    }

    /*
     * ***************************  Open Cart Functions  ****************************
     * *************************** *********************** **************************** 
     * *************************** ************************* ****************************  
     * *************************** *************************** **************************** 
     * *************************** ***************************** **************************** 
     */

    function getAllcustomer_price_groups($aStart, $aLimit, $sort, $type, $searchName, $key_ = '') {

        $sql = "SELECT * FROM customer_price_groups  ";
        $sql .= " WHERE  id > 0 ";
        $sql .= $key_ ? " AND  `key` = '{$key_}' " : " ";
        $sql .= $key_ ? " " : " ORDER BY   {$sort} {$type} ";

//        echo $sql . "<hr>";
        if ($key_) {
            return $this->mDb->getRow($sql);
        } else {
            return $this->mDb->getAll($sql);
        }

//        $sql .= " ORDER BY   {$sort} {$type} ";
//        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
        // echo $sql; die();
//        return $this->mDb->getAll($sql);
    }

    function getPiceTypeByStore_id($id) {



        $sql = "SELECT `customer_price_id` FROM store_open_carts where id='{$id}'  ";
        // echo $sql; die();
        $customer_price_id = $this->mDb->getOne($sql);


        $sql = "SELECT `key` FROM customer_price_groups where id='{$customer_price_id}'  ";
        // echo $sql; die();
        return $this->mDb->getOne($sql);
    }

}
