<?php

$supportAndBlogObj = new supportAndBlog();

class supportAndBlog {

    public $mDb;
    public $mConfig;
    public $dateTime;
    public $lang_code;

    public function __construct() {
        global $Config;

        $this->mDb = new iplus();
        $this->mConfig = $Config;
        $this->dateTime = date('Y-m-d H:i:s');
        $this->lang_code = LANGUAGE; // تأكد من أن LANGUAGE مُعرف
    }


    function getServicesByParams($aStart, $aLimit, $sort, $type, $searchName, $parent_id, $service_type, $affiliators_ids = array()) {


        $sql = "SELECT c.* , cl.name ,cl2.name as parentName, u.user_name AS 'addedBy' FROM support_and_blog_category c ";
        $sql .= " LEFT JOIN `users` u ON u.id = c.admin_id ";
        $sql .= " LEFT JOIN `support_and_blog_category_langs` cl ON c.id = cl.cat_id AND cl.lang_code = '{$this->lang_code}'";
        $sql .= " LEFT JOIN `support_and_blog_category_langs` cl2 ON c.parent = cl2.cat_id AND cl2.lang_code = '{$this->lang_code}' ";


        $sql .= " WHERE c.id > 0  ";


        $sql .= $searchName ? ' AND (cl.name like "%' . $searchName . '%" ) ' : '';
        $sql .= count($affiliators_ids) > 0 ? ' and ( c.affiliators_ids like "%,-1,%" ' : "";
        foreach ($affiliators_ids as $k => $v) {
            if ($v) {
                $sql .=' ||  (c.affiliators_ids like "%,' . $v . ',%" ) ';
            }
        }
        $sql .= count($affiliators_ids) > 0 ? ' ) ' : '';

        $sql .= ($parent_id === '0' || $parent_id) ? " AND c.parent = '{$parent_id}' " : ' ';
        $sql .= $service_type == 'subService' ? " AND c.parent > '0' " : '';
        $sql .= $service_type == 'mainService' ? " AND c.parent = '0' " : '';


        $sql .= " Group by c.id ORDER BY c.{$sort} {$type} ";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
        // echo LANGUAGE ;die();
//     echo $sql; 
//p($affiliators_ids);
        $res = $this->mDb->getAll($sql);

        return $res;
    }

    function getAllServicesList($aStart, $aLimit, $sort, $type, $searchName, $parent_id, $affiliators_ids) {


        $sql = "SELECT c.id , cl.name  FROM support_and_blog_category c ";
        $sql .= " LEFT JOIN `support_and_blog_category_langs` cl ON c.id = cl.cat_id AND cl.lang_code = '{$this->lang_code}'";
        $sql .= " WHERE c.active = '1'  ";
        $sql .= $searchName ? ' AND (cl.name like "%' . $searchName . '%" ) ' : '';
        $sql .= ' and ( c.affiliators_ids like "%,-1,%"  ';
        foreach ($affiliators_ids as $k => $v) {
            if ($v) {
                $sql .=' ||  (c.affiliators_ids like "%,' . $v . ',%" ) ';
            }
        }
        $sql .= ' ) ';

        $sql .= ($parent_id === '0' || $parent_id) ? " AND c.parent = '{$parent_id}' " : ' ';

        $sql .= " Group by c.id ORDER BY cl.{$sort} {$type} ";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
//   echo $sql."<hr>"; 
        $res = $this->mDb->getAll($sql);

        return $res;
    }

    function getAllServices($aStart, $aLimit, $sort, $type, $searchName, $parent_id, $service_type, $affiliators_ids) {


        $sql = "SELECT c.* , cl.name ,cl2.name as parentName, u.user_name AS 'addedBy' FROM support_and_blog_category c ";
        $sql .= " LEFT JOIN `users` u ON u.id = c.admin_id ";
        $sql .= " LEFT JOIN `support_and_blog_category_langs` cl ON c.id = cl.cat_id AND cl.lang_code = '{$this->lang_code}'";
        $sql .= " LEFT JOIN `support_and_blog_category_langs` cl2 ON c.parent = cl2.cat_id AND cl2.lang_code = '{$this->lang_code}' ";


        $sql .= " WHERE c.id > 0  ";


        $sql .= $searchName ? ' AND (cl.name like "%' . $searchName . '%" ) ' : '';
        $sql .= ' and ( c.affiliators_ids like "%,-1,%"  ';
        foreach ($affiliators_ids as $k => $v) {
            if ($v) {
                $sql .=' ||  (c.affiliators_ids like "%,' . $v . ',%" ) ';
            }
        }
        $sql .= ' ) ';

        $sql .= ($parent_id === '0' || $parent_id) ? " AND c.parent = '{$parent_id}' " : ' ';
        $sql .= $service_type == 'subService' ? " AND c.parent > '0' " : "";
        $sql .= $service_type == 'mainService' ? " AND c.parent = '0' " : "";


        $sql .= " Group by c.id ORDER BY c.{$sort} {$type} ";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
        // echo LANGUAGE ;die();
//     echo $sql; 
//p($affiliators_ids);
        $res = $this->mDb->getAll($sql);

        return $res;
    }

    function getCountOfProdByServiceId($id) {
        $sql = "SELECT count(id) FROM `products`";
        $sql .= " WHERE `service_id` = '{$id}' ";
        return $this->mDb->getOne($sql);
    }

    function cheackIfServieHaveSubService($id) {
        $sql = "SELECT count(id) FROM `services`";
        $sql .= " WHERE `parent` = '{$id}' ";
        $res = $this->mDb->getOne($sql) ? true : false;
        return $res;
    }

    function getSearchServicesCount(
    $sort, $type, $searchName, $parent_id, $service_type
    ) {



        $sql = "SELECT COUNT(DISTINCT c.id) as 'result_count' FROM support_and_blog_category c ";
        $sql .= " LEFT JOIN `support_and_blog_category_langs` cl ON c.id = cl.cat_id ";

        $sql .= " WHERE c.id > 0 AND cl.lang_code = '{$this->lang_code}' ";


        $sql .= $searchName ? ' AND (cl.name like "%' . $searchName . '%"  ) ' : '';
        $sql .= ($parent_id === '0' || $parent_id) ? " AND c.parent = '{$parent_id}' " : ' ';
        $sql .= $service_type == 'subService' ? " AND c.parent > '0' " : "";
        $sql .= $service_type == 'mainService' ? " AND c.parent = '0' " : "";

        // echo $sql; die();

        return $this->mDb->getOne($sql);
    }

    function addEditService($temp) {


        $temp['affiliators_ids'] = ',' . implode($temp['affiliators_ids'], ',') . ',';

        $temp['active'] = $temp['active'] ? '1' : '0';
        $temp['show_in_header'] = $temp['show_in_header'] ? '1' : '0';
        $temp['show_in_footer'] = $temp['show_in_footer'] ? '1' : '0';
        $temp['sort'] = $temp['sort'] ? $temp['sort'] : '0';

        $temp['parent'] = $temp['sub'] > '0' ? $temp['sub'] : $temp['parent'];


        if ($temp['id'] === null || $temp['id'] === '') {
            // add

            $sql = "INSERT INTO `support_and_blog_category` SET ";
            foreach ($this->mDb->getCols('support_and_blog_category', $temp) as $k => $v) {
                $sql .= ($k == 'lang_Details' || $k == 'img'|| $k == 'img_banner' || $k == 'lang_parameter') ? "" : "`{$k}`='{$v}',";
            }
            $sql .= " `date_added` = '{$this->dateTime}'";

            $sql .=$temp['img'] == '' ? " , `img` = null" : ", `img` = '{$temp['img']}' ";
            $sql .=$temp['img_banner'] == '' ? " , `img_banner` = null" : ", `img_banner` = '{$temp['img_banner']}' ";

//             echo "$sql";die();
            $res = $this->mDb->query($sql);
            if ($res) {
                $id = $this->mDb->getLastInsertId();
                //enter lang_details
                foreach ($temp['lang_Details'] as $k => $v) {
                    $sql = " INSERT INTO `support_and_blog_category_langs` SET  lang_code = '{$v['lang_code']}' , name = '{$v['details']['name']}', ser_description = '{$v['details']['ser_description']}' ,cat_id='{$id}' ";
                    $sql .= " ,`date_added` = '{$this->dateTime}'";
                    // echo "$sql";die();
                    $res2 = $this->mDb->query($sql);
                }
            }
            return $res;
        } else {


            // edit
            if ($temp['img'] == '') { //remove image if we removed
                $image = $this->getimg($temp['id']);
                $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . DEALERUPLOAD . '/support-and-blog/' . $image['img'];
//               echo $old_img."<hr>";
                if (file_exists($old_img)) {
                    @unlink($old_img);
                }
            }
            if ($temp['img_banner'] == '') { //remove image if we removed
                $image = $this->getimg($temp['id']);
                $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . DEALERUPLOAD . '/support-and-blog/' . $image['img_banner'];
//               echo $old_img."<hr>";
                if (file_exists($old_img)) {
                    @unlink($old_img);
                }
            }

            $sql = "UPDATE `support_and_blog_category` SET ";
            foreach ($this->mDb->getCols('support_and_blog_category', $temp) as $k => $v) {
                $sql .= ($k == 'lang_Details' || $k == 'img' || $k == 'img_banner'  || $k == 'id' || $k == 'lang_parameter') ? "" : "`{$k}`='{$v}',";
            }
            $sql = substr($sql, 0, -1);
            $sql .=$temp['img'] == '' ? " , `img` = null" : ", `img` = '{$temp['img']}' ";
            $sql .=$temp['img_banner'] == '' ? " , `img_banner` = null" : ", `img_banner` = '{$temp['img_banner']}' ";

            $sql .= " WHERE `id` = '{$temp['id']}'";
            $res = $this->mDb->query($sql);
            if ($res) {

                //delete lang_details
                $sql = "DELETE FROM `support_and_blog_category_langs` ";
                $sql .= " WHERE cat_id='{$temp['id']}'  ";
                $this->mDb->query($sql);


                //enter lang_details
                foreach ($temp['lang_Details'] as $k => $v) {
                    $sql = " INSERT INTO `support_and_blog_category_langs` SET  lang_code = '{$v['lang_code']}' , name = '{$v['details']['name']}', ser_description = '{$v['details']['ser_description']}'  ,cat_id='{$temp['id']}' ";
                    $sql .= ", `date_added` = '{$this->dateTime}'";
                    // echo "$sql";die();
                    $this->mDb->query($sql);
                }
                # code...
            }

            return $res;
        }
    }

    function getOneService($id) {
        $sql = "SELECT * FROM `support_and_blog_category`";
        $sql .= " WHERE `id` = '{$id}' ";
        $res = $this->mDb->getRow($sql);
        if ($res) {
            $res['parent_list'] = array_reverse($this->getBreadcrumb($res['id']));
            $sql = "SELECT lang_code ,name,ser_description FROM `support_and_blog_category_langs`";
            $sql .= " WHERE `cat_id` = '{$id}' ";
            $res['lang_parameter'] = $this->mDb->getAll($sql);
            $res['affiliators_ids'] = explode(",", substr($res['affiliators_ids'], 1, -1));
        }
        // echo "<pre>";print_r($res);die();  
        return $res;
    }

    function getBreadcrumb($aId) {

        $sql = "SELECT s.id,s.`parent` FROM `support_and_blog_category` s ";
        $sql .= "WHERE s.`id`='{$aId}'";
//        echo $sql."<hr>";
        $tier = $this->mDb->getRow($sql);

        if ($tier['id']) {

            $tree[] = $tier;
            $tier_arr = $this->getBreadcrumb($tier['parent']);
            if (is_array($tier_arr)) {
                $tree = array_merge($tree, $tier_arr);
            }
        }

        return $tree;
    }

    function getimg($id) {
        $sql = "SELECT `img`,`img_banner` FROM `support_and_blog_category`";
        $sql .= " WHERE `id` = '{$id}' ";
        return $this->mDb->getRow($sql);
    }

    function deleteservice($ids) {

        $sql = "DELETE FROM `support_and_blog_category` ";
        $sql .= " WHERE `id` = 0";
        foreach ($ids as $id) {


            $image = $this->getimg($id);
            $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . DEALERUPLOAD . '/support_and_blog_category/' . $image['img'];

            if (file_exists($old_img)) {
                @unlink($old_img);
            }
            $old_img_banner = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . DEALERUPLOAD . '/support_and_blog_category/' . $image['img_banner'];

            if (file_exists($old_img)) {
                @unlink($old_img);
            }
            $sql .= " || `id` = '{$id}' ";
        }
        // echo "$sql";die();

        $res = $this->mDb->query($sql);
        if ($res) {
            $sql2 = "DELETE FROM `support_and_blog_category_langs` ";
            $sql2 .= " WHERE `car_id` = '{$id}'";
            $this->mDb->query($sql2);
        }
        return $res;
    }

//    function getTreeCategories($sort, $type, $searchName, $parent_id, $withChaild = false, $id = '') {
//
//
//        $sql = "SELECT s.id , s.parent , s.key_word , s.ser_image , s.service_system_commission , sl.ser_name,sl.ser_description ,sl2.ser_name as parentName  FROM services s ";
//        $sql .= " LEFT JOIN `service_langs` sl ON s.id = sl.service_id  AND  sl.lang_code = '{$this->lang_code}' ";
//        $sql .= " LEFT JOIN `service_langs` sl2 ON s.parent = sl2.service_id   AND  sl2.lang_code = '{$this->lang_code}'";
//
//        $sql .= " LEFT JOIN `affiliator_services` af ON s.id = af.service_id   ";
//
//
//        $sql .= " WHERE s.id > 0 AND s.active = '1' ";
//        $sql .= $searchName ? ' AND (sl.ser_name like "%' . $searchName . '%" || s.key_word like "%' . $searchName . '%" )' : '';
//        $sql .= ($parent_id === '0' || $parent_id) ? " AND s.parent = '{$parent_id}' " : ' ';
//        $sql .= $id ? " AND  s.id = '{$id}' " : ' ';
//
//        $sql .= $sort == 'ser_name' ? " group by s.id  ORDER BY sl.{$sort} {$type} " : "  group by s.id  ORDER BY s.{$sort} {$type} ";
//        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
//        // echo LANGUAGE ;die();
////          echo $sql; die();
//        $res = $this->mDb->getAll($sql);
//        if ($res) {
//            for ($i = 0; $i < count($res); $i++) {
//                $res[$i]['haveSubService'] = $res[$i]['countOfProd'] == 0 ? $this->cheackIfServieHaveSubService($res[$i]['id']) : false;
//                if ($withChaild == true) {
//                    $res[$i]['subServices'] = $this->getTreeCategories( $sort, $type, '', $res[$i]['id'], false);
//                }
//            }
//        }
//
//        return $res;
//    }
//    function getAllCategories() {
//        $sql = "SELECT s.id , sl.ser_name  FROM services s ";
//        $sql .= " LEFT JOIN `service_langs` sl ON s.id = sl.service_id  AND  sl.lang_code = '{$this->lang_code}' ";
//        $sql .= " LEFT JOIN `affiliator_services` af ON s.id = af.service_id   ";
//        $sql .= " WHERE s.id > 0 AND s.active = '1' ";
//         $sql .= " Group by s.id    ";
////        echo $sql."<hr>";
//        $res = $this->mDb->getAll($sql);
//    
//        return $res;
//    }
}
