<?php

///////////////////////////////////////////////////////////////////////////////
/**
 * Filename: upload-class.php
 * Purpose: Upload FIles
 * Author: TRAIDNT
 * Developer : Ahmed Elsayed
 * Date: 10/11/2009
 */
///////////////////////////////////////////////////////////////////////////////


Class Upload {
    protected $_allowext;
    protected $_logoimages;
    protected $_thumbsimages;
    protected $_th_width;
    protected $_th_hight;
    protected $_nameprefix;
    protected $_maxsize;
    protected $_error;
    protected $_disallow_mime = array("text/html",
        "text/plain",
        "magnus-internal/shellcgi",
        "application/x-php",
        "text/php",
        "application/x-httpd-php",
        "application/php",
        "magnus-internal/shellcgi",
        "text/x-perl",
        "application/x-perl",
        "application/x-exe",
        "application/exe",
        "application/x-java",
        "application/java-byte-code",
        "application/x-java-class",
        "application/x-java-vm",
        "application/x-java-bean",
        "application/x-jinit-bean",
        "application/x-jinit-applet",
        "magnus-internal/shellcgi",
        "image/svg",
        "image/svg-xml",
        "image/svg+xml",
        "text/xml-svg",
        "image/vnd.adobe.svg+xml",
        "image/svg-xml",
        "text/xml",
    );
    protected $_fileinfo;
    protected $_logopath;
    private $_uploadfolder;
    public function __construct($allowext, $th_width, $th_hight, $maxsize, $uploadfolder, $thumbsimages) {
        $this->_allowext = $allowext;
        $this->_th_width = $th_width;
        $this->_th_hight = $th_hight;
        $this->_maxsize = $maxsize;
        $this->_error = array();
        $this->_fileinfo = array();
        $this->_uploadfolder = $uploadfolder;
        $this->_thumbsimages = $thumbsimages;
    }
    public function Upload_File($filearray, $maxsize = NULL) {
        if (is_array($filearray) OR ! is_null($filearray["type"]) OR ! is_null($filearray["name"]) OR ! is_null($filearray["tmp"]) OR ! is_null($filearray["size"])) {
            $filearray["uniqname"] = $this->uniqname();
            $filearray["newname"] = $this->_nameprefix . $filearray["uniqname"] . "." . $filearray["ext"];
            $filearray["place"] = $this->CurrentFullPath() . "/" . $this->_uploadfolder . "/";
            $filearray["nplace"] = $this->CurrentFullPath() . "/" . $this->_uploadfolder . "/" . $filearray["newname"];
            if ($this->is_img($filearray["ext"]) and $this->_thumbsimages == true) {
                $filearray["thplace"] = $this->CurrentFullPath() . "/" . $this->_uploadfolder . "/thumbs/" . $filearray["newname"];
            }
            $this->_fileinfo = $filearray;
            if (!$this->CheckExt($this->_fileinfo["ext"])) {
                $allowexts = '';
                foreach ($this->_allowext as $v) {
                    $allowexts .= $v . ',';
                }
                $allowexts = substr($allowexts, 0, -1);
                $this->return_error("إمتداد الملف غير مصرح به يرجى أستخدام أحد هذه الامتدادات فقط " . ' (' . $allowexts . ')');
            }

         
            if (!$this->CheckSize($this->_fileinfo["size"], $maxsize)) {
                $this->return_error("حجم الملف كبير , يجب ان يكون حجم الملف اقل من " . $maxsize . '  كيلو بايت  ');
            }
            if (!$this->hasErrors()) {
                $up = $this->move_uploaded($filearray["tmp"], $filearray["place"], $filearray["newname"]);
                if ($up) {
                    if ($this->_thumbsimages == true) {
                        $thumbs = $this->createthumb($filearray["place"] . $filearray["newname"], $filearray["ext"], $filearray["thplace"], $this->_th_width, $this->_th_hight);
                        if (!$thumbs) {
                            @unlink($this->_fileinfo["place"] . $this->_fileinfo["newname"]);
                            @unlink($this->_fileinfo["thplace"]);
                            $this->return_error("حدثت مشكلة أثناء إنشاء الصورة المصغرة , يرجى مراجعة الدعم الفنى الخاص بالاسكربت لتحديد سبب المشكلة ");
                            return(FALSE);
                        }
                    }
                    if ($this->_logoimages == TRUE and is_file($this->_logopath)) {
                        $this->printlogo($this->_fileinfo["place"] . $this->_fileinfo["newname"], $this->_fileinfo["ext"], $this->_logopath);
                    }

                    return($this->_fileinfo);
                } else {
                    $this->return_error("حدثت مشكلة أثناء رفع الملف ");
                    return(FALSE);
                }
            } else {
                return(FALSE);
            }
        } else {
            // if have error in function param
            return(FALSE);
        }
    }
    public function CheckExt($ext) {
        return in_array($ext, $this->_allowext);
    }
    public function CheckSize($filesieze, $maxsize = null) {
        return is_numeric($filesieze) && $filesieze <= $maxsize;
    }
    public function GetExt($filename) 
    {
        return pathinfo($filename, PATHINFO_EXTENSION);
    }
    public function uniqname() {
        return(substr(md5(uniqid(rand())), 0, 10));
    }
    public function showErrors() {
        if ($this->hasErrors()) {
            reset($this->_error);
            return($this->_error);
        }
    }
    public function is_img($ext) {
        $picarray = ["jpg", "gif", "png", "jpeg", "bmp", "jpeg", 'avif', 'webp'];
        return in_array($ext, $picarray, true);
    }

    private function CurrentFullPath() {
        $root = $_SERVER['DOCUMENT_ROOT'];
        return $root;
    }
    private function move_uploaded($tmp, $path, $name)
    {
        if (!is_null($tmp) && !is_null($path) && !is_null($name)) {
            if (is_dir($path) && is_writable($path)) {
                return move_uploaded_file($tmp, $path . $name);
            }
        }
        return false;
    }

    private function ExtDir($ext) {
        // if param ext is not null
        if (!is_null($ext)) {
            echo $this->_uploadfolder;
            // if upload folder is not exist create it
            if (!is_dir($this->_uploadfolder)) {
                $mkdir = @mkdir($this->_uploadfolder, 0777);
                if (!$mkdir) {
                    // return false if php can't create upload folder
                    return(FALSE);
                }
            } else {
                // if ext folder is not exist
                if (!is_dir($this->_uploadfolder)) {

                    // create ext folder
                    $mkdir = @mkdir($this->_uploadfolder, 0777);
                    // create the thumbs folder
                    $mkdir2 = @mkdir($this->_uploadfolder . "/thumbs", 0777);

                    // if php create folder
                    if ($mkdir AND $mkdir2) {
                        return(TRUE);
                    }
                    // if php can't create folder
                    else {
                        return(FALSE);
                    }
                } else {
                    // if ext folder is exist
                    return(TRUE);
                }
            }
        } else {
            // if param ext is null
            return(FALSE);
        }
    }
    public function printlogo($name, $ext, $logo) {

        if (!is_null($name) AND ! is_null($ext) AND ! is_null($logo) AND function_exists('gd_info')) {

            if (preg_match("/jpg|jpeg/", $ext)) {
                $src_img = imagecreatefromjpeg($name);

                if (!$src_img) {
                    return(FALSE);
                }
            }
            if (preg_match("/png/", $ext)) {
                $src_img = imagecreatefrompng($name);

                if (!$src_img) {
                    return(FALSE);
                }
            }

            if (preg_match("/gif/", $ext)) {
                $src_img = imagecreatefromgif($name);

                if (!$src_img) {
                    return(FALSE);
                }
            }

            $src_logo = imagecreatefrompng($logo);

            $bwidth = imageSX($src_img);
            $bheight = imageSY($src_img);
            $lwidth = imageSX($src_logo);
            $lheight = imageSY($src_logo);


            if ($bwidth > 160 && $bheight > 130) {

                $src_x = $bwidth - ($lwidth + 5);
                $src_y = $bheight - ($lheight + 5);
                ImageAlphaBlending($src_img, true);
                ImageCopy($src_img, $src_logo, $src_x, $src_y, 0, 0, $lwidth, $lheight);

                if (preg_match("/jpg|jpeg/", $ext)) {
                    imagejpeg($src_img, $name);
                }
                if (preg_match("/png/", $ext)) {
                    imagepng($src_img, $name);
                }
                if (preg_match("/gif/", $ext)) {
                    imagegif($src_img, $name);
                }
            } else {
                return(FALSE);
            }
        } else {
            return(FALSE);
        }
    }


    public function createthumb($file, $ext, $filename, $new_w, $new_h) {
        if (!is_null($file) && function_exists('gd_info')) {
            if (!file_exists($file)) {
                return false; // تأكد من وجود الصورة
            }

            $what = getimagesize($file);
            
            switch (strtolower($what['mime'])) {
                case 'image/png':
                    $img = imagecreatefrompng($file);
                    $outputFunction = 'imagepng';
                    break;
                case 'image/jpeg':
                    $img = imagecreatefromjpeg($file);
                    $outputFunction = 'imagejpeg';
                    break;
                case 'image/gif':
                    $img = imagecreatefromgif($file);
                    $outputFunction = 'imagegif';
                    break;
                case 'image/webp':
                    $img = @imagecreatefromwebp($file);
                    $outputFunction = 'imagejpeg'; 
                    break;
                default:
                    return false; 
            }

            $thumb_h = ($new_w / $what[0]) * $what[1];
            $dst_img = imagecreatetruecolor($new_w, $thumb_h);

            imagecopyresampled($dst_img, $img, 0, 0, 0, 0, $new_w, $thumb_h, $what[0], $what[1]);

            if (!empty($outputFunction)) {
                $outputFunction($dst_img, $filename);
            }

            imagedestroy($dst_img);
            imagedestroy($img);
            return true;
        }
        return false;
    }

    private function return_error($message) {
        return $this->_error[] = $message;
    }

    public function hasErrors() {
        if (count($this->error ?? []) > 0) {
            return true;
        } else {
            return false;
        }
    }

    public function __destruct() {
        $this->_allowext = NULL;
        $this->_logoimages = FALSE;
        $this->_th_width = NULL;
        $this->_th_hight = NULL;
        $this->_nameprefix = NULL;
        $this->_maxsize = NULL;
        $this->_error = NULL;
        $this->_fileinfo = NULL;
        $this->_disallow_mime = NULL;
        $this->_logopath = NULL;
        $this->_uploadfolder = NULL;
    }

}

?>