<?php

$productsObj = new Products();

class Products {

    public $mDb;
    public $mConfig;
    public $lang_code;
    public $dateTime;
    public $notifications;
    public $offersObj;
    public $date;

    public function __construct() {
        global $Config;
        global $notifyObj;
        global $offersObj;

        $this->mDb = new iplus();
        $this->notifications = $notifyObj;
        $this->offersObj = $offersObj;

        $this->mConfig = $Config;
        $this->dateTime = date('Y-m-d H:i:s');
        $this->date = date('Y-m-d');
        $this->lang_code = LANGUAGE;
    }

// public function getAllIdsOfProductHaveAmount()
// {
//     $sql = " SELECT p.id , sum(ps1.value) as sum_add  , sum(ps2.value  ) as sum_remove   FROM products  AS p   ";
//     $sql .= " LEFT JOIN product_stores AS ps1 ON p.id = ps1.product_id  and   ps1.type ='add'  ";
//     $sql .= " LEFT JOIN product_stores AS ps2 ON p.id = ps2.product_id  and   ps2.type ='remove' ";
//     $sql .= " GROUP BY p.id HAVING ( (sum_add - (sum_remove/ count(ps2.id) > 0)) || (sum_add > 0 AND sum_remove is null ))";
//       echo $sql ;die();
//     $res =  $this->mDb->getAll($sql);
//     return   fetchArrayValue_from_dataBase($res, 'id');
// }

    public function getIdsOfChidServiceIn($ids) {
        $array = getPlaceHolders($ids);
        $sql = "SELECT id 
                FROM services
                WHERE parent in  ({$array['placeholders']})";
        $stmt = $this->mDb->connect()->prepare($sql);
        foreach ($array['ids'] as $key => $id) {
            $stmt->bindValue(":id" . $key, trim($id), PDO::PARAM_INT);
        }
        $stmt->execute();
        $res = $stmt->fetchAll(PDO::FETCH_ASSOC);
        if ($res) {
            return fetchArrayValue_from_dataBase($res, 'id');
        }
    }

//    function getIdsOfChidServiceInId($ids) {
//        $sql = "SELECT parent FROM `services`";
//        $sql .= " WHERE `id` in  ({$ids})    ";
////        echo $sql."<hr>";
//        $res = $this->mDb->getAll($sql);
//
//        if ($res) {
//            return fetchArrayValue_from_dataBase($res, 'parent');
//        }
//    }
//    function getAllServiceTradeMarketAndAffilator($searchTrademark_id) {
//        $sql = "SELECT afs.service_id ,sl.ser_name   FROM `affiliator_services` afs ";
//        $sql .= " LEFT JOIN `services` s ON s.id = afs.service_id ";
//        $sql .= " LEFT JOIN `service_langs` sl ON sl.service_id = afs.service_id AND sl.lang_code = '{$this->lang_code}'  ";
//        $sql .= " LEFT JOIN `product_services` ps ON ps.service_id = afs.service_id ";
//        $sql .= " LEFT JOIN `products` p ON ps.product_id = p.id ";
//        $sql .= " WHERE afs.`user_id` = '" . AFFILIATOR['id'] . "' AND s.active = '1' ";
//        $sql .= $searchTrademark_id ? " AND p.trademark_id in ({$searchTrademark_id}) " : " ";
//        $sql .= " group by afs.service_id";
//        // echo $sql;
//        return $this->mDb->getAll($sql);
//    }


    function getAllServiceTradeMarketAndAffilatorIds($searchTrademark_id) {
        $sql = "SELECT s.id,s.parent  FROM `products` p ";
        $sql .= " LEFT JOIN `product_services` ps ON ps.product_id = p.id ";
        $sql .= " LEFT JOIN `services` s ON s.id = ps.service_id ";
        $sql .= " WHERE s.active = '1' ";
        $sql .= $searchTrademark_id ? " AND p.trademark_id in ({$searchTrademark_id}) " : " ";
        $sql .= " group by s.id";
//        echo $sql;
        $res = $this->mDb->getAll($sql);
        $ids = '';
        for ($i = 0; $i < count($res); $i++) {
            if ($res[$i]['parent']) {
                $ids = $ids ? $ids . ',' . $res[$i]['parent'] : $res[$i]['parent'];
            } else {
                $ids = $ids ? $ids . ',' . $res[$i]['id'] : $res[$i]['id'];
            }
        }
        return $ids;
    }

    function getAllServiceTradeMarketAndAffilator($searchTrademark_id) {
        $ids = $this->getAllServiceTradeMarketAndAffilatorIds($searchTrademark_id);
        if ($ids) {
            $sql = "SELECT service_id,ser_name  FROM `service_langs` ";
            $sql .= " WHERE service_id in ({$ids}) and lang_code = '{$this->lang_code}' ";
            $sql .= " group by service_id";
//            echo $sql;
            $res1 = $this->mDb->getAll($sql);
        }
        return $res1;
    }

    function getAllServiceInSearchCategoryId($ids) {

        if ($ids) {
            $sql = "SELECT sl.service_id,sl.ser_name  FROM `service_langs` sl ";
            $sql .= " LEFT JOIN `services` s ON s.id = sl.service_id ";
            $sql .= " WHERE s.parent ='0' and sl.service_id in ({$ids}) and sl.lang_code = '{$this->lang_code}' ";
            $sql .= " group by sl.service_id";
//            echo $sql;
            $res1 = $this->mDb->getAll($sql);
        }
        return $res1;
    }

    public function getAllIdsWithChidServiceToAffiliator() {
        $affiliator_id = AFFILIATOR['id'];
        $sql = "SELECT afs.service_id 
                FROM affiliator_services afs
                LEFT JOIN services s ON s.id = afs.service_id
                WHERE afs.user_id = :affiliator_id AND s.active = '1' ";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindValue(":affiliator_id", $affiliator_id, PDO::PARAM_INT);
        $stmt->execute();
        $main = $stmt->fetchAll(PDO::FETCH_ASSOC);
        $data['main'] = fetchArrayValue_from_dataBase($main, 'service_id');
        $data['sub'] = $this->getIdsOfChidServiceIn($data['main']);
        $all_ids = '';
        if ($data['main']) {
            $all_ids .= $data['main'];
        }
        if ($data['sub']) {
            $all_ids = $all_ids ? $all_ids . "," . $data['sub'] : $data['sub'];
        }
        return $all_ids;
    }

    function gethightPriceProduct($searchCategoryId, $searchTrademark_id) {

        if ($searchCategoryId) {
            $chidIds = $this->getIdsOfChidServiceIn($searchCategoryId);
            if ($chidIds) {
                $searchCategoryId .= ',' . $chidIds;
// p($searchCategoryId);
            }
        } else {
            $searchCategoryId = $this->getAllIdsWithChidServiceToAffiliator();
        }

        $sql = "SELECT MAX( p." . AFFILIATOR['price_type'] . ") as max  , MIN(p." . AFFILIATOR['price_type'] . ") as min FROM `products` p ";
        $sql .= " LEFT JOIN `product_services` ps ON ps.product_id = p.id ";
        $sql .= " WHERE ps.`service_id` in  ({$searchCategoryId})   ";
        $sql .= $searchTrademark_id ? " AND  p.`trademark_id` in  ({$searchTrademark_id})  " : ' ';
//       echo $sql."<hr>";
        $res = $this->mDb->getRow($sql);

        $res['max'] = round($res['max']);
        $res['min'] = round($res['min']);

// echo $sql;die();
        return $res;
    }

//    $sql = "select `p`.`id` AS `product_id`,`afs`.`user_id` AS `affiliator_id`,`psa`.`store_id` AS `store_id_add`,`psr`.`store_id` AS `store_id_remove`,`psa`.`name` AS `name_add`,`psr`.`name` AS `name_remove`,if(((`psa`.`store_id` = `psr`.`store_id`) and (`psa`.`name` = `psr`.`name`)),(coalesce(sum(`psa`.`value`),0) - coalesce(sum(`psr`.`value`),0)),coalesce(sum(`psa`.`value`),0)) AS `store_amounts`,`p`.`date_added` AS `date_added` from (((`souqalhi_affiliate_new`.`products` `p` left join `souqalhi_affiliate_new`.`product_stores` `psa` on(((`psa`.`product_id` = `p`.`id`) and (`psa`.`type` = 'add') and (`psa`.`is_deleted` = '0')))) left join `souqalhi_affiliate_new`.`product_stores` `psr` on(((`psr`.`product_id` = `p`.`id`) and (`psr`.`type` = 'remove') and (`psr`.`is_deleted` = '0') and (`p`.`active` = '1')))) left join `souqalhi_affiliate_new`.`affiliator_stores` `afs` on((`afs`.`store_id` = `psa`.`store_id`))) group by `product_id`,`affiliator_id`,`store_id_add`";

    public function getProductCount(
            $sort,
            $type,
            $searchKey,
            $searchDateFrom,
            $searchDateTo,
            $searchCategoryId,
            $searchProductStatus,
            $searchMerchant_id,
            $searchTrademark_id,
            $searchUserType,
            $searchStore_id,
            $searchMultiPrices,
            $prod_ids,
            $offer_id,
            $coupon_id,
            $filter_type,
            $form_shape = array(),
            $history = false,
            $mode = false,
            $searchMode = ''
    ) {
        $affiliator_stores = fetchArrayValue_from_dataBase(AFFILIATOR['stores'], 'id');
        if ($searchCategoryId) {
            $chidIds = $this->getIdsOfChidServiceIn($searchCategoryId);
            if ($chidIds) {
                $searchCategoryId .= ',' . $chidIds;
            }
        } else {
            $searchCategoryId = $this->getAllIdsWithChidServiceToAffiliator();
        }
        $searchStatusStock = $filter_type ? 'in_stock' : '';

        $data_count = $this->getSearchProductCount(
                $searchKey,
                $searchDateFrom,
                $searchDateTo,
                $searchCategoryId,
                $searchProductStatus,
                $searchMerchant_id,
                $searchTrademark_id,
                $searchUserType,
                $searchStore_id,
                $searchMultiPrices,
                $prod_ids,
                $offer_id,
                $searchStatusStock,
                $affiliator_stores,
                $prod_ids_string,
                $offer_filter,
                $filter_type,
                $offer_filter_all,
                $form_shape,
                $history,
                $mode,
                $sort,
                $type,
                $searchMode
        );
        return $data_count;
    }

    public function getProducts(
            $aStart,
            $aLimit,
            $sort,
            $type,
            $searchKey,
            $searchDateFrom,
            $searchDateTo,
            $searchCategoryId,
            $searchProductStatus,
            $searchMerchant_id,
            $searchTrademark_id,
            $searchUserType,
            $searchStore_id,
            $searchMultiPrices,
            $prod_ids,
            $offer_id,
            $coupon_id = '',
            $filter_type = '',
            $form_shape = array(),
            $history = false,
            $mode = '',
            $searchMode = ''
    ) {
        $client_id = CLIENT['id'] ?? 0;
        $affiliator_stores = fetchArrayValue_from_dataBase(AFFILIATOR['stores'], 'id');
        if (!$history) {
            $filter_type == 'offers' ? $offer_filter_all = $this->getAllPR_SR_TR() : '';
            $offer_id ? $offer_filter = $this->getPR_SR_TR_IDs($offer_id) : '';
            $coupon_id ? $coupon_filter = $this->getCoupon_PR_SR_TR_IDs($coupon_id) : '';

            if ($searchCategoryId) {
                $chidIds = $this->getIdsOfChidServiceIn($searchCategoryId);
                if ($chidIds) {
                    $searchCategoryId .= ',' . $chidIds;
                }
            } else {
                $searchCategoryId = $this->getAllIdsWithChidServiceToAffiliator();
            }
            if (count($prod_ids) > 0) {
                $prod_ids_string = implode(",", $prod_ids);
            }
            if (($filter_type || $searchKey || $searchCategoryId)) {

                $searchStatusStock = $filter_type ? 'in_stock' : '';

                $data_count = $this->getSearchProductCount(
                        $searchKey,
                        $searchDateFrom,
                        $searchDateTo,
                        $searchCategoryId,
                        $searchProductStatus,
                        $searchMerchant_id,
                        $searchTrademark_id,
                        $searchUserType,
                        $searchStore_id,
                        $searchMultiPrices,
                        $prod_ids,
                        $offer_id,
                        $searchStatusStock,
                        $affiliator_stores,
                        $prod_ids_string,
                        $offer_filter,
                        $filter_type,
                        $offer_filter_all,
                        $form_shape,
                        $history,
                        $mode,
                        $sort,
                        $type,
                        $searchMode
                );
                $out_of_product_ids = $data_count['out_of_product_ids'];
            }
        }
        $sql = "SELECT  
                    p.* , 
                    p." . AFFILIATOR['price_type'] . "  as price ,
                    ul.title as unit_title,
                    pl.meta_url  ,
                    pl.name as name  , 
                    pl.description as description,
                    pl.promotional_description,
                    pl.brief_description, 
                    tl.title as trademark_title , 
                    al.name as attachment_name , 
                    a.color as attachment_color, 
                    ap.price as affiliator_price ";
        if ($history) {
            $sql .= " ,bph.id as history_id, MAX(bph.date_added) as history_date_added";
        }

        if ($mode === 'best_seller') {
            $sql .= " ,tsp.top_selling ";
        }
        if ($searchKey && $searchMode == 'formshapes') {
            $sql .= " ,pfs.value as form_shape_id ";
        }

        $sql .= ",IFNULL(psa.store_amounts, 0) AS store_amounts, IFNULL(f.id, 0) as favorites_id  FROM `products` p";

        $versLang = $this->lang_code == 'ar' ? 'en' : 'ar';
        $sql .= " LEFT JOIN (";
        $sql .= " SELECT psa.product_id,SUM(psa.store_amounts) AS store_amounts,psa.store_id,psa.`expiration_date` FROM  product_stores_amounts psa ";
        $sql .= " LEFT JOIN `stores` s ON s.id = psa.store_id  ";
        $sql .= " WHERE   s.active = '1' and s.show_store_amounts='1' AND psa.store_id in  ({$affiliator_stores})  ";
        $sql .= "  GROUP BY  psa.product_id ";
        $sql .= " ) AS psa ON psa.product_id = p.id ";
        if ($mode === 'best_seller') {
            $sql .= " INNER JOIN `z_view_product_top_selling` tsp ON tsp.product_id = p.id  and tsp.product_id IS NOT NULL  ";
        }
        $sql .= " LEFT JOIN `product_services` ps ON ps.product_id = p.id ";
        $sql .= " LEFT JOIN `product_suggesstion_search_keys` pssk ON pssk.product_id = p.id ";

        $sql .= " LEFT JOIN `product_langs` pl ON pl.product_id = p.id  AND  pl.lang_code = '{$this->lang_code}' ";
        $sql .= " LEFT JOIN `product_langs` pl2 ON pl2.product_id = p.id  AND  pl2.lang_code = '{$versLang}' ";
        $sql .= " LEFT JOIN `attachments` a ON a.id = p.attachment_id  ";
        $sql .= " LEFT JOIN `attachment_langs` al ON al.attachment_id = p.attachment_id  AND  al.lang_code = '{$this->lang_code}' ";
        $sql .= " LEFT JOIN `trademark_langs` tl ON tl.trademark_id = p.trademark_id   AND  tl.lang_code = 'ar'  ";
        $sql .= " LEFT JOIN `unit_langs` ul ON ul.unit_id = p.unit_id  AND  ul.lang_code = 'ar'    ";
        $sql .= " LEFT JOIN `affiliator_prices` ap ON ap.product_id = p.id ";
        $sql .= " LEFT JOIN `favorites` f ON f.product_id = p.id and  f.`affiliator_id` = '" . AFFILIATOR['id'] . "'  AND f.`client_id` = $client_id ";

        for ($i = 0; $i < count($form_shape); $i++) {

            $sql .= " LEFT JOIN `product_form_shapes` pfs{$i} ON (pfs{$i}.product_id = p.id  )";
            $sql .= " INNER JOIN `form_shape_option_langs` fsol{$i} ON fsol{$i}.form_shape_option_id = pfs{$i}.value AND  fsol{$i}.lang_code = '{$this->lang_code}' ";
        }

        if ($searchKey && $searchMode == 'formshapes') {
            $sql .= " LEFT JOIN `product_form_shapes` pfs ON pfs.product_id = p.id ";
            $sql .= " INNER JOIN `form_shape_option_langs` fsol ON fsol.form_shape_option_id = pfs.value AND  fsol.lang_code = '{$this->lang_code}' and fsol.`label` !='' ";
        }
        if ($offer_filter["types"] == "tags" && $offer_filter["offer_tags_ids"]) {
            $sql .= " LEFT JOIN product_tags pt ON pt.product_id = p.id and pt.tag_id in ({$offer_filter["offer_tags_ids"]})
                     INNER JOIN tags t ON t.id = pt.tag_id and t.active = '1' ";
        }
        if ($offer_filter["types"] == "product_group" && $offer_filter["offer_product_group_ids"]) {
            $sql .= " LEFT JOIN products_groups pg ON pg.product_id = p.id and pg.group_id in ({$offer_filter["offer_product_group_ids"]})
                     INNER JOIN groups g ON g.id = pg.group_id and g.active = '1'
                     INNER JOIN groups_affiliate ga ON ga.group_id = g.id and ga.active = '1' AND ga.affiliator_id = " . AFFILIATOR['id'] . " ";
        }
        if ($history) {
            $sql .= " INNER JOIN `browse_product_history` bph ON bph.product_id = p.id ";
        }
        $sql .= " WHERE p.id >  0 AND psa.store_id in  ({$affiliator_stores}) and p.active " . search_active('!=0');

        if ($history) {
            $sql .= " and   bph.`affiliator_id` = '" . AFFILIATOR['id'] . "'  and bph.`client_id` = $client_id ";
        }

        if ($mode == 'is_back_from_new') {
            $sql .= " and   psa.store_amounts > '0' and p.new_store_amounts_date_added IS NOT NULL ";
        }
        //$filter_type
        $sql .= $filter_type && $out_of_product_ids ? " AND p.id  not in  ({$out_of_product_ids})  " : " ";
        $sql .= $filter_type == 'discounts' && AFFILIATOR['price_type'] == 'price_multi' ? " AND p.last_price_multi >'0' " : " ";
        $sql .= $filter_type == 'discounts' && AFFILIATOR['price_type'] == 'price_one' ? " AND p.last_price_one >'0' " : " ";
        $sql .= $filter_type == 'soon' ? " AND  p." . AFFILIATOR['price_type'] . " = 0 " : " ";

        $sql .= $prod_ids_string ? " AND p.id in  ({$prod_ids_string})  " : " ";
        $sql .= $searchKey && $searchMode == 'key_words' ? ' AND (   ' . search_word_in_column('p.`key_words`', ',' . $searchKey . ',') . ')' : " ";
        $sql .= $searchKey && $searchMode == 'suggesstion' ? ' AND (  ' . search_word_in_column('pssk.`suggesstion`', $searchKey) . ')' : " ";
        $sql .= $searchKey && $searchMode == 'formshapes' ? ' AND (  ' . search_word_in_column('fsol.`label`', $searchKey) . ')' : " ";
        $sql .= $searchKey && $searchMode == '' ? ' AND ( ' . search_word_in_column('p.`product_code`', $searchKey) . ' OR ' . search_word_in_column('p.`product_barcode`', $searchKey) . ' OR ' . search_word_in_column('pl.`name`', $searchKey) . ' OR ' . search_word_in_column('pl2.`name`', $searchKey) . ' OR ' . search_word_in_column('p.`key_words`', ',' . $searchKey . ',') . ' OR ' . search_word_in_column('pssk.`suggesstion`', $searchKey) . ')' : " ";

        $sql .= $searchDateFrom ? " AND p.`date_added`   >= '{$searchDateFrom}' " : "";
        $sql .= $searchDateTo ? " AND p.`date_added`  <= '{$searchDateTo}' " : "";
        $sql .= $searchCategoryId ? " AND ps.`service_id` in  ({$searchCategoryId})  " : "";
        $sql .= $searchProductStatus === '0' || $searchProductStatus ? " AND p.`active` " . search_active($searchProductStatus) : "";

        $sql .= $searchMerchant_id ? " AND p.`merchant_id` =  '{$searchMerchant_id}'  " : "";
        $sql .= $searchTrademark_id ? " AND p.`trademark_id` IN({$searchTrademark_id})  " : "";
        $sql .= count($searchMultiPrices) > 0 ? " AND ( " : '';
        for ($i = 0; $i < count($searchMultiPrices); $i++) {
            $sql .= $i == 0 ? "  " : " || ";
            $sql .= "  (  p." . AFFILIATOR['price_type'] . " >= '{$searchMultiPrices[$i]['from']}' AND p." . AFFILIATOR['price_type'] . "   <= '{$searchMultiPrices[$i]['to']}'  )";
        }
        $sql .= count($searchMultiPrices) > 0 ? " ) " : '';
        if ($offer_filter["types"] == "products" && $offer_filter["offer_products_ids"]) {
            $sql .= " AND p.id in ({$offer_filter["offer_products_ids"]}) ";
        }
        if ($offer_filter["types"] == "services" && $offer_filter["offer_services_ids"]) {
            $sql .= " AND ps.service_id in ({$offer_filter["offer_services_ids"]}) ";
        }
        if ($offer_filter["types"] == "trademarks" && $offer_filter["offer_trademarks_ids"]) {
            $sql .= " AND p.trademark_id in ({$offer_filter["offer_trademarks_ids"]}) ";
        }
        if ($offer_filter["types"] == "tags" && $offer_filter["offer_tags_ids"]) {
            $sql .= " AND pt.tag_id in ({$offer_filter["offer_tags_ids"]}) ";
        }
        if ($offer_filter["types"] == "product_group" && $offer_filter["offer_product_group_ids"]) {
            $sql .= " AND pg.group_id in ({$offer_filter["offer_product_group_ids"]}) ";
        }        //coupon_filter 
        $sql .= $coupon_filter["types"] == "products" && $coupon_filter["coupon_products_ids"] ? " AND p.id   in  ({$coupon_filter["coupon_products_ids"]})  " : " ";

        $sql .= $coupon_filter["types"] == "services" && $coupon_filter["coupon_services_ids"] ? " AND ps.service_id   in  ({$coupon_filter["coupon_services_ids"]})  " : " ";

        $sql .= $coupon_filter["types"] == "trademarks" && $coupon_filter["coupon_trademarks_ids"] ? " AND p.trademark_id    in  ({$coupon_filter["coupon_trademarks_ids"]})  " : " ";

        //VIP dont touch
        $sql .= "AND(";
        $sql .= $offer_filter_all["products"] && $offer_filter_all["offer_products_ids"] ? "  p.id in  ({$offer_filter_all["offer_products_ids"]})  ||" : "";
        $sql .= $offer_filter_all["services"] && $offer_filter_all["offer_services_ids"] ? "  ps.service_id   in  ({$offer_filter_all["offer_services_ids"]})  ||" : "";
        $sql .= $offer_filter_all["trademarks"] && $offer_filter_all["offer_trademarks_ids"] ? "  p.trademark_id    in  ({$offer_filter_all["offer_trademarks_ids"]}) ----" : "";
        $sql = substr($sql, 0, -4);
        $sql .= ($offer_filter_all["products"] && $offer_filter_all["offer_products_ids"]) ||
                ($offer_filter_all["services"] && $offer_filter_all["offer_services_ids"]) ||
                ($offer_filter_all["trademarks"] && $offer_filter_all["offer_trademarks_ids"]) ? " ) " : ' ';
        $sql .= count($form_shape) > 0 ? " AND ( " : '';
        for ($i = 0; $i < count($form_shape); $i++) {
            $sql .= $i == 0 ? "  " : " and ";
            $sql .= "  (  pfs{$i}.form_shape_id  = '{$form_shape[$i]['key']}' AND pfs{$i}.value  in ({$form_shape[$i]['value']}) )";
        }
        $sql .= count($form_shape) > 0 ? " ) " : '';

        if (!$history) {
            $sql .= " group by  p.id";
            $sql .= $sort == 'price' ? "  ORDER BY p." . AFFILIATOR['price_type'] . " {$type} " : "  ORDER BY  {$sort} {$type} ";
        } else {
            $sql .= " group by bph.product_id";
            $sql .= "  ORDER BY  history_date_added DESC ";
        }
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
        $res = $this->mDb->getAll($sql);
        if ($res) {
            $allProductCart = $this->getProductsCartClient();
            for ($i = 0; $i < count($res); $i++) {
                $res[$i]['active'] = activeFormat($res[$i]['active']);
                $inCart = $this->searchForColumn($res[$i]['id'], $allProductCart, 'product_id');

                if ($inCart != null) {
                    $res[$i]['quantity_in_cart'] = $inCart['quantity'];
                } else {
                    $res[$i]['quantity_in_cart'] = '0';
                }


                if (strip_tags($res[$i]['description'])) {
                    $breaks = array("<br />", "<br>", "<br/>", "</p>", "</div>");
                    $res[$i]['description_strip_tags'] = str_replace($breaks, " \r\n ", $res[$i]['description']);
                    $res[$i]['description_strip_tags'] = strip_tags($res[$i]['description_strip_tags']);
                } else {
                    $res[$i]['description_strip_tags'] = '';
                }
                if (strip_tags($res[$i]['promotional_description'])) {
                    $breaks = array("<br />", "<br>", "<br/>", "</p>", "</div>");

                    $res[$i]['promotional_description_strip_tags'] = str_replace($breaks, " \r\n ", $res[$i]['promotional_description']);
                    $res[$i]['promotional_description_strip_tags'] = str_replace("&nbsp;", "  ", $res[$i]['promotional_description_strip_tags']);
                    $res[$i]['promotional_description_strip_tags'] = strip_tags($res[$i]['promotional_description_strip_tags']);
                } else {
                    $res[$i]['promotional_description_strip_tags'] = '';
                }
                if (strip_tags($res[$i]['brief_description'])) {
                    $breaks = array("<br />", "<br>", "<br/>", "</p>", "</div>");
                    $res[$i]['brief_description_strip_tags'] = str_replace($breaks, " \r\n ", $res[$i]['brief_description']);
                    $res[$i]['brief_description_strip_tags'] = str_replace("&nbsp;", "  ", $res[$i]['brief_description_strip_tags']);
                    $res[$i]['brief_description_strip_tags'] = strip_tags($res[$i]['brief_description_strip_tags']);
                } else {
                    $res[$i]['brief_description_strip_tags'] = '';
                }

                $res[$i]['description'] = nl2br($res[$i]['description']);
                $res[$i]['promotional_description'] = nl2br($res[$i]['promotional_description']);
                $res[$i]['brief_description'] = nl2br($res[$i]['brief_description']);

                $res[$i]['added_listiner_available'] = $this->checkUserHaveListenToProductAvailability($res[$i]['id']) ? true : false;
                $res[$i]['store_amounts'] = intval($res[$i]['store_amounts']) > 0 ? intval($res[$i]['store_amounts']) : 0;
                $res[$i]['stores'] = $this->getProductStores($res[$i]['id'], true);

                $res[$i]['product_services'] = $this->getProduct_services($res[$i]['id']);
                $res[$i]['ser_name'] = fetchArrayValue_from_dataBase($res[$i]['product_services'], 'ser_name');
                $trademark = $this->getTrademarkData($res[$i]['trademark_id']);
                $res[$i]['trademark_image'] = $trademark['image'];
                $res[$i]['trademark_title'] = $trademark['title'];

                $res[$i]['last_price'] = null;
                if (AFFILIATOR['price_type'] == 'price' && $res[$i]['affiliator_price'] > 0) {
                    $res[$i]['price'] = $res[$i]['affiliator_price'];
                }
                $res[$i]['affiliator_commission'] = $res[$i]['affiliator_price'] ? $res[$i]['price'] - $res[$i]['price_multi'] : $res[$i]['commission'];

                if (AFFILIATOR['price_type'] == 'price_one' && $res[$i]['last_price_one'] > '0') {
                    $res[$i]['last_price'] = $res[$i]['price_one'];
                    $res[$i]['price_one'] = $res[$i]['last_price_one'];
                }
                if (AFFILIATOR['price_type'] == 'price_multi' && $res[$i]['last_price_multi'] > '0') {
                    $res[$i]['last_price'] = $res[$i]['price_multi'];
                    $res[$i]['price_multi'] = $res[$i]['last_price_multi'];
                }

                if ($res[$i]['last_price_multi'] > '0') {
                    $price_multi_last = $res[$i]['price_multi'];
                    $res[$i]['price_multi'] = $res[$i]['last_price_multi'];
                    $res[$i]['last_price_multi'] = $price_multi_last;
                }

                if ($res[$i]['api_id_to'] && $res[$i]['api_id_to'] != '0') {
                    if ($res[$i]['last_price_one'] > '0') {
                        $res[$i]['last_price'] = $res[$i]['price_one'];
                        $res[$i]['price_one'] = $res[$i]['last_price_one'];
                    }

                    $res[$i]['price'] = $res[$i]['price_one'];
                } else {
                    $res[$i]['price'] = $res[$i][AFFILIATOR['price_type']];
                }



                $res[$i]['product_group_data'] = $this->GetGroupData($res[$i]['id']);
                $res[$i]['product_tags'] = $this->getProductTags($res[$i]['id']);
                $res[$i]['images'] = $this->getProductimgs($res[$i]['id']);
                $res[$i]['image'] = $res[$i]['images'][0]['name'];
                $res[$i]['original_image'] = $res[$i]['images'][0]['original_name'];
                $res[$i]['offer_id'] = $this->getProduct_offer(
                        $res[$i]['id'],
                        $res[$i]['trademark_id'],
                        $res[$i]['product_services'],
                        $res[$i]['product_group_data']['id'],
                        $res[$i]['product_tags']
                );
                if ($res[$i]['offer_id']) {
                    $res[$i]['offer_data'] = $this->offersObj->getOneOffer($res[$i]['offer_id'], 'trim_attachment_single');
                    $res[$i]['offer_data'] = $res[$i]['offer_data'] ? $res[$i]['offer_data'] : null;
                } else {
                    $res[$i]['offer_data'] = null;
                }

                $res[$i]['coupon_id'] = $this->getProduct_coupon(
                        $res[$i]['id'],
                        $res[$i]['trademark_id'],
                        $res[$i]['product_services'],
                        "",
                        $res[$i]['product_group_data']['id'],
                        $res[$i]['product_tags']
                );
                if ($res[$i]['coupon_id']) {
                    $res[$i]['coupon_data'] = $this->offersObj->getOneCoupon($res[$i]['coupon_id']);
                    $res[$i]['coupon_data'] = $res[$i]['coupon_data'] ? $res[$i]['coupon_data'] : null;
                } else {
                    $res[$i]['coupon_data'] = null;
                }

                $res[$i]['meta_url'] = (trim($res[$i]['meta_url']) ? processTitle($res[$i]['meta_url']) : processTitle($res[$i]['name']));
                if ($res[$i]['store_amounts'] > 0 && $res[$i]['price'] > 0) {
                    $res[$i]['count_quantity_discount'] = $this->getCountProductQuantityDiscount($res[$i]['id']);
                }

                $res[$i]['count_products_related'] = $this->getCountProductsRelated($res[$i]['id']);
            }
        }

        $ret['products'] = $res;
        $ret['total_count'] = $data_count['total_count'] ? $data_count['total_count'] : 0;
        $ret['all_category_ids_for_searching_products'] = $data_count['all_category_ids_for_searching_products'] ? $data_count['all_category_ids_for_searching_products'] : '';
        $ret['out_of_product_ids'] = $out_of_product_ids;

        return $ret;
    }

    function getBreadcrumbFormShape($searchKey = '', $form_shape_id = '') {
        $tree = [];
        $sql = '';

        if ($searchKey != '') {
            $sql = "SELECT fsol.id, fsol.label, fso.form_shape_id 
                FROM `form_shape_option_langs` fsol 
                LEFT JOIN `form_shape_options` fso ON fso.id = fsol.form_shape_option_id 
                WHERE fsol.id > 0 AND (" . search_word_in_column('fsol.`label`', $searchKey) . ")";
        } elseif ($form_shape_id != '') {
            $sql = "SELECT fsl.id, fsl.label 
                FROM `form_shape_langs` fsl 
                WHERE fsl.id > 0 AND fsl.lang_code = '{$this->lang_code}' AND fsl.form_shape_id = '{$form_shape_id}'";
        }

        if (!empty($sql)) {
            $tier = $this->mDb->getRow($sql);
            if ($tier && isset($tier['id'])) {
                $tree[] = $tier;
                if ($searchKey != '') {
                    $tree = array_merge($tree, $this->getBreadcrumbFormShape('', $tier['form_shape_id']));
                }
            }
        }

        return $tree;
    }

//    function getBreadcrumbFormShapeBySearchKey($searchKey = '') {
//
//        $sql = "SELECT fsol.id, fsol.label ,fso.form_shape_id FROM `form_shape_option_langs` fsol ";
//        $sql .= " LEFT JOIN `form_shape_options` fso ON fso.id = fsol.form_shape_option_id ";
//        $sql .= "WHERE  fsol.id> 0  ";
//        $sql .= ' AND (  ' . search_word_in_column('fsol.`label`', $searchKey) . ')';
////        echo $sql."<hr>";
//        $tier = $this->mDb->getRow($sql);
//
//        if ($tier['id']) {
//
//            $tree[] = $tier;
//            $tier_arr = $this->getBreadcrumbFormShapeByformShapeId($tier['form_shape_id']);
//            if (is_array($tier_arr)) {
//                $tree = array_merge($tree, $tier_arr);
//            }
//        }
//
//        return $tree;
//    }
//
//    function getBreadcrumbFormShapeByformShapeId($form_shape_id = '') {
//
//        $sql = "SELECT fsl.id, fsl.label  FROM `form_shape_langs` fsl ";
//        $sql .= "WHERE  fsl.id> 0 AND  fsl.lang_code = '{$this->lang_code}' AND  fsl.form_shape_id = '{$form_shape_id}'";
//
////        echo $sql."<hr>";
//        $tier = $this->mDb->getRow($sql);
//
//
//        return [$tier];
//    }

    public function getProductsCartClient() {
        $client_id = CLIENT['id'] ?? 0;
        $device_id = DEVICEID ? DEVICEID : '0';
        $affiliator_id = AFFILIATOR['id'];
        $sql = "SELECT 
                    cp.cart_id ,
                    cp.product_id,
                    cp.quantity ,
                    cp.product_type_name,
                    cp.offer_id  
                FROM carts c
                LEFT JOIN cart_products cp ON (c.id = cp.cart_id and cp.is_deleted='0')
                WHERE c.user_id = :affiliator_id ";
        if ($client_id) {
            $sql .= " AND  c.client_id = :client_id ";
        } else {
            $sql .= " AND  c.device_id = :device_id AND c.client_id = '0' ";
        }
        $sql .= " AND (c.type='packing_in_progress' || c.type='editing_in_progress')";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':affiliator_id', $affiliator_id, PDO::PARAM_INT);
        if ($client_id) {
            $stmt->bindParam(':client_id', $client_id, PDO::PARAM_INT);
        } else {
            $stmt->bindParam(':device_id', $device_id, PDO::PARAM_STR);
        }
        $stmt->execute();
        return $stmt->fetchAll(PDO::FETCH_ASSOC);
    }

    public function getProductsCartDevice() {
        $device_id = DEVICEID ? DEVICEID : '0';
        $sql = "SELECT `cp`.cart_id ,cp.product_id,cp.quantity ,cp.product_type_name,cp.offer_id  FROM `carts` c ";
        $sql .= " LEFT JOIN `cart_products` cp ON (c.id = cp.cart_id and cp.is_deleted='0')";
        $sql .= " WHERE `c`.user_id = " . AFFILIATOR['id'] . "  ";
        $sql .= " and  `c`.device_id ='{$device_id}' and  `c`.client_id = '0' ";

        $sql .= " and (c.type='packing_in_progress' || c.type='editing_in_progress')";
//          echo $sql."<hr>";
        $res = $this->mDb->getAll($sql);
// echo "<pre>";print_r($sql);die();
        return $res;
    }

    public function UpdateCartDevice() {
        $device_id = DEVICEID ? DEVICEID : '0';
        $sql = " UPDATE `carts` SET `client_id` = " . CLIENT['id'] . " ";
        $sql .= " WHERE `client_id` = '0' and `device_id` = '{$device_id}' ";
//         echo $sql."<hr>";
        return $this->mDb->query($sql);
    }

    function getProductsGroups($aStart, $aLimit, $sort, $type) {

        $now = date('Y-m-d');
        $sql = "SELECT  od.offer_id,o.offer_type,ol.title,od.value,od.maximum_discount_value,od.ids,od.offer_application_type,od.minimum_value_offer_application FROM `offers` o";
        $sql .= " LEFT JOIN `offer_langs` ol ON o.id = ol.offer_id and ol.lang_code='{$this->lang_code}' ";
        $sql .= " LEFT JOIN `offer_discount` od ON o.id = od.offer_id  ";
        $sql .= " WHERE o.active ='1' and o.package ='1'  and od.apply_type_conditions='products' ";
        $sql .= " and `o`.affiliator_id = " . AFFILIATOR['id'] . "  ";
        $sql .= " AND (o.`offer_start_date` <= '{$now}' ||  o.`offer_start_date` is Null    )  ";
        $sql .= " AND (o.`offer_end_date` >= '{$now}'  ||  o.`offer_end_date` is Null     )";
        $sql .= " ORDER BY  {$sort} {$type} ";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
//        echo $sql."<hr>";
        $res = $this->mDb->getAll($sql);
        if ($res) {
            for ($i = 0; $i < count($res); $i++) {
                global $offersObj;
                $res[$i]['products'] = $offersObj->getAllProductsInPackage('0' . $res[$i]['ids'] . '0');
//            echo count($data['products'])."<hr>";
                if (count($res[$i]['products']) > 0) {
                    for ($p = 0; $p < count($res[$i]['products']); $p++) {
                        $res[$i]['total_price'] += +$res[$i]['products'][$p]['price'];
                    }
                    if ($res[$i]['total_price'] > 0) {
                        $res[$i]['total_price'] = number_format($res[$i]['total_price'], 2, '.', '');
                        if ($res[$i]['offer_type'] == 'discount_constant') {
                            $res[$i]['discount'] = number_format($res[$i]['value'], 2, '.', '');
                        } else if ($res[$i]['offer_type'] == 'discount_percentage') {
                            $res[$i]['discount'] = number_format((+$res[$i]['total_price'] * +$res[$i]['value'] / 100), 2, '.', '');
                            if (($res[$i]['discount'] > $res[$i]['maximum_discount_value']) && $res[$i]['maximum_discount_value'] > 0) {
                                $res[$i]['discount'] = number_format($res[$i]['maximum_discount_value'], 2, '.', '');
                            }
                        }
                    }
//                
                }
            }
        }
        return $res ? $res : null;
    }

    function searchForColumn($id, $array, $column) {
        foreach ($array as $key => $val) {
            if ($val[$column] === $id) {
                return $val;
            }
        }
        return null;
    }

// public function getRootOfSerivce($id)
// {
//     $sql = "SELECT parent FROM services  ";
//     $sql .= " WHERE `service_id` = '{$id}'  ";
//     $res =  $this->mDb->getOne($sql);
//     return $res > 0  ? $res  :  $id;
// }
// public function getSpecifications($id)
// {
//     $sql = "SELECT name ,value FROM service_specifications  ";
//     $sql .= " WHERE `service_id` = '{$id}'  ";
//     ///    echo $sql ;die();
//     return $this->mDb->getAll($sql);
// }


    public function getSearchProductCount(
            $searchKey, $searchDateFrom, $searchDateTo, $searchCategoryId, $searchProductStatus, $searchMerchant_id, $searchTrademark_id, $searchUserType, $searchStore_id, $searchMultiPrices, $prod_ids, $offer_id, $searchStatusStock, $affiliator_stores, $prod_ids_string, $offer_filter, $filter_type = '', $offer_filter_all = '', $form_shape = array(), $history = false, $mode = '', $sort = 'id', $type = 'DESC', $searchMode = ''
    ) {

        $affiliator_stores = fetchArrayValue_from_dataBase(AFFILIATOR['stores'], 'id');

// echo
// p($form_shape);
        $sql = "SELECT DISTINCT p.*  , p." . AFFILIATOR['price_type'] . "  as price , ap.price as affiliator_price ";
        if ($history) {
            $sql .= " ,bph.id as history_id, MAX(bph.date_added) as history_date_added";
        }

        if ($mode === 'best_seller') {
            $sql .= " ,tsp.top_selling ";
        }
        $sql .= ",psav.store_amounts  as store_amounts FROM `products` p";

//   sl.ser_name   ******************************************
        $sql .= " LEFT JOIN `z_view_product_store_amounts` psav ON psav.product_id = p.id ";
        if ($mode === 'best_seller') {
            $sql .= " LEFT JOIN `z_view_product_top_selling` tsp ON tsp.product_id = p.id  and tsp.product_id IS NOT NULL  ";
        }
        $sql .= " LEFT JOIN `product_services` ps ON ps.product_id = p.id ";

//        $sql .= " LEFT JOIN `product_stores` pst ON pst.product_id = p.id ";
        $sql .= " LEFT JOIN `product_suggesstion_search_keys` pssk ON pssk.product_id = p.id ";
        $versLang = $this->lang_code == 'ar' ? 'en' : 'ar';
        $sql .= " LEFT JOIN `product_langs` pl2 ON pl2.product_id = p.id  AND  pl2.lang_code = '{$versLang}' ";
        $sql .= " LEFT JOIN `product_langs` pl ON pl.product_id = p.id  AND  pl.lang_code = '{$this->lang_code}' ";
        $sql .= " LEFT JOIN `attachment_langs` al ON al.attachment_id = p.attachment_id  AND  pl.lang_code = '{$this->lang_code}' ";

        $sql .= " LEFT JOIN `trademark_langs` tl ON tl.trademark_id = p.trademark_id   AND  tl.lang_code = 'ar'  ";
        $sql .= " LEFT JOIN `unit_langs` ul ON ul.unit_id = p.unit_id  AND  ul.lang_code = 'ar'    ";

        $sql .= " LEFT JOIN `affiliator_prices` ap ON ap.product_id = p.id ";

        for ($i = 0; $i < count($form_shape); $i++) {

            $sql .= " LEFT JOIN `product_form_shapes` pfs{$i} ON (pfs{$i}.product_id = p.id  )";
            $sql .= " INNER JOIN `form_shape_option_langs` fsol{$i} ON fsol{$i}.form_shape_option_id = pfs{$i}.value AND  fsol{$i}.lang_code = '{$this->lang_code}' ";
        }


        if ($searchKey && $searchMode == 'formshapes') {
            $sql .= " LEFT JOIN `product_form_shapes` pfs ON pfs.product_id = p.id ";
            $sql .= " INNER JOIN `form_shape_option_langs` fsol ON fsol.form_shape_option_id = pfs.value AND  fsol.lang_code = '{$this->lang_code}' and fsol.`label` !='' ";
        }


// SELECT * FROM `affiliator_prices`
        if ($history) {
            $sql .= " INNER JOIN `browse_product_history` bph ON bph.product_id = p.id ";
        }

        $sql .= " WHERE p.id >  0 AND psav.store_id in  ({$affiliator_stores}) and p.active " . search_active('!=0');

        if ($history) {
            $sql .= " and   bph.`affiliator_id` = '" . AFFILIATOR['id'] . "'  and bph.`client_id` = '" . CLIENT['id'] . "' ";
        }

        if ($mode == 'is_back_from_new') {
            $sql .= " and   psav.store_amounts > '0' and p.new_store_amounts_date_added IS NOT NULL ";
        }
//form_shape




        $sql .= count($form_shape) > 0 ? " AND ( " : '';
        for ($i = 0; $i < count($form_shape); $i++) {
            $sql .= $i == 0 ? "  " : " and ";
            $sql .= "  (  pfs{$i}.form_shape_id  = '{$form_shape[$i]['key']}' AND pfs{$i}.value  in ({$form_shape[$i]['value']}) )";
        }
        $sql .= count($form_shape) > 0 ? " ) " : '';

//$filter_type
        $sql .= $filter_type == 'discounts' && AFFILIATOR['price_type'] == 'price_multi' ? " AND p.last_price_multi > '0'   " : " ";
        $sql .= $filter_type == 'discounts' && AFFILIATOR['price_type'] == 'price_one' ? " AND p.last_price_one > '0'  " : " ";
        $sql .= $filter_type == 'soon' ? " AND  p." . AFFILIATOR['price_type'] . " = 0 " : " ";

        $sql .= $prod_ids_string ? " AND p.id in  ({$prod_ids_string})  " : " ";

// $sql .= $offer_filter   ? " AND p.id in  ({$offer_filter})  "  : " ";
// $sql .= $searchUserType  && $ids ? " AND p.id  not in  ({$ids})  "  : " ";
        $sql .= $searchKey && $searchMode == 'key_words' ? ' AND (   ' . search_word_in_column('p.`key_words`', ',' . $searchKey . ',') . ')' : " ";
        $sql .= $searchKey && $searchMode == 'suggesstion' ? ' AND (  ' . search_word_in_column('pssk.`suggesstion`', $searchKey) . ')' : " ";
        $sql .= $searchKey && $searchMode == 'formshapes' ? ' AND (  ' . search_word_in_column('fsol.`label`', $searchKey) . ')' : " ";
        $sql .= $searchKey && $searchMode == '' ? ' AND ( ' . search_word_in_column('p.`product_code`', $searchKey) . ' OR ' . search_word_in_column('p.`product_barcode`', $searchKey) . ' OR ' . search_word_in_column('pl.`name`', $searchKey) . ' OR ' . search_word_in_column('pl2.`name`', $searchKey) . ' OR ' . search_word_in_column('p.`key_words`', ',' . $searchKey . ',') . ' OR ' . search_word_in_column('pssk.`suggesstion`', $searchKey) . ')' : " ";

        $sql .= $searchDateFrom ? " AND p.`date_added`   >= '{$searchDateFrom}' " : "";
        $sql .= $searchDateTo ? " AND p.`date_added`  <= '{$searchDateTo}' " : "";
        $sql .= $searchCategoryId ? " AND ps.`service_id` in  ({$searchCategoryId})  " : "";
        $sql .= $searchProductStatus === '0' || $searchProductStatus ? " AND p.`active` =  '{$searchProductStatus}'  " : "";

        $sql .= $searchMerchant_id ? " AND p.`merchant_id` =  '{$searchMerchant_id}'  " : "";
        $sql .= $searchTrademark_id ? " AND p.`trademark_id` IN ({$searchTrademark_id})  " : "";

// $sql .= $searchPriceFrom    ? " AND  p." . AFFILIATOR['price_type'] . "    >= '{$searchPriceFrom}' " : "";
// $sql .= $searchPriceTo    ? " AND p." . AFFILIATOR['price_type'] . "   <= '{$searchPriceTo}' " : "";


        $sql .= count($searchMultiPrices) > 0 ? " AND ( " : '';
        for ($i = 0; $i < count($searchMultiPrices); $i++) {
            $sql .= $i == 0 ? "  " : " || ";
            $sql .= "  (  p." . AFFILIATOR['price_type'] . " >= '{$searchMultiPrices[$i]['from']}' AND p." . AFFILIATOR['price_type'] . "   <= '{$searchMultiPrices[$i]['to']}'  )";
        }
        $sql .= count($searchMultiPrices) > 0 ? " ) " : '';

//offer_filter 
        $sql .= $offer_filter["types"] == "products" && $offer_filter["offer_products_ids"] ? " AND p.id   in  ({$offer_filter["offer_products_ids"]})  " : " ";

        $sql .= $offer_filter["types"] == "services" && $offer_filter["offer_services_ids"] ? " AND ps.service_id   in  ({$offer_filter["offer_services_ids"]})  " : " ";

        $sql .= $offer_filter["types"] == "trademarks" && $offer_filter["offer_trademarks_ids"] ? " AND p.trademark_id    in  ({$offer_filter["offer_trademarks_ids"]})  " : " ";

//VIP dont touch
        $sql .= "AND(";
        $sql .= $offer_filter_all["products"] && $offer_filter_all["offer_products_ids"] ? "  p.id in  ({$offer_filter_all["offer_products_ids"]})  ||" : "";
        $sql .= $offer_filter_all["services"] && $offer_filter_all["offer_services_ids"] ? "  ps.service_id   in  ({$offer_filter_all["offer_services_ids"]})  ||" : "";
        $sql .= $offer_filter_all["trademarks"] && $offer_filter_all["offer_trademarks_ids"] ? "  p.trademark_id    in  ({$offer_filter_all["offer_trademarks_ids"]}) ----" : "";
        $sql = substr($sql, 0, -4);
        $sql .= ($offer_filter_all["products"] && $offer_filter_all["offer_products_ids"]) ||
                ($offer_filter_all["services"] && $offer_filter_all["offer_services_ids"]) ||
                ($offer_filter_all["trademarks"] && $offer_filter_all["offer_trademarks_ids"]) ? " ) " : ' ';

        if (!$history) {
            $sql .= " group by  p.id";
            $sql .= $sort == 'price' ? "  ORDER BY p." . AFFILIATOR['price_type'] . " {$type} " : "  ORDER BY  {$sort} {$type} ";
        } else {
            $sql .= " group by bph.product_id";
            $sql .= "  ORDER BY  history_date_added DESC ";
        }

//         echo $sql . "<hr>";
//  p($sql);
        $res = $this->mDb->getAll($sql);

        $out_of_product_ids = '';
        $in_ids = '';
        for ($i = 0; $i < count($res); $i++) {
            if ($searchStatusStock == 'in_stock' || $searchStatusStock == 'out_of_stock') {
                $store_amounts = $this->getProductStoreAmounts($res[$i]['id'], $searchStore_id);
            }
            if ($res[$i]['id']) {

// echo $store_amounts; 
                if ($searchStatusStock == 'in_stock') {
                    if ($store_amounts <= 0 || !$store_amounts) {
                        $out_of_product_ids .= '' . $res[$i]['id'] . ',';
// $res['count'] -= 1;
                    } else {
                        $in_ids .= '' . $res[$i]['id'] . ',';
                    }
                } else if ($searchStatusStock == 'out_of_stock') {
                    if ($store_amounts > 0) {
// p($res);
                        $out_of_product_ids .= '' . $res[$i]['id'] . ',';
// $res['count'] -= 1;
                    } else {
                        $in_ids .= '' . $res[$i]['id'] . ',';
                    }
                } else {
                    $in_ids .= '' . $res[$i]['id'] . ',';
                }
            }
        }
// p($in_ids);
// die();
// echo $out_of_product_ids;
        $out_of_product_ids = $out_of_product_ids ? substr($out_of_product_ids, 0, -1) : $out_of_product_ids;
        $in_ids = $in_ids ? substr($in_ids, 0, -1) : $in_ids;

        $ret['out_of_product_ids'] = $out_of_product_ids;
        if (count($form_shape) > 0) {
            $column = 'parent';
        } else {
            $column = 'id';
        }
//        echo $in_ids."<hr>";
        $all_category_ids_for_searching_products = $this->getProduct_servicesIds(explode(",",$in_ids), $column);
        $ret['all_category_ids_for_searching_products'] = fetchArrayValue_from_dataBase($all_category_ids_for_searching_products, $column);

        $ret['total_count'] = count($res);
//    p($out_of_product_ids);
        return $ret;
    }

    public function getSuggesstionsProductsSearchKeys(
            $aStart, $aLimit, $sort, $type, $products_ids, $searchKey, $mode
    ) {

        $sql = "SELECT DISTINCT    pssk.suggesstion , pssk.product_id   
        FROM `product_suggesstion_search_keys` pssk  ";
        $sql .= $mode == 'all' ? " where   pssk.`product_id` in ({$products_ids})" : " where pssk.suggesstion LIKE '$searchKey%'";

        $sql .= " group by pssk.suggesstion ORDER BY pssk.suggesstion ASC ";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
//        echo $sql."<hr>";
//   p($sql);
        return $this->mDb->getAll($sql);
    }

    public function getProductsAutoComplete(
            $aStart, $aLimit, $sort, $type, $searchKey, $affiliator_stores, $services_ids, $mode = 'all'
    ) {
        global $trademarksObj;
        if ($mode == 'all' || $mode == 'products') {
            $ret['products'] = array();

            $versLang = $this->lang_code == 'ar' ? 'en' : 'ar';

// echo
            $sql = "SELECT DISTINCT  p.id,  pl.name as name ,  pl.meta_url    ,p.last_price_one,p.last_price_multi,  p.price_one,p.price_multi  , ap.price as affiliator_price
          ,IFNULL(psa.store_amounts, 0) AS store_amounts FROM `products` p";

//   sl.ser_name   ******************************************

            $sql .= " LEFT JOIN (";
            $sql .= " SELECT psa.product_id,SUM(psa.store_amounts) AS store_amounts,psa.store_id,psa.`expiration_date` FROM  product_stores_amounts psa ";
            $sql .= " LEFT JOIN `stores` s ON s.id = psa.store_id  ";
            $sql .= " WHERE   s.active = '1' and s.show_store_amounts='1'   ";
            $sql .= "  GROUP BY  psa.product_id ";
            $sql .= " ) AS psa ON psa.product_id = p.id ";
//            $sql .= " LEFT JOIN `z_view_product_store_amounts` psav ON psav.product_id = p.id ";
//        $sql .= " LEFT JOIN `product_stores` pst ON pst.product_id = p.id ";
            $sql .= " LEFT JOIN `product_langs` pl ON pl.product_id = p.id  AND  pl.lang_code = '{$this->lang_code}' ";
            $sql .= " LEFT JOIN `product_langs` pl2 ON pl2.product_id = p.id  AND  pl2.lang_code = '{$versLang}' ";
            $sql .= " LEFT JOIN `product_suggesstion_search_keys` pssk ON pssk.product_id = p.id ";
            $sql .= " LEFT JOIN `product_services` ps ON ps.product_id = p.id ";
            $sql .= " LEFT JOIN `affiliator_prices` ap ON ap.product_id = p.id ";
//            $sql .= " LEFT JOIN `product_form_shapes` pfs ON pfs.product_id = p.id ";
//            $sql .= " LEFT JOIN `form_shape_option_langs` fsol ON fsol.form_shape_option_id = pfs.value AND  fsol.lang_code = '{$this->lang_code}' ";
            $sql .= " WHERE p.id >  0 AND psa.store_id in  ({$affiliator_stores})   and p.active " . search_active('!=0');
            $sql .= $services_ids ? " AND ps.id  not in  ({$services_ids})  " : " ";
//            $sql .= $searchKey ? ' AND ( ' . search_word_in_column('p.`product_code`', $searchKey) . ' OR  ' . search_word_in_column('p.`product_barcode`', $searchKey) . ' OR ' . search_word_in_column('pl.`name`', $searchKey) . ' OR ' . search_word_in_column('pl2.`name`', $searchKey) . ' OR ' . search_word_in_column('p.`key_words`', $searchKey) . ' OR ' . search_word_in_column('pssk.`suggesstion`', $searchKey) . ' OR ' . search_word_in_column('pfs.`value`', $searchKey) . ' OR ' . search_word_in_column('fsol.`label`', $searchKey) . '  )' : " ";
            $sql .= $searchKey ? ' AND ( ' . search_word_in_column('p.`product_code`', $searchKey) . ' OR  ' . search_word_in_column('p.`product_barcode`', $searchKey) . ' OR ' . search_word_in_column('pl.`name`', $searchKey) . ' OR ' . search_word_in_column('pl2.`name`', $searchKey) . ' OR ' . search_word_in_column('p.`key_words`', ',' . $searchKey . ',') . ' OR ' . search_word_in_column('pssk.`suggesstion`', $searchKey) . '  )' : " ";
            $sql .= " group by  p.id ";
            $sql .= $sort == 'price' ? "  ORDER BY p." . AFFILIATOR['price_type'] . " {$type} " : "  ORDER BY {$sort} {$type} ";
            $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';

//         echo $sql ."<hr>";
            $res = $this->mDb->getAll($sql);
            if ($res) {
                $products_ids = '';
                for ($i = 0; $i < count($res); $i++) {
                    $products_ids .= $products_ids ? ',' . $res[$i]['id'] : $res[$i]['id'];
                    $res[$i]['images'] = $this->getProductimgs($res[$i]['id']);
                    $res[$i]['image'] = $res[$i]['images'][0]['name'];
                    $res[$i]['original_image'] = $res[$i]['images'][0]['original_name'];
                    unset($res[$i]['images']);
//                $res[$i]['store_amounts'] = $this->getProductStoreAmounts($res[$i]['id']);
                    $res[$i]['last_price'] = null;
// $res[$i]['product_langs'] = $this->getProduct_langs($res[$i]['id']);
// $res[$i]['price'] =  $res[$i][AFFILIATOR['price_type']];
                    if (AFFILIATOR['price_type'] == 'price' && $res[$i]['affiliator_price'] > 0) {
                        $res[$i]['price'] = $res[$i]['affiliator_price'];
                    }
//                $res[$i]['affiliator_commission'] = $res[$i]['affiliator_price'] ? $res[$i]['price'] - $res[$i]['price_multi'] : $res[$i]['commission'];

                    if (AFFILIATOR['price_type'] == 'price_one' && $res[$i]['last_price_one'] > '0') {
                        $res[$i]['last_price'] = $res[$i]['price_one'];
                        $res[$i]['price_one'] = $res[$i]['last_price_one'];
                    }
                    if (AFFILIATOR['price_type'] == 'price_multi' && $res[$i]['last_price_multi'] > '0') {
                        $res[$i]['last_price'] = $res[$i]['price_multi'];
                        $res[$i]['price_multi'] = $res[$i]['last_price_multi'];
                    }

                    if ($res[$i]['last_price_multi'] > '0') {
                        $price_multi_last = $res[$i]['price_multi'];
                        $res[$i]['price_multi'] = $res[$i]['last_price_multi'];
                        $res[$i]['last_price_multi'] = $price_multi_last;
                    }

                    if ($res[$i]['api_id_to'] && $res[$i]['api_id_to'] != '0') {
                        if ($res[$i]['last_price_one'] > '0') {
                            $res[$i]['last_price'] = $res[$i]['price_one'];
                            $res[$i]['price_one'] = $res[$i]['last_price_one'];
                        }

                        $res[$i]['price'] = $res[$i]['price_one'];
                    } else {
                        $res[$i]['price'] = $res[$i][AFFILIATOR['price_type']];
                    }
                    $res[$i]['meta_url'] = (trim($res[$i]['meta_url']) ? processTitle($res[$i]['meta_url']) : processTitle($res[$i]['name']));

//                $trademark = $this->getTrademarkData($res[$i]['trademark_id']);
//                $res[$i]['trademark_image'] = $trademark['image'];
//                $res[$i]['trademark_title'] = $trademark['title'];

                    unset($res[$i]['affiliator_price']);
// $res[$i]['statistics'] = $this->getStatisticByProductId($res[$i]['id']);
                }
# code...
// p( $products_ids)
                $ret['products'] = $res ? $res : array();
            }
        }

        if ($mode == 'all' || $mode == 'suggesstions_products_search_keys') {

            $ret['suggesstions_products_search_keys'] = $this->getSuggesstionsProductsSearchKeys(
                    $aStart, $aLimit, $sort, $type, $products_ids, $searchKey, $mode
            );
        }
        if ($mode == 'all' || $mode == 'brands') {
            $sort = 'id';
            $ret['brands'] = $this->getTrademarksSearch(0, 10, $sort, $type, $searchKey, $services_ids);
        }




        return $ret;
    }

    function getTrademarksSearch($aStart, $aLimit, $sort, $type, $searchTitle, $searchCategoryId) {

        $sql = "SELECT  t.id,t.image ,tl.title,tl.description  FROM trademarks t";
        $sql .= " LEFT JOIN `trademark_langs` tl ON t.id = tl.trademark_id  AND  tl.lang_code = 'ar'  ";
        $sql .= " LEFT JOIN `products` p ON  p.trademark_id    =  t.id ";
        $sql .= " LEFT JOIN `product_services` ps ON ps.product_id = p.id    ";
        $sql .= " WHERE t.id > 0 and t.active = '1'   ";
        $sql .= " AND ps.service_id  in ($searchCategoryId)  ";

        $sql .= $searchTitle ? ' AND (tl.title like "' . $searchTitle . '%" ||  t.code like "' . $searchTitle . '%" || t.`alternate_words_array` like "' . $searchTitle . '%"  ) ' : '';
        $sql .= "  group by t.id  ORDER BY t.{$sort} {$type} ";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
// 	 echo $sql."<hr>";
        //  echo $sql; die();

        return $this->mDb->getAll($sql);
    }

    public function getProductsAutoCompleteCount(
            $aStart, $aLimit, $sort, $type, $searchKey, $affiliator_stores, $services_ids
    ) {
        global $trademarksObj;

        $versLang = $this->lang_code == 'ar' ? 'en' : 'ar';

// echo
        $sql = "SELECT  count(DISTINCT p.id)  FROM `products` p";
        $sql .= " LEFT JOIN `z_view_product_store_amounts` psav ON psav.product_id = p.id ";
        $sql .= " LEFT JOIN `product_langs` pl ON pl.product_id = p.id  AND  pl.lang_code = '{$this->lang_code}' ";
        $sql .= " LEFT JOIN `product_langs` pl2 ON pl2.product_id = p.id  AND  pl2.lang_code = '{$versLang}' ";
        $sql .= " LEFT JOIN `product_suggesstion_search_keys` pssk ON pssk.product_id = p.id ";
        $sql .= " LEFT JOIN `product_services` ps ON ps.product_id = p.id ";
        $sql .= " LEFT JOIN `affiliator_prices` ap ON ap.product_id = p.id ";
        $sql .= " LEFT JOIN `product_form_shapes` pfs ON pfs.product_id = p.id ";
        $sql .= " LEFT JOIN `form_shape_option_langs` fsol ON fsol.form_shape_option_id = pfs.value AND  fsol.lang_code = '{$this->lang_code}' ";

// SELECT * FROM `affiliator_prices`

        $sql .= " WHERE p.id >  0 AND psav.store_id in  ({$affiliator_stores})   and p.active " . search_active('!=0');

// $sql .= $offer_filter   ? " AND p.id in  ({$offer_filter})  "  : " ";

        $sql .= $services_ids ? " AND ps.id  not in  ({$services_ids})  " : " ";
        $sql .= $searchKey ? ' AND ( ' . search_word_in_column('p.`product_code`', $searchKey) . ' OR  ' . search_word_in_column('p.`product_barcode`', $searchKey) . ' OR ' . search_word_in_column('pl.`name`', $searchKey) . ' OR ' . search_word_in_column('pl2.`name`', $searchKey) . ' OR ' . search_word_in_column('p.`key_words`', ',' . $searchKey . ',') . ' OR ' . search_word_in_column('pssk.`suggesstion`', $searchKey) . '  )' : " ";

//        $sql .= " group by  p.id ";
//        $sql .= $sort == 'price' ? "  ORDER BY p." . AFFILIATOR['price_type'] . " {$type} " : "  ORDER BY {$sort} {$type} ";
//        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
//        echo $sql . "<hr>";
// die();
        $res = $this->mDb->getOne($sql);

        return $res;
    }

// public function  getStatisticsFroProduct($product_id)
// {
//     $sql = "SELECT  sum(value)  FROM `product_stores` where product_id ='{$product_id}'   and type ='add'  and store_id = '1' ";
//     $sql .=  "  group by product_id   ";
//     $res['total_add_amount_product'] = $this->mDb->getOne($sql);
//     $res['total_add_amount_product'] = $res['total_add_amount_product'] ? $res['total_add_amount_product'] : 0;
//     $sql = "SELECT sum(value)   FROM `product_stores` where product_id ='{$product_id}'  and type ='remove'   and store_id = '1'  ";
//     $sql .=  "  group by product_id   ";
//     $res['total_sell_amount_product'] = $this->mDb->getOne($sql);
//     $res['total_sell_amount_product'] = $res['total_sell_amount_product'] ? $res['total_sell_amount_product'] : 0;
//     return $res;
// }
//SELECT p.id as product_id,
//psa.store_id as store_id_a,
//psr.store_id as store_id_r,
//SUM( psa.value) as value_a,
//SUM( psr.value) as value_r,
//(SUM( psa.value)-SUM( psr.value))as store_amounts
//FROM `products` p 
//LEFT JOIN `product_stores` psa ON (psa.product_id = p.id and psa.type ='add' and psa.is_deleted ='0')
//LEFT JOIN `product_stores` psr ON (psr.product_id = p.id and psr.type ='remove' and psr.is_deleted ='0') 
//WHERE p.id='312' 
//    z_view_product_store_amounts
//SELECT p.id as product_id,afs.user_id as affiliator_id,ps.store_id,ps.name,
//coalesce((SELECT sum(psa.value) FROM `product_stores` psa WHERE psa.product_id= p.id and psa.type ='add' and psa.is_deleted ='0') - (SELECT sum(psr.value) FROM `product_stores` psr WHERE psr.product_id= p.id and psr.type ='remove' and psr.is_deleted ='0'),0 ) as store_amounts 
//FROM `products` p
//LEFT JOIN `product_stores` ps ON ps.product_id = p.id and ps.type ='add' and ps.is_deleted ='0'
//LEFT JOIN `affiliator_stores` afs ON afs.store_id = ps.store_id
//group by product_id ,afs.user_id ,ps.store_id
//    
//    public function getProductStoreAmountsByExpirationDate($product_id, $store_id = '', $name = '') {
//        $sql = "SELECT `expiration_date`,
//                   SUM(CASE WHEN type = 'add' THEN value ELSE 0 END) AS `addition`, 
//                   SUM(CASE WHEN type = 'remove' THEN value ELSE 0 END) AS `remove`
//             FROM `product_stores`
//             WHERE `product_id` = '{$product_id}' AND `is_deleted` = '0'";
//
//        $sql .= $store_id ? " AND `store_id` = '{$store_id}' " : "";
//        $sql .= $name ? " AND `name` = '{$name}' " : "";
//        $sql .= "GROUP BY `product_id`, `name`, `expiration_date`  ORDER BY expiration_date ASC ";
//         echo $sql . "<hr>";
//        $res = $this->mDb->getAll($sql);
//
//        $expirationDateTotals = [];
//        foreach ($res as $row) {
//            $expirationDateTotals[] = [
//                'expiration_date' => $row['expiration_date'],
//                'total' => max($row['addition'] - $row['remove'], 0)
//            ];
//        }
////        p($expirationDateTotals);
//        return $expirationDateTotals;
//    }
    public function getProductStoreAmountsByExpirationDate($product_id, $store_id = '', $name = '') {
        $sql = "SELECT `expiration_date`, store_amounts as total
    
             FROM `product_stores_amounts`
             WHERE `product_id` = '{$product_id}' ";

        $sql .= $store_id ? " AND `store_id` = '{$store_id}' " : "";
        $sql .= $name ? " AND `name` = '{$name}' " : "";
        $sql .= "GROUP BY `product_id`, `name`, `expiration_date`  ORDER BY expiration_date ASC ";
//        echo $sql . "<hr>";
        $res = $this->mDb->getAll($sql);

//        $expirationDateTotals = [];
//        foreach ($res as $row) {
//            $expirationDateTotals[] = [
//                'expiration_date' => $row['expiration_date'],
//                'total' => max($row['addition'] - $row['remove'], 0)
//            ];
//        }
//        p($expirationDateTotals);
        return $res;
    }

    public function getParentExpirationDateByProductId($id) {

        $sql = "SELECT  sch.expiration_date parent_expiration_date  FROM product_services ps ";
        $sql .= " LEFT JOIN `services` s ON s.id = ps.service_id  ";
        $sql .= " LEFT JOIN `services` sch ON sch.id = s.parent ";
        $sql .= " WHERE ps.`product_id` = '{$id}' and  sch.expiration_date is not null ";
        return $this->mDb->getOne($sql);
//        $parent_expiration_date = '0';
//        for ($i = 0; $i < count($res); $i++) {
//            if ($res[$i]["parent_expiration_date"] == '1') {
//                $parent_expiration_date = $res[$i]["parent_expiration_date"];
//            }
//        }
//        return $parent_expiration_date;
    }

    public function getProductQuantityOnShelf($product_id, $store_id = '', $name = '', $expiration_date = '') {
        if ($product_id && $store_id && $name) {
            $parent_expiration_date = $this->getParentExpirationDateByProductId($product_id);
            $sql = "SELECT  sum(psa.quantity_on_shelf)  FROM `product_stores_amounts` psa ";
            $sql .= " LEFT JOIN `stores` s ON s.id = psa.store_id  ";
            $sql .= " where psa.product_id ='{$product_id}'  and s.show_store_amounts='1'  ";
            $sql .= $store_id ? " AND  psa.`store_id` IN({$store_id})   " : "";
            $sql .= $name ? " AND  psa.`name` = '{$name}'   " : "";
            $sql .= ($parent_expiration_date && $store_id && $name) ? $expiration_date == '' ? "  " : " AND  psa.`expiration_date` = '{$expiration_date}'   " : "";
            $sql .= "  group by psa.product_id   ";
            $res = $this->mDb->getOne($sql);
            return $res > 0 ? intval($res) : 0;
        }
    }

    public function getProductStoreAmounts(
            $product_id,
            $store_id = '',
            $name = '',
            $expiration_date = '',
            $mode = ''
    ) {
        if ($product_id && $store_id && $name) {
            $parent_expiration_date = $this->getParentExpirationDateByProductId($product_id);
        }

        $sql = "SELECT  sum(psa.store_amounts)  
                FROM product_stores_amounts psa
                LEFT JOIN stores s ON s.id = psa.store_id
                WHERE psa.product_id ='{$product_id}' ";
        $sql .= $mode !== 'gard' ? " and s.show_store_amounts='1'  " : "";
        $sql .= $store_id ? " AND  psa.store_id IN({$store_id})   " : "";
        $sql .= $name ? " AND  psa.name = '{$name}'   " : "";
        $sql .= ($parent_expiration_date && $store_id && $name) ? ($expiration_date == '' ? " and psa.expiration_date IS NULL " : ($expiration_date == 'all_date' ? "" : " AND psa.expiration_date = '{$expiration_date}'")) : "";
        $sql .= "  group by psa.product_id   ";
//        echo $sql."<hr>";
        $res = $this->mDb->getOne($sql);
        return $res > 0 ? intval($res) : 0;
    }

//    public function getProductStoreAmounts($product_id, $store_id = '', $name = '', $expiration_date = '', $mode = '') {
//        if ($product_id && $store_id && $name) {
//            $parent_expiration_date = $this->getParentExpirationDateByProductId($product_id);
//        }
//
//        $sql = "SELECT  sum(psa.store_amounts)  FROM `product_stores_amounts` psa ";
//        $sql .= " LEFT JOIN `stores` s ON s.id = psa.store_id  ";
//        $sql .= " where psa.product_id ='{$product_id}' ";
//        $sql .= $mode !== 'gard' ? " and s.show_store_amounts='1'  " : "";
//        $sql .= $store_id ? " AND  psa.`store_id` IN({$store_id})   " : "";
//        $sql .= $name ? " AND  psa.`name` = '{$name}'   " : "";
//        $sql .= ($parent_expiration_date && $store_id && $name) ? $expiration_date == '' ? " and psa.`expiration_date` IS NULL  " : $expiration_date == 'all_date' ? "" : " AND  psa.`expiration_date` = '{$expiration_date}'   " : "";
//        $sql .= "  group by psa.product_id   ";
////          echo $sql."<hr>";
//        $res = $this->mDb->getOne($sql);
//
//        return $res > 0 ? intval($res) : 0;
//    }



    public function getProductQuantityByInvoiceId($product_id, $store_id = '', $name = '', $for_id = '') {

        $sql = "SELECT ps.`expiration_date` , sum(ps.value) as total FROM `product_stores` ps ";
        $sql .= " LEFT JOIN `stores` s ON s.id = ps.store_id  ";
        $sql .= " where ps.product_id ='{$product_id}'  and ps.type ='remove' and ps.is_deleted ='0' and s.show_store_amounts='1' ";
        $sql .= $store_id ? " AND  ps.`store_id` = '{$store_id}'   " : "";
        $sql .= $name ? " AND  ps.`name` = '{$name}'   " : "";
        $sql .= $for_id ? " AND  ps.`for_id` = '{$for_id}'  AND  ps.`for_type` = 'sale-invoice'   " : "";
        $sql .= "  group by ps.`product_id`, ps.`name`, ps.`expiration_date`  ";
//        echo $sql."<hr>";
        $res = $this->mDb->getAll($sql);
//

        return $res;
    }

    public function getAllServicesOfProductById($id) {

        $sql = "SELECT sl.ser_name FROM product_services  ps ";
        $sql .= " LEFT JOIN `service_langs` sl ON sl.service_id = ps.service_id  AND  sl.lang_code = '{$this->lang_code}'  ";
        $sql .= " WHERE ps.`product_id` = '{$id}'   ";
        return $this->mDb->getAll($sql);
    }

    public function getActiveInProduct($id) {

        $sql = "SELECT active FROM products  ";
        $sql .= " WHERE id = '{$id}'   ";
        $res = $this->mDb->getOne($sql);

        return activeFormat($res);
    }

    function getCountProductQuantityDiscount($product_id) {
        $sql = "SELECT count(pqd.id) FROM `product_quantity_discount` pqd ";
        $sql .= " LEFT JOIN `product_quantity_discount_affiliators` pqdf ON (pqdf.affiliator_id = pqd.affiliator_id and pqdf.product_id = pqd.product_id)";
        $sql .= " WHERE pqd.`product_id`='{$product_id}' and pqd.affiliator_id= " . AFFILIATOR['id'] . "  and pqdf.quantity_discount_show='1' ";
        $res = $this->mDb->getOne($sql);
        return $res;
    }

    public function getProductQuantityDiscount($product_id) {
        $affiliator_id = AFFILIATOR['id'];
        $sql = "SELECT 
                    pqd.*,
                    p.api_id_to,
                    p.trademark_id,
                    pqdl.purchase_text 
                FROM `product_quantity_discount` pqd 
                LEFT JOIN `product_quantity_discount_affiliators` pqdf 
                    ON (pqdf.affiliator_id = pqd.affiliator_id 
                    AND pqdf.product_id = pqd.product_id)
                LEFT JOIN `product_quantity_discount_langs` pqdl 
                    ON pqdl.p_id = pqd.id  
                    AND pqdl.lang_code = :land_code
                LEFT JOIN `products` p ON p.id = pqd.product_id
                WHERE pqd.product_id = :product_id 
                    AND pqd.affiliator_id= :affiliator_id 
                    AND pqdf.quantity_discount_show = '1'
                GROUP BY pqd.id
                ORDER BY  pqd.quantity ASC  ";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':product_id', $product_id, PDO::PARAM_INT);
        $stmt->bindParam(':affiliator_id', $affiliator_id, PDO::PARAM_INT);
        $stmt->bindParam(':land_code', $this->lang_code, PDO::PARAM_STR);
        $stmt->execute();
        $res = $stmt->fetchAll(PDO::FETCH_ASSOC);
        if ($res) {
            foreach ($res as &$product_discount) {
                $product_discount['id'] = $product_discount['product_id'];
                $product_discount['store_amounts'] = $this->getProductStoreAmounts($product_discount['id']);
                $product_discount['product_services'] = $this->getProduct_services($product_discount['id']);
                $product_discount['product_group_data'] = $this->GetGroupData($product_discount['id']);
                $product_discount['product_tags'] = $this->getProductTags($product_discount['id']);
                $product_discount['offer_id'] = $this->getProduct_offer(
                        $product_discount['id'],
                        $product_discount['trademark_id'],
                        $product_discount['product_services'],
                        $product_discount['product_group_data']['id'],
                        $product_discount['product_tags']
                );
                $product_discount['coupon_id'] = $this->getProduct_coupon(
                        $product_discount['id'],
                        $product_discount['trademark_id'],
                        $product_discount['product_services'],
                        '',
                        $product_discount['product_group_data']['id'],
                        $product_discount['product_tags']
                );
                $product_discount['stores'] = $this->getProductStores($product_discount['id'], true);
                $product_discount["product_type_name"] = $product_discount['stores'][0]["product_type_name"];
            }
        }
        return $res;
    }

    public function getCountProductsRelated($product_id) {
        $sql = "SELECT count(id) FROM `product_related`  ";
        $sql .= " WHERE `p_id`='{$product_id}' ";
//        echo $sql . "<hr>";
        $res = $this->mDb->getOne($sql);

        return $res;
    }

    public function getProductsRelated($product_id) {
        $sql = "SELECT 
                    pr.*,
                    prl.related_details,
                    p.trademark_id,
                    p.price,ap.price as affiliator_price,
                    p.price_multi,
                    p.commission,
                    p.last_price_one,
                    p.last_price_multi,
                    p.api_id_to,
                    p.price_one,
                    pl_ar.name as product_name ,
                    pl_ar.meta_url
                FROM `product_related` pr 
                LEFT JOIN `product_related_langs` prl 
                    ON  prl.p_id = pr.id  
                    AND prl.lang_code = :land_code 
                LEFT JOIN `products` p ON p.id = pr.product_id
                LEFT JOIN `product_langs` pl_ar 
                    ON pl_ar.product_id = pr.product_id  
                    AND  pl_ar.lang_code = :land_code
                LEFT JOIN `affiliator_prices` ap ON ap.product_id = pr.product_id
                WHERE pr.p_id = :product_id
                ORDER BY 
                    CASE WHEN pr.product_id = :product_id
                    THEN 1 ELSE 2 END ASC";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':product_id', $product_id, PDO::PARAM_INT);
        $stmt->bindParam(':land_code', $this->lang_code, PDO::PARAM_STR);
        $stmt->execute();
        $res = $stmt->fetchAll(PDO::FETCH_ASSOC);
        if ($res) {
            for ($i = 0; $i < count($res); $i++) {
                $res[$i]['id'] = $res[$i]['product_id'];

                $res[$i]['store_amounts'] = $this->getProductStoreAmounts($res[$i]['id']);
                $res[$i]['last_price'] = null;

                if (AFFILIATOR['price_type'] == 'price' && $res[$i]['affiliator_price'] > 0) {
                    $res[$i]['price'] = $res[$i]['affiliator_price'];
                }

                $res[$i]['affiliator_commission'] = $res[$i]['affiliator_price'] ? $res[$i]['price'] - $res[$i]['price_multi'] : $res[$i]['commission'];

                if (AFFILIATOR['price_type'] == 'price_one' && $res[$i]['last_price_one'] > '0') {
                    $res[$i]['last_price'] = $res[$i]['price_one'];
                    $res[$i]['price_one'] = $res[$i]['last_price_one'];
                }

                if (AFFILIATOR['price_type'] == 'price_multi' && $res[$i]['last_price_multi'] > '0') {
                    $res[$i]['last_price'] = $res[$i]['price_multi'];
                    $res[$i]['price_multi'] = $res[$i]['last_price_multi'];
                }

                if ($res[$i]['last_price_multi'] > '0') {
                    $price_multi_last = $res[$i]['price_multi'];
                    $res[$i]['price_multi'] = $res[$i]['last_price_multi'];
                    $res[$i]['last_price_multi'] = $price_multi_last;
                }

                if ($res[$i]['api_id_to'] && $res[$i]['api_id_to'] != '0') {
                    if ($res[$i]['last_price_one'] > '0') {
                        $res[$i]['last_price'] = $res[$i]['price_one'];
                        $res[$i]['price_one'] = $res[$i]['last_price_one'];
                    }
                    $res[$i]['price'] = $res[$i]['price_one'];
                } else {
                    $res[$i]['price'] = $res[$i][AFFILIATOR['price_type']];
                }

                $res[$i]['images'] = $this->getProductimgs($res[$i]['id']);

                $res[$i]['meta_url'] = (trim($res[$i]['meta_url']) ? processTitle($res[$i]['meta_url']) : processTitle($res[$i]['product_name']));

                $res[$i]['product_services'] = $this->getProduct_services($res[$i]['id']);
                $res[$i]['product_group_data'] = $this->GetGroupData($res[$i]['id']);
                $res[$i]['product_tags'] = $this->getProductTags($res[$i]['id']);
                $res[$i]['offer_id'] = $this->getProduct_offer(
                        $res[$i]['id'],
                        $res[$i]['trademark_id'],
                        $res[$i]['product_services'],
                        $res[$i]['product_group_data']['id'],
                        $res[$i]['product_tags']
                );
                $res[$i]['coupon_id'] = $this->getProduct_coupon(
                        $res[$i]['id'],
                        $res[$i]['trademark_id'],
                        $res[$i]['product_services'],
                        "",
                        $res[$i]['product_group_data']['id'],
                        $res[$i]['product_tags']
                );
                $res[$i]['stores'] = $this->getProductStores($res[$i]['id'], true);
                $res[$i]["product_type_name"] = $res[$i]['stores'][0]["name"];
            }
        }
        return $res;
    }

    public function getProductSimilar($product_id) {
        $sql = "SELECT 
                    ps.*,
                    p.trademark_id,
                    p.price,ap.price as affiliator_price,
                    p.price_multi,
                    p.commission,p.last_price_one,
                    p.last_price_multi,
                    p.api_id_to,
                    p.price_one,
                    pl_ar.name as product_name ,
                    pl_ar.meta_url
                FROM `product_similar` ps
                LEFT JOIN `products` p ON p.id = ps.product_id
                LEFT JOIN `affiliator_prices` ap ON ap.product_id = ps.product_id
                LEFT JOIN `product_langs` pl_ar 
                    ON pl_ar.product_id = ps.product_id  
                    AND pl_ar.lang_code = :lang_code
                WHERE ps.p_id = :product_id ";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':product_id', $product_id, PDO::PARAM_INT);
        $stmt->bindParam(':lang_code', $this->lang_code, PDO::PARAM_STR);
        $stmt->execute();
        $res = $stmt->fetchAll(PDO::FETCH_ASSOC);
        $res_new = array();
        if ($res) {
            for ($i = 0; $i < count($res); $i++) {
                $res[$i]['id'] = $res[$i]['product_id'];

                $res[$i]['store_amounts'] = $this->getProductStoreAmounts($res[$i]['id']);
                if ($i == 0 || ($i > 0 && $res[$i]['store_amounts'] > 0)) {


                    $res[$i]['last_price'] = null;

                    if (AFFILIATOR['price_type'] == 'price' && $res[$i]['affiliator_price'] > 0) {
                        $res[$i]['price'] = $res[$i]['affiliator_price'];
                    }

                    $res[$i]['affiliator_commission'] = $res[$i]['affiliator_price'] ? $res[$i]['price'] - $res[$i]['price_multi'] : $res[$i]['commission'];

                    if (AFFILIATOR['price_type'] == 'price_one' && $res[$i]['last_price_one'] > '0') {
                        $res[$i]['last_price'] = $res[$i]['price_one'];
                        $res[$i]['price_one'] = $res[$i]['last_price_one'];
                    }

                    if (AFFILIATOR['price_type'] == 'price_multi' && $res[$i]['last_price_multi'] > '0') {
                        $res[$i]['last_price'] = $res[$i]['price_multi'];
                        $res[$i]['price_multi'] = $res[$i]['last_price_multi'];
                    }

                    if ($res[$i]['last_price_multi'] > '0') {
                        $price_multi_last = $res[$i]['price_multi'];
                        $res[$i]['price_multi'] = $res[$i]['last_price_multi'];
                        $res[$i]['last_price_multi'] = $price_multi_last;
                    }

                    if ($res[$i]['api_id_to'] && $res[$i]['api_id_to'] != '0') {
                        if ($res[$i]['last_price_one'] > '0') {
                            $res[$i]['last_price'] = $res[$i]['price_one'];
                            $res[$i]['price_one'] = $res[$i]['last_price_one'];
                        }
                        $res[$i]['price'] = $res[$i]['price_one'];
                    } else {
                        $res[$i]['price'] = $res[$i][AFFILIATOR['price_type']];
                    }

                    $res[$i]['images'] = $this->getProductimgs($res[$i]['id']);

                    $res[$i]['meta_url'] = (trim($res[$i]['meta_url']) ? processTitle($res[$i]['meta_url']) : processTitle($res[$i]['product_name']));

                    $res[$i]['product_services'] = $this->getProduct_services($res[$i]['id']);
                    $res[$i]['product_group_data'] = $this->GetGroupData($res[$i]['id']);
                    $res[$i]['product_tags'] = $this->getProductTags($res[$i]['id']);
                    $res[$i]['offer_id'] = $this->getProduct_offer(
                            $res[$i]['id'],
                            $res[$i]['trademark_id'],
                            $res[$i]['product_services'],
                            $res[$i]['product_group_data']['id'],
                            $res[$i]['product_tags']
                    );
                    $res[$i]['coupon_id'] = $this->getProduct_coupon(
                            $res[$i]['id'],
                            $res[$i]['trademark_id'],
                            $res[$i]['product_services'],
                            "",
                            $res[$i]['product_group_data']['id'],
                            $res[$i]['product_tags']
                    );
                    $res[$i]['stores'] = $this->getProductStores($res[$i]['id'], true);
                    $res[$i]["product_type_name"] = $res[$i]['stores'][0]["name"];
                    if ($i == 0 || ($i > 0 && $res[$i]['price'] > 0)) {
                        array_push($res_new, $res[$i]);
                    }
                }
            }
        }
        return $res_new;
    }

    public function getProductOptions($product_id) {
        $affiliator_id = AFFILIATOR['id'];
        $sql = "SELECT 
                    po.* ,
                    pol.name 
                FROM product_options po
                LEFT JOIN product_options_langs pol ON pol.p_id = po.id  AND  pol.lang_code = :lang_code
                WHERE po.product_id  = :product_id and po.active='1' AND po.affiliator_id = :affiliator_id ";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':product_id', $product_id, PDO::PARAM_INT);
        $stmt->bindParam(':lang_code', $this->lang_code, PDO::PARAM_STR);
        $stmt->bindParam(':affiliator_id', $affiliator_id, PDO::PARAM_INT);
        $stmt->execute();

        $res = $stmt->fetchAll(PDO::FETCH_ASSOC);
        return $res ? $res : [];
    }

    public function getOneProduct($temp) {
        $sql = "SELECT 
                    p.* ,
                    ed.label as expiration_date_checked, 
                    pl.description as description ,
                    pl.promotional_description,
                    pl.brief_description, 
                    pl.name, 
                    pl.meta_title, 
                    pl.meta_url, 
                    pl.meta_description , 
                    al.name as attachment_name, 
                    a.color as attachment_color    , 
                    ap.price as affiliator_price 
                FROM products p 
                LEFT JOIN product_langs pl ON pl.product_id = p.id  AND  pl.lang_code = '{$this->lang_code}'
                LEFT JOIN attachments a ON a.id = p.attachment_id
                LEFT JOIN attachment_langs al ON al.attachment_id = p.attachment_id AND al.lang_code = '{$this->lang_code}'
                LEFT JOIN product_services ps ON ps.product_id = p.id
                LEFT JOIN affiliator_prices ap ON ap.product_id = p.id
                LEFT JOIN expiration_date ed ON (ed.product_id = p.id && ed.checked='1')
                WHERE p.id > 0  and p.active " . search_active('!=0');
        $sql .= $temp['product_id'] ? " AND p.id IN ({$temp['product_id']})  " : "";
        $sql .= $temp['searchCategoryId'] ? " AND ps.service_id IN  ({$temp['searchCategoryId']})  " : "";
        $sql .= $temp['searchTrademark_id'] ? " AND p.trademark_id =  '{$temp['searchTrademark_id']}'  " : "";
        $sql .= $temp['product_barcode'] ? " AND p.product_barcode =  '{$temp['product_barcode']}'  " : "";
        return $this->mDb->getRow($sql);
    }

    public function getOneProductDetails($temp) {
        $affiliator_stores = fetchArrayValue_from_dataBase(AFFILIATOR['stores'], 'id');
        if (!$temp['product_barcode'] && !$temp['product_id']) {
            return '';
        }
        $res = $this->getOneProduct($temp);
        if ($res) {

            $res['active'] = activeFormat($res['active']);
            $res['details_store_external'] = $this->getDetailsStoreExternalById($res['api_id_to']);
            $res['seller_name'] = $this->getSellerNameBySellerId($res['seller_id']);
            $res['favorites_id'] = $this->getFavoritesId($res['id']);
            $allProductCart = $this->getProductsCartClient();
            $inCart = $this->searchForColumn($res['id'], $allProductCart, 'product_id');
            if ($inCart != null) {
                $res['quantity_in_cart'] = $inCart['quantity'];
            } else {
                $res['quantity_in_cart'] = '0';
            }

            $res['last_price'] = null;

            if (AFFILIATOR['price_type'] == 'price' && $res['affiliator_price'] > 0) {
                $res['price'] = $res['affiliator_price'];
            }

            $res['affiliator_commission'] = $res['affiliator_price'] ? $res['price'] - $res['price_multi'] : $res['commission'];

            if (AFFILIATOR['price_type'] == 'price_one' && $res['last_price_one'] > '0') {
                $res['last_price'] = $res['price_one'];
                $res['price_one'] = $res['last_price_one'];
            }

            if (AFFILIATOR['price_type'] == 'price_multi' && $res['last_price_multi'] > '0') {
                $res['last_price'] = $res['price_multi'];
                $res['price_multi'] = $res['last_price_multi'];
            }

            if ($res['last_price_multi'] > '0') {
                $price_multi_last = $res['price_multi'];
                $res['price_multi'] = $res['last_price_multi'];
                $res['last_price_multi'] = $price_multi_last;
            }

            if ($res['api_id_to'] && $res['api_id_to'] != '0') {
                if ($res['last_price_one'] > '0') {
                    $res['last_price'] = $res['price_one'];
                    $res['price_one'] = $res['last_price_one'];
                }
                $res['price'] = $res['price_one'];
            } else {
                $res['price'] = $res[AFFILIATOR['price_type']];
            }

            $res['images'] = $this->getProductimgs($res['id']);

            $trademark = $this->getTrademarkData($res['trademark_id']);
            $res['trademark_image'] = $trademark['image'];
            $res['trademark_title'] = $trademark['title'];

            $res['added_listiner_available'] = $this->checkUserHaveListenToProductAvailability($res['id']) ? true : false;

            $res['expiration_date_checked'] = $this->getProductTypesStores($res['id']);

            $res['form_shapes_Details'] = $this->getFormShapeDetailsForProduct($res['id']);

            if (count($res['expiration_date_checked']) > 0) {
                $form_value = '';
                for ($i = 0; $i < count($res['expiration_date_checked']); $i++) {
                    if ($res['expiration_date_checked'][$i]['expiration_date'] && $res['expiration_date_checked'][$i]['store_amounts'] > 0) {
                        $form_value = $form_value ? $form_value . ' - ' . $res['expiration_date_checked'][$i]['expiration_date'] : $res['expiration_date_checked'][$i]['expiration_date'];
                    }
                }
                if ($form_value != '') {
                    array_unshift($res['form_shapes_Details'], ['form_name' => $this->lang_code == 'ar' ? 'تاريخ الصلاحية' : 'Expiration date', 'form_value' => $form_value]);
                }
            }


            $res['store_amounts'] = $this->getProductStoreAmounts($res['id'], $affiliator_stores);
            $res['stores'] = $this->getProductStores($res['id'], true);
            $breaks = array("<br />", "<br>", "<br/>", "</p>");
            $res['description_strip_tags'] = str_replace($breaks, " \n\n ", $res['description']);
            $res['description_strip_tags'] = strip_tags($res['description_strip_tags']);
            $res['description'] = nl2br($res['description']);
            $breaks = array("<br />", "<br>", "<br/>", "</p>", "</div>");
            $res['promotional_description_strip_tags'] = str_replace($breaks, " \r\n ", $res['promotional_description']);
            $res['promotional_description_strip_tags'] = str_replace("&nbsp;", "  ", $res['promotional_description_strip_tags']);
            $res['promotional_description_strip_tags'] = strip_tags($res['promotional_description_strip_tags']);
            $res['promotional_description'] = nl2br($res['promotional_description']);

            $breaks = array("<br />", "<br>", "<br/>", "</p>", "</div>");
            $res['brief_description_strip_tags'] = str_replace($breaks, " \r\n ", $res['brief_description']);
            $res['brief_description_strip_tags'] = str_replace("&nbsp;", "  ", $res['brief_description_strip_tags']);
            $res['brief_description_strip_tags'] = strip_tags($res['brief_description_strip_tags']);
            $res['brief_description'] = nl2br($res['brief_description']);

            $res['product_services'] = $this->getProduct_services($res['id']);
            $res['ser_name'] = fetchArrayValue_from_dataBase($res['product_services'], 'ser_name');

            $res['product_group_data'] = $this->GetGroupData($res['id']);
            $res['product_tags'] = $this->getProductTags($res['id']);
            $res['offer_id'] = $this->getProduct_offer(
                    $res['id'],
                    $res['trademark_id'],
                    $res['product_services'],
                    $res['product_group_data']['id'],
                    $res['product_tags']
            );

            if ($res['offer_id']) {
                $res['offer_data'] = $this->offersObj->getOneOffer($res['offer_id'], 'Dont_trim_attachment_single');

                $res['package_data'] = $this->offersObj->getPackageData($res['offer_id'], $res['id']);
            } else {
                $res['offer_data'] = null;
                $res['package_data'] = null;
                $res['offer_id'] = '0';
            }

            $res['coupon_id'] = $this->getProduct_coupon(
                    $res['id'],
                    $res['trademark_id'],
                    $res['product_services'],
                    "",
                    $res['product_group_data']['id'],
                    $res['product_tags']
            );
            if ($res['coupon_id']) {
                $res['coupon_data'] = $this->offersObj->getOneCoupon($res['coupon_id']);
            } else {
                $res['coupon_data'] = null;
            }

            $res['meta_url'] = (trim($res['meta_url']) ? processTitle($res['meta_url']) : processTitle($res['name']));
            $res['product_options'] = $this->getProductOptions($res['id']);
        }
        return $res;
    }

    public function getOneProductTitle($temp) {

        if (!$temp['product_barcode'] && !$temp['product_id']) {
            return '';
        }
        $sql = "SELECT 
                    p.id , 
                    pl.name,
                    pl_ar.name AS name_ar ,
                    pl_en.name AS name_en, 
                    pl.meta_url,
                    pl.description ,
                    p.key_words 
                FROM products p 
                LEFT JOIN product_langs pl ON pl.product_id = p.id AND pl.lang_code = :lang_code
                LEFT JOIN product_langs pl_ar ON pl_ar.product_id = p.id AND pl_ar.lang_code = 'ar'
                LEFT JOIN product_langs pl_en ON pl_en.product_id = p.id AND pl_en.lang_code = 'en'
                WHERE p.id > 0 AND p.active " . search_active('!=0') . " AND p.id = :product_id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':lang_code', $this->lang_code);
        $stmt->bindParam(':product_id', $temp['product_id']);
        $stmt->execute();
        $res = $stmt->fetch(PDO::FETCH_ASSOC);
        if ($res) {
            $res['meta_url'] = processTitle($res['meta_url'] ?: $res['name']);
            $res['name_ar'] = processTitle($res['name_ar']);
            $res['name_en'] = processTitle($res['name_en']);
        }
        return $res;
    }

//    public function getOneProductTitle($temp) {
//
////        header('Content-type text/html; charset=UTF-8');
//
//        if (!$temp['product_barcode'] && !$temp['product_id']) {
//            return '';
//        }
//        $sql = "SELECT `p`.id , pl.name,pl_ar.name AS name_ar ,pl_en.name AS name_en, pl.meta_url,pl.description ,p.key_words FROM `products` p ";
////   sl.ser_name   ******************************************
//        $sql .= " LEFT JOIN `product_langs` pl ON pl.product_id = p.id  AND  pl.lang_code = '{$this->lang_code}' ";
//        $sql .= " LEFT JOIN `product_langs` pl_ar ON pl_ar.product_id = p.id  AND  pl_ar.lang_code = 'ar' ";
//        $sql .= " LEFT JOIN `product_langs` pl_en ON pl_en.product_id = p.id  AND  pl_en.lang_code = 'en' ";
//        $sql .= " WHERE   p.id > 0  and p.active != '0' ";
//        $sql .= " AND p.id ='{$temp['product_id']}'  ";
//// echo $sql."<hr>";
//        $res = $this->mDb->getRowPDO($sql);
//        if ($res) {
//            $res['meta_url'] = processTitle($res['meta_url'] ?: $res['name']);
//            $res['name_ar'] = processTitle($res['name_ar']);
//            $res['name_en'] = processTitle($res['name_en']);
//        }
//        return $res;
//    }

    function getFromShapeVAlus($product_id, $form_shape_id = '') {
        $sql = "SELECT form_shape_id ,value FROM `product_form_shapes` ";
        $sql .= " where product_id = '{$product_id}' and value !=''  ";
        $sql .= $form_shape_id > 0 ? "  AND form_shape_id in ({$form_shape_id}) " : " ";
        $sql .= !$form_shape_id ? " group by form_shape_id   " : " ";
        return $this->mDb->getAll($sql);
    }

    function getFromShapeLangsVAlus($value) {
        $sql = "SELECT label FROM `form_shape_option_langs`  where   form_shape_option_id  in ({$value})    AND  lang_code = '{$this->lang_code}'   ";
// echo  $sql;
        return $this->mDb->getAll($sql);
    }

    public function getFormShapeDetailsForProduct($product_id) {


        $forms = $this->getFromShapeVAlus($product_id, '');
        for ($i = 0; $i < count($forms); $i++) {

            $sql = "SELECT type FROM `form_shapes`  where id ='{$forms[$i]['form_shape_id']}'  ";
            $forms[$i]['type'] = $this->mDb->getOne($sql);

            $sql = "SELECT label FROM `form_shape_langs`  where   form_shape_id ='{$forms[$i]['form_shape_id']}' AND  lang_code = '{$this->lang_code}'   ";
            $forms[$i]['form_name'] = $this->mDb->getOne($sql);

            if ($forms[$i]['type'] == 'm_select' || $forms[$i]['type'] == 'select') {

                if ($forms[$i]['type'] == 'm_select') {
                    $form_selected_ids = $this->getFromShapeVAlus($product_id, $forms[$i]['form_shape_id']);
                    $form_value = $this->getFromShapeLangsVAlus(fetchArrayValue_from_dataBase($form_selected_ids, 'value'));
                } else {
                    $form_value = $this->getFromShapeLangsVAlus($forms[$i]['value']);
                }
// p($form_value);
                $forms[$i]['form_value'] = '';

// 
                for ($l = 0; $l < count($form_value); $l++) {
                    if ($form_value[$l]['label']) {
                        $forms[$i]['form_value'] .= $form_value[$l]['label'] . ' - ';
                    }
                }
                if ($forms[$i]['form_value']) {
                    $forms[$i]['form_value'] = substr($forms[$i]['form_value'], 0, -2);
                }
            } else if ($forms[$i]['type'] == 'number' || $forms[$i]['type'] == 'text' || $forms[$i]['type'] == 'date') {
                $forms[$i]['form_value'] = $forms[$i]['value'];
            }
        }
        return $forms;
    }

    public function getProductTypesStores($id, $name = '') {
        $sql = "SELECT  ps.name,ps.store_id,ps.expiration_date,sl.title as store_title  FROM product_stores ps ";
        $sql .= " LEFT JOIN `store_langs` sl ON sl.store_id = ps.store_id   AND sl.lang_code = '{$this->lang_code}' ";

        $sql .= " WHERE ps.`product_id` = '{$id}' AND ps.`is_deleted` = '0'    ";

        $sql .= $name ? " AND ps.`name` = '{$name}' " : '';
        $sql .= "   group by ps.store_id,ps.name,ps.expiration_date ";
        $sql .= " ORDER BY ps.expiration_date ASC  ";

        $res = $this->mDb->getAll($sql);
        for ($i = 0; $i < count($res); $i++) {
            $res[$i]['store_amounts'] = $this->getProductStoreAmounts($id, $res[$i]['store_id'], $res[$i]['name'], $res[$i]['expiration_date']);
# code...
        }
        return $res;
    }

    public function getExpirationDateCheckedForProduct($product_id) {
        $sql = "SELECT label FROM `expiration_date`  where   checked ='1' AND  product_id = '{$product_id}'   ";
        $sql .= " ORDER BY sort ASC  ";
        $res = $this->mDb->getAll($sql);
        return $res;
    }

//  function getProduct_offer($product_id, $trademark_id, $product_services) {
//    $now = date('Y-m-d');
//
//    // بناء استعلام SQL لجلب العروض
//    $sql = "SELECT p.id, p.priority 
//        FROM `offers` p
//        LEFT JOIN `offer_discount` od ON p.id = od.offer_id 
//        LEFT JOIN `offer_x_y` oxy ON p.id = oxy.offer_id
//        WHERE p.active != '0' 
//            AND (p.`affiliator_id` = :affiliator_id OR p.`affiliator_id` = '0') 
//            AND p.price_type = :price_type
//            AND (p.`offer_start_date` <= :now OR p.`offer_start_date` IS NULL)  
//            AND (p.`offer_end_date` >= :now OR p.`offer_end_date` IS NULL) 
//            AND (p.`show_on` = :show_on OR p.`show_on` = 'both') 
//            AND (
//                (od.apply_type_conditions = 'cart') 
//                OR (od.`ids` LIKE CONCAT('%,', :product_id, ',%') AND od.apply_type_conditions = 'products') 
//                OR (od.`ids` LIKE CONCAT('%,', :trademark_id, ',%') AND od.apply_type_conditions = 'trademarks')
//                OR (od.`ids` LIKE '%,-1,%' AND od.apply_type_conditions = 'services' AND FIND_IN_SET(od.`ids`, :service_ids) > 0)
//            )
//            AND (
//                (oxy.`x_ids` LIKE CONCAT('%,', :product_id, ',%') AND oxy.x_types = 'products') 
//                OR (oxy.`x_ids` LIKE CONCAT('%,', :trademark_id, ',%') AND oxy.x_types = 'trademarks')
//                OR (oxy.`x_ids` LIKE '%,-1,%' AND oxy.x_types = 'services' AND FIND_IN_SET(oxy.`x_ids`, :service_ids) > 0)
//            )
//        ORDER BY p.priority DESC 
//        LIMIT 1";
//
//    // تحضير معلمات الاستعلام
//    $service_ids = implode(',', array_map(function ($service) {
//        return $service['service_id'];
//    }, $product_services));
//
//    $params = [
//        'product_id' => $product_id,
//        'trademark_id' => $trademark_id,
//        'service_ids' => $service_ids,
//        'affiliator_id' => AFFILIATOR['id'],
//        'price_type' => AFFILIATOR['price_type'],
//        'now' => $now,
//        'show_on' => SETFROM,
//    ];
//
//    // تنفيذ الاستعلام
//    $offers = $this->mDb->getAll($sql, $params);
//
//    // التحقق من النتيجة
//    if (!empty($offers)) {
//        return $offers[0]['id'];
//    } else {
//        return '';
//    }
//}
    public function getProduct_offer(
            $product_id,
            $trademark_id,
            $product_services,
            $product_group_id,
            $product_tags
    ) {

        $now = date('Y-m-d');
        $affiliator_id = AFFILIATOR['id'];
        $setfrom = SETFROM;
        $price_type = AFFILIATOR['price_type'];

        $offer_discount = $this->getOfferDiscount(
                $product_id,
                $trademark_id,
                $product_services,
                $product_group_id,
                $product_tags,
                $now,
                $affiliator_id,
                $setfrom,
                $price_type
        );
        $offer_x_y = $this->getoffer_x_y(
                $product_id,
                $trademark_id,
                $product_services,
                $product_group_id,
                $product_tags,
                $now,
                $affiliator_id,
                $setfrom,
                $price_type
        );
        if ($offer_discount[0]['priority'] > $offer_x_y[0]['priority']) {
            return $offer_discount[0]['id'];
        } else if ($offer_discount[0]['priority'] <= $offer_x_y[0]['priority']) {
            return $offer_x_y[0]['id'];
        } else {
            return '';
        }
    }

    public function getProduct_coupon(
            $product_id,
            $trademark_id,
            $product_services,
            $couponId = '',
            $product_group_id,
            $product_tags
    ) {
        $affiliator_id = AFFILIATOR['id'];
        $price_type = AFFILIATOR['price_type'];
        $setfrom = SETFROM;
        $client_id = CLIENT['id'] ?? 0;
        $client_group_id = CLIENT['group_id'];
        $now = date('Y-m-d');
        $sql = "SELECT 
                    c.id  ,
                    c.priority  
                FROM coupons c
                LEFT JOIN coupon_discount cd ON c.id = cd.coupon_id
                WHERE c.id  > 0
                    AND (c.affiliator_id = :affiliator_id) 
                    AND (c.price_type = :price_type)
                    AND (
                                c.coupon_start_date <= :now
                            OR  c.coupon_start_date is Null     
                            OR  c.coupon_start_date = '0000-00-00' 
                        )
                    AND ( 
                                c.coupon_end_date >= :now  
                            OR  c.coupon_end_date is Null 
                            OR  c.coupon_end_date = '0000-00-00' 
                        )
                    AND  (
                                (cd.apply_type_conditions = 'cart' ) 
                            OR ( cd.ids LIKE :product_id AND  cd.apply_type_conditions = 'products')
                            OR ( cd.ids LIKE :trademark_id AND  cd.apply_type_conditions = 'trademarks' )
                            OR ( cd.ids LIKE :product_group_id AND cd.apply_type_conditions = 'product_group')
                            OR ( cd.ids LIKE '%,-1,%' )
                            OR (";

        foreach ($product_services as $index => $service) {
            $param = ":service_id_{$index}";
            $sql .= " (cd.ids LIKE $param) OR";
        }
        $sql = rtrim($sql, 'OR');
        $sql .= " AND cd.apply_type_conditions = 'services' ) ";
        $sql .= $product_tags ? " OR (" : '';
        if ($product_tags) {
            foreach ($product_tags as $index => $tag) {
                $param = ":product_tag_{$index}";
                $sql .= "(cd.ids LIKE $param) OR";
            }
            $sql = rtrim($sql, 'OR');
        } else {
            $sql .= ")";
        }
        $product_tags ? $sql .= " AND cd.apply_type_conditions = 'tags' )
            )" : '';

        $sql .= $couponId ? " AND c.id = :couponId " : " AND c.active='1' AND c.marketing_coupon='0' ";
        $sql .= $client_id ? '  AND  (
                                        ( 
                                                c.client_type ="specific_clients" 
                                            AND c.client_type_id LIKE :client_id 
                                        )
                                        OR ( 
                                                    c.client_type ="group" 
                                                AND c.client_type_id  LIKE :client_group 
                                            ) 
                                        OR ( 
                                                    c.client_type ="all" 
                                                AND c.client_type_id =",," 
                                            )
                                        ) ' : '';
        $sql .= !$client_id ? '  AND ( c.client_type ="visitors" AND c.client_type_id =",," )' : '';

        $sql .= " ORDER BY c.priority DESC LIMIT 1";
        $stmt = $this->mDb->connect()->prepare($sql);
        $couponId ? $stmt->bindValue(':couponId', $couponId) : '';
        if ($client_id) {
            $stmt->bindValue(':client_id', '%,' . $client_id . ',%');
            $stmt->bindValue(':client_group', '%,' . $client_group_id . ',%');
        }
        $stmt->bindValue(':product_id', '%,' . $product_id . ',%');
        $stmt->bindValue(':affiliator_id', $affiliator_id);
        $stmt->bindValue(':price_type', $price_type);
        $stmt->bindValue(':setfrom', $setfrom);
        $stmt->bindValue(':trademark_id', '%,' . $trademark_id . ',%');
        $stmt->bindValue(':product_group_id', '%,' . $product_group_id . ',%');
        $stmt->bindValue(':now', $now);

        foreach ($product_services as $index => $service) {
            if ($service != '0') {
                $param = ":service_id_{$index}";
                $stmt->bindValue($param, '%,' . $service['parent'] . ',%');
            } else {
                $param = ":service_id_{$index}";
                $stmt->bindValue($param, '%,' . $service['service_id'] . ',%');
            }
        }
        if ($product_tags) {
            foreach ($product_tags as $index => $tag) {
                $param = ":product_tag_{$index}";
                $stmt->bindValue($param, '%,' . $tag['id'] . ',%');
            }
        }
        $stmt->execute();
        $coupon_discount = $stmt->fetchAll(PDO::FETCH_ASSOC);
        return $coupon_discount[0]['id'];
    }

    function getTrademarkData($trademark_id) {
        $sql = "SELECT t.image ,tl.title  FROM trademarks t";
        $sql .= " LEFT JOIN `trademark_langs` tl ON t.id = tl.trademark_id    AND  tl.lang_code = 'ar' ";
        $sql .= " WHERE t.id = '{$trademark_id}' ";
        return $this->mDb->getRow($sql);
    }

// public function deleteProductStores($ids)
// {
//     $sql = "DELETE FROM `product_stores` ";
//     $sql .= " WHERE `id` = 0    ";
//     foreach ($ids as $id) {
//         $sql .= " || `id` = '{$id}' ";
//         //**VIP***
//         // $product_id = $this->getProduct_idByProduct_store_id($id);
//         // // refresh Quantity To Open CART WITH STORE 1
//         // $row =  $this->getStatisticsFroProduct($product_id);
//         // $total  =  ($row['total_add_amount_product'] * 1) -  ($row['total_sell_amount_product'] * 1);
//         // $this->refreshQuantityProductToOpenCart($product_id, $total);
//         //**VIP***
//     }
//     // echo "$sql";die();
//     return $this->mDb->query($sql);
// }
// public function getProduct_idByProduct_store_id($id)
// {
//     $sql = "SELECT product_id FROM product_stores  ";
//     $sql .= " WHERE `id` = '{$id}'    ";
//     return $this->mDb->getOne($sql);
// }



    public function checkUserHaveListenToProductAvailability($product_id, $email = '') {
        $sql = "SELECT id FROM product_availability_notices ";
        $sql .= "WHERE `product_id` = :product_id ";
        $sql .= "AND `affiliator_id` = :affiliator_id ";
        $sql .= "AND (`client_id` = :client_id ";

        if ($email !== '') {
            $sql .= " OR `email` = :email ";
        }

        $sql .= ") AND `notify_status` = 'not_send'";

        // تحضير الاستعلام
        $stmt = $this->mDb->connect()->prepare($sql);

        // تعريف المتغيرات وتعيينها للقيم المطلوبة
        $affiliatorId = AFFILIATOR['id'] ?? 0;
        $clientId = CLIENT['id'] ?? 0;

        // ربط القيم
        $stmt->bindParam(':product_id', $product_id, PDO::PARAM_INT);
        $stmt->bindParam(':affiliator_id', $affiliatorId, PDO::PARAM_INT);
        $stmt->bindParam(':client_id', $clientId, PDO::PARAM_INT);

        if ($email !== '') {
            $stmt->bindParam(':email', $email, PDO::PARAM_STR);
        }


        $stmt->execute();

        // استرجاع أول عمود (id)
        return $stmt->fetchColumn();
    }

    public function addListenToProductAvailability($temp) {
        $sql = "INSERT `product_availability_notices` SET ";
        $sql .= " `product_id` ='{$temp['product_id']}' ";
        $sql .= ", `note` ='{$temp['note']}'";
        $sql .= $temp['email'] ? ", `email` ='{$temp['email']}' " : "";
        $sql .= ", `notify_status` ='not_send'";
        $sql .= " ,  `affiliator_id` =  " . AFFILIATOR['id'] . "";
        $sql .= ",  `client_id` =  " . CLIENT['id'] . " ";
        $sql .= " ,  `set_from` =  '" . SETFROM . "'  ";
        $sql .= " , `date_added` = '{$this->dateTime}'";
//        echo $sql;
// die();
        return $this->mDb->query($sql);
    }

    public function getProductimgs($id, $aLimit = '') {
//        $time = time();
        $sql = "SELECT name ,type,date_added   FROM product_medias  ";
        $sql .= " WHERE `product_id` = '{$id}'  ";
        $sql .= $aLimit ? " LIMIT  0, {$aLimit} " : '';

        $res = $this->mDb->getAll($sql);
        for ($i = 0; $i < count($res); $i++) {
            if ($res[$i]["name"] != '') {
                $res[$i]["original_name"] = $res[$i]["name"];
                $res[$i]["name"] = $res[$i]["name"] . "?t=" . strtotime($res[$i]["date_added"]);
//                $res[$i]["name"] = $res[$i]["name"] . "?t=" . $time;
            }
        }
        return $res;
    }

    public function getProduct_services($id) {
//        $sql = "SELECT ps.service_id  , s.parent ,s.service_system_commission    FROM product_services  ps "; //VIP
//        $sql .= " LEFT JOIN `services` s ON s.id = ps.service_id  ";
//        $sql .= " LEFT JOIN `service_langs` sl ON sl.service_id = ps.service_id  AND  sl.lang_code = '{$this->lang_code}'  ";
//
//        $sql .= " WHERE  s.active = '1' and `product_id` = '{$id}' order by s.service_system_commission  asc  ";

        $sql = "SELECT  ps.service_id , s.id ,sch.expiration_date parent_expiration_date, sl.ser_name , slch.ser_name as parent_name , s.parent ,s.service_system_commission  FROM product_services ps ";
        $sql .= " LEFT JOIN `services` s ON s.id = ps.service_id  ";
        $sql .= " LEFT JOIN `service_langs` sl ON sl.service_id = s.id  AND sl.lang_code = '{$this->lang_code}'";
        $sql .= " LEFT JOIN `services` sch ON sch.id = s.parent ";
        $sql .= " LEFT JOIN `service_langs` slch ON slch.service_id = sch.id AND sl.lang_code = '{$this->lang_code}' ";
        $sql .= " WHERE ps.`product_id` = '{$id}' Group by s.id  order by s.service_system_commission  asc  ";

        return $this->mDb->getAll($sql);
    }

    public function getProduct_servicesIds($ids, $column = 'id') {
        // التحقق من أن المعرفات هي مصفوفة
        if (!is_array($ids) || empty($ids)) {
            return []; // إرجاع مصفوفة فارغة إذا كانت الإدخالات غير صالحة
        }

        // تحويل المصفوفة إلى سلسلة من القيم مفصولة بـ , (لاستعمالها في الاستعلام)
        $placeholders = implode(',', array_fill(0, count($ids), '?'));

        // بناء الاستعلام مع المعاملات المعدة مسبقًا
        $sql = "SELECT s.{$column} FROM product_services ps ";
        $sql .= "LEFT JOIN `services` s ON s.id = ps.service_id ";
        $sql .= "WHERE s.active = '1' AND ps.product_id IN ({$placeholders}) GROUP BY s.id";
        // تحضير الاستعلام
        $stmt = $this->mDb->connect()->prepare($sql);
        // ربط المعاملات
        foreach ($ids as $index => $id) {
            $stmt->bindValue($index + 1, $id, PDO::PARAM_INT); // ربط المعرفات بالقيم
        }
        // تنفيذ الاستعلام
        $stmt->execute();
//        echoSql($stmt);
        return $stmt->fetchAll(PDO::FETCH_ASSOC);
    }

//    public function getProduct_servicesIds($ids, $column = 'id') {
//        $sql = "SELECT s.{$column} FROM product_services  ps "; //VIP
//        $sql .= " LEFT JOIN `services` s ON s.id = ps.service_id  ";
//        $sql .= " WHERE  s.active = '1' and `product_id` in ({$ids})  group by s.id   ";
////   echo $sql ; 
//        return $this->mDb->getAll($sql);
//    }
// stores
//    public function getProductStores($product_id, $fromDetails = '') {
//
//        $affiliator_stores = fetchArrayValue_from_dataBase(AFFILIATOR['stores'], 'id');
//// p($affiliator_stores);
//        $sql = "SELECT  psa.name,psa.store_id,sl.title as store_title,IFNULL(psa.store_amounts,0) AS store_amounts_product FROM `product_stores_amounts` psa";
//        $sql .= " LEFT JOIN `stores` s ON s.id = psa.store_id    ";
//        $sql .= " LEFT JOIN `store_langs` sl ON sl.store_id = psa.store_id   AND sl.lang_code = 'ar' ";
//        $sql .= " WHERE  psa.`product_id` =   '{$product_id}'  and s.active = '1'  ";
//        $sql .= " AND psa.`store_id` in  ({$affiliator_stores})  ";
//        $sql .= $fromDetails ? " Group BY p.name" : " ";
////    echo  $fromDetails ;die();
//        $res = $this->mDb->getAll($sql);
//
//        return $res;
//    }

    public function getProductStores($product_id, $fromDetails = '', $typeStore = '', $aStart = '', $aLimit = '', $sort = '', $type = '', $searchName = '', $searchDateFrom = '', $searchDateTo = '') {

        $affiliator_stores = fetchArrayValue_from_dataBase(AFFILIATOR['stores'], 'id');
// p($affiliator_stores);
        $sql = "SELECT   p.name   , p.store_id,p.expiration_date, sl.title as store_title FROM `product_stores_amounts` p";
        $sql .= " LEFT JOIN `stores` s ON s.id = p.store_id    ";

        $sql .= " LEFT JOIN `store_langs` sl ON sl.store_id = p.store_id   AND sl.lang_code = 'ar' ";
        $sql .= " WHERE   p.`product_id` =   '{$product_id}'  and s.active = '1' and s.show_store_amounts='1' ";
        $sql .= " AND p.`store_id` in  ({$affiliator_stores})  ";

        $sql .= $searchName ? ' AND ( pt.`name` like "% ' . $searchName . ' %" || sl.`title` like "%' . $searchName . '%") ' : '';
        $sql .= $searchDateFrom ? " AND p.`date_added`   >= '{$searchDateFrom}' " : "";
        $sql .= $searchDateTo ? " AND p.`date_added`  <= '{$searchDateTo}' " : "";

        $sql .= $typeStore ? " AND p.`type` =  '{$typeStore}'" : "";
        $sql .= $fromDetails ? " Group BY p.name  " : " ";
        $sql .= $sort ? " ORDER BY p.{$sort} {$type}" : " ";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
//    echo  $sql."<hr>";
        $res = $this->mDb->getAll($sql);

        if ($res) {
            for ($i = 0; $i < count($res); $i++) {
                $store_amounts_product = $this->getProductStoreAmounts($product_id, $affiliator_stores, $res[$i]['name'], 'all_date');
//                $store_amounts_product = $this->getProductStoreAmounts($product_id, $res[$i]['store_id'], $res[$i]['name'], $res[$i]['expiration_date']);
                $res[$i]['store_amounts_product'] = $store_amounts_product > 0 ? $store_amounts_product : 0;
            }
        }
        return $res;
    }

    public function getProductStoresCount(
            $product_id,
            $fromDetails = '',
            $typeStore = '',
            $aStart = '',
            $aLimit = '',
            $sort = '',
            $type = '',
            $searchName = '',
            $searchDateFrom = '',
            $searchDateTo = ''
    ) {
        $affiliator_stores = fetchArrayValue_from_dataBase(AFFILIATOR['stores'], 'id');
        $sql = "SELECT DISTINCT 
                    p.name , 
                    p.store_id, 
                    sl.title as store_title 
                FROM product_stores p
                LEFT JOIN stores s ON s.id = p.store_id
                LEFT JOIN store_langs sl 
                    ON sl.store_id = p.store_id   
                    AND sl.lang_code = 'ar'
                WHERE   p.is_deleted = '0'  
                    AND p.product_id = '{$product_id}'  AND s.active = '1'
                AND p.store_id in  ({$affiliator_stores})";
        $sql .= $searchName ? ' AND ( p.`name` like "% ' . $searchName . ' %" || sl.`title` like "%' . $searchName . '%") ' : '';
        $sql .= $searchDateFrom ? " AND p.`date_added`   >= '{$searchDateFrom}' " : "";
        $sql .= $searchDateTo ? " AND p.`date_added`  <= '{$searchDateTo}' " : "";

        $sql .= $typeStore ? " AND p.`type` =  '{$typeStore}'" : "";
        $sql .= $fromDetails ? " Group BY p.name " : " ";
        $sql .= $sort ? " ORDER BY p.{$sort} {$type}" : " ";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
        $res = count($this->mDb->getAll($sql));
        return $res;
    }

// 'none','order','order_refund','sale-invoice','receipt-return-invoice','sale-return-invoice','receipt-invoice','mortal-invoice','settlement-invoice','inventory-invoice','merchant-return-invoice','merchant-supply-invoice'
    public function addEditProduct_stores($temp, $dateTime = '') {
        $dateTime = $dateTime ? $dateTime : $this->dateTime;
// echo $this->time;
// echo "<pre>";print_r($temp);die();



        $sql = "INSERT INTO `product_stores` SET ";
        foreach ($this->mDb->getCols('product_stores', $temp) as $k => $v) {
            $sql .= ($k == 'medias' or $k == 'id' or $k == 'lang_Details') ? "" : "`{$k}`='{$v}',";
        }
        $sql .= " `date_added` = '{$dateTime}' ";
//   echo $sql;die();

        $res = $this->mDb->query($sql);

        if ($res) {

// //**VIP***
// // refresh Quantity To Open CART WITH STORE 1
// $row =  $this->getStatisticsFroProduct($temp['product_id']);
// $total  =  ($row['total_add_amount_product'] * 1) -  ($row['total_sell_amount_product'] * 1);
// $this->refreshQuantityProductToOpenCart($temp['product_id'], $total);
// //**VIP***
        }
        return $res;
    }

    public function addEditProductStoresAmounts($temp, $dateTime = '') {
        $dateTime = $dateTime ? $dateTime : $this->dateTime;
        $oldData = $this->getProductStoresAmountsByData($temp);

        $new_store_amounts = 0;

        if ($temp['type'] == 'add') {
            $new_store_amounts = (floatval($oldData['store_amounts']) + floatval($temp['value']));
        } else if ($temp['type'] == 'remove') {
            $new_store_amounts = (floatval($oldData['store_amounts']) - floatval($temp['value']));
        }

        $new_store_amounts = $new_store_amounts >= 0 ? $new_store_amounts : 0;

        if (!$oldData['id']) {
            if ($temp['expiration_date'] && $new_store_amounts > 0 || !$temp['expiration_date']) {
                $sql = "INSERT INTO `product_stores_amounts` SET ";
                $sql .= "`product_id`='{$temp['product_id']}',`store_id`='{$temp['store_id']}'";
                $sql .= $temp['expiration_date'] ? ",`expiration_date`='{$temp['expiration_date']}'" : "";
                $sql .= ",`name`='{$temp['name']}',`store_amounts`='{$new_store_amounts}' ";
                $sql .= " ,`date_added` = '{$dateTime}' ";
//            echo $sql . "<hr>";
                return $this->mDb->query($sql);
            }
        } else {
            if ($temp['expiration_date'] && $new_store_amounts == 0) {
                $sql = "DELETE From `{$this->mPrefix}product_stores_amounts`   ";
                $sql .= "where id ='{$oldData['id']}'";
                return $this->mDb->query($sql);
            } else {
                $sql = "UPDATE  `product_stores_amounts` SET ";
                $sql .= " store_amounts='{$new_store_amounts}'";
                $sql .= " ,`date_added` = '{$dateTime}' ";
                $sql .= " where `id` = '{$oldData['id']}' ";
//                  echo $sql."<hr>";
//                 echo $temp['type']."<hr>";
                return $this->mDb->query($sql);
            }
        }
    }

    public function removeProductStoresAmountsQuantityOnShelf($temp, $status = '', $last_status = '') {
        $oldData = $this->getProductStoresAmountsByData($temp);
        $new_quantity_on_shelf = $oldData['quantity_on_shelf'] ? $oldData['quantity_on_shelf'] : 0;
        $new_quantity_reserved = $oldData['quantity_reserved'] ? $oldData['quantity_reserved'] : 0;
        if ($temp['for_type'] == 'sale-invoice') {
            if (($status == 'pending' || $status == 'waiting_confirm' || $status == 'confirmed' || $status == 'under_prepare' || $status == 'booked_up')) {
                $new_quantity_reserved = (floatval($oldData['quantity_reserved']) - floatval($temp['value']));
                $new_quantity_on_shelf = (floatval($oldData['store_amounts']) + floatval($new_quantity_reserved));
            } else {
                $new_quantity_reserved = floatval($oldData['quantity_reserved']) - floatval($temp['value']);
            }
        } else if ($temp['for_type'] == 'sale-return-invoice') {
            $new_quantity_reserved = (floatval($oldData['quantity_reserved']) + floatval($temp['value']));
            $new_quantity_on_shelf = (floatval($oldData['store_amounts']) + floatval($new_quantity_reserved));
        } else if ($temp['for_type'] == 'receipt-invoice') {
            $new_quantity_on_shelf -= floatval($temp['value']);
        }
        $new_quantity_on_shelf = $new_quantity_on_shelf >= 0 ? $new_quantity_on_shelf : 0;
        $new_quantity_reserved = $new_quantity_reserved >= 0 ? $new_quantity_reserved : 0;
        if (($status == 'canceled') && (in_array($last_status, ['delivery_failed', 'delivered', 'ready_to_delivered', 'prepared', 'in_delivered']))) {
            $new_quantity_on_shelf += floatval($temp['value']);
        }
        $sql = "UPDATE  `product_stores_amounts` SET ";
        $sql .= " quantity_on_shelf='{$new_quantity_on_shelf}'";
        $sql .= " ,quantity_reserved='{$new_quantity_reserved}'";
        $sql .= " where `id` = '{$oldData['id']}' ";
        return $this->mDb->query($sql);
    }

    public function addProductStoresAmountsQuantityOnShelf($temp, $status, $id = '') {
        $oldData = $this->getProductStoresAmountsByData($temp);
        $new_quantity_on_shelf = $oldData['quantity_on_shelf'] ? $oldData['quantity_on_shelf'] : 0;
        $new_quantity_reserved = $oldData['quantity_reserved'] ? $oldData['quantity_reserved'] : 0;
        if (in_array($temp['for_type'], ['receipt-invoice', 'sale-return-invoice', 'settlement-invoice'])) {
            $new_quantity_on_shelf += $temp['value'];
            $res = $this->UpdateProductStoreAmountAsAdvanced($new_quantity_on_shelf, $new_quantity_reserved, $oldData['id'], '');
        } elseif ($temp['for_type'] == 'sale-invoice') {
            if (in_array($status, ['delivery_failed', 'delivered', 'ready_to_delivered', 'prepared', 'in_delivered'])) {
                $sql = "SELECT is_quantity_changed_on_status FROM invoices WHERE id = :id";
                $stmt = $this->mDb->connect()->prepare($sql);
                $stmt->bindParam(':id', $id, PDO::PARAM_INT);
                $stmt->execute();
                $result = $stmt->fetch(PDO::FETCH_ASSOC);
                if ($result['is_quantity_changed_on_status'] == 0) {
                    $sql = 'UPDATE invoices SET is_quantity_changed_on_status = "1" WHERE id = :id';
                    $stmt = $this->mDb->connect()->prepare($sql);
                    $stmt->bindParam(':id', $id, PDO::PARAM_INT);
                    $stmt->execute();
                    $new_quantity_on_shelf -= $temp['value'];
                    $res = $this->UpdateProductStoreAmountAsAdvanced($new_quantity_on_shelf, $new_quantity_reserved, $oldData['id'], '');
                } else {
                    $res = $this->UpdateProductStoreAmountAsAdvanced($new_quantity_on_shelf, $new_quantity_reserved, $oldData['id'], '');
                }
            } else {
                $new_quantity_reserved += $temp['value'];
                $res = $this->UpdateProductStoreAmountAsAdvanced($new_quantity_on_shelf, $new_quantity_reserved, $oldData['id'], '');
            }
        } elseif (in_array($temp['for_type'], ['receipt-return-invoice', 'mortal-invoice'])) {
            $new_quantity_on_shelf -= $temp['value'];
            $res = $this->UpdateProductStoreAmountAsAdvanced($new_quantity_on_shelf, $new_quantity_reserved, $oldData['id'], '');
        } elseif ($temp['for_type'] == 'inventory-invoice') {
            $new_quantity_on_shelf = $temp['store_amounts'];
            $new_quantity_reserved = 0;
            $res = $this->UpdateProductStoreAmountAsAdvanced($new_quantity_on_shelf, $new_quantity_reserved, $oldData['id'], '');
        } elseif ($temp['for_type'] == 'store-convesion-invoice') {
            if ($temp['type'] == 'remove') {
                $new_quantity_on_shelf -= $temp['value'];
                $res = $this->UpdateProductStoreAmountAsAdvanced($new_quantity_on_shelf, $new_quantity_reserved, $oldData['id'], $temp['store_id']);
            } elseif ($temp['type'] == 'add') {
                $new_quantity_on_shelf += $temp['value'];
                $res = $this->UpdateProductStoreAmountAsAdvanced($new_quantity_on_shelf, $new_quantity_reserved, $oldData['id'], $temp['store_id']);
            }
        }
        return $res;
    }

    public function UpdateProductStoreAmountAsAdvanced($shelf, $reserved, $id, $store_id) {
        $sql = "UPDATE product_stores_amounts
                SET
                quantity_on_shelf = :quantity_on_shelf, ";
        $sql .= "quantity_reserved = :quantity_reserved ";
        $sql .= "WHERE id = :id";
        $sql .= $store_id ? " AND store_id = $store_id " : "";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':quantity_on_shelf', $shelf, PDO::PARAM_STR);
        $stmt->bindParam(':quantity_reserved', $reserved, PDO::PARAM_STR);
        $stmt->bindParam(':id', $id, PDO::PARAM_INT);
        return $stmt->execute();
    }

    public function getProductStoresAmountsByData($temp) {
        $sql = "SELECT `id`,`store_amounts` FROM product_stores_amounts ";
        $sql .= " WHERE `product_id`='{$temp['product_id']}' and `store_id`='{$temp['store_id']}' ";
        $sql .= $temp['name'] ? " and `name`='{$temp['name']}'" : "";
        $sql .= $temp['expiration_date'] ? " and `expiration_date`='{$temp['expiration_date']}'" : " and `expiration_date` IS NULL ";
//echo $sql."<hr>";
        return $this->mDb->getRow($sql);
    }

    public function addBrowseProductHistory($temp) {
//        echo 'test<hr>';
        if (CLIENT['id']) {

            $temp['client_id'] = CLIENT['id'];
            $temp['affiliator_id'] = AFFILIATOR['id'];
            $temp['set_from'] = SETFROM;

            $sql = "INSERT INTO `browse_product_history` SET ";
            foreach ($this->mDb->getCols('browse_product_history', $temp) as $k => $v) {
                $sql .= ($k == 'medias' or $k == 'id' or $k == 'lang_Details') ? "" : "`{$k}`='{$v}',";
            }
            $sql .= " `date_added` = '{$this->dateTime}' ";
//             echo $sql;die();

            $res = $this->mDb->query($sql);

            if ($res) {
                $countClient = $this->getCountClientIdInBrowseProductHistory();
                if ($countClient > 100) {

                    $this->deleteBrowseProductHistoryInGreaterThan100(($countClient - 100));
                }
            }
            return $res;
        }
    }

    public function addFavorites($temp) {
//        echo 'test<hr>';
        if (CLIENT['id']) {

            $temp['client_id'] = CLIENT['id'];
            $temp['affiliator_id'] = AFFILIATOR['id'];
            $temp['set_from'] = SETFROM;

            $sql = "INSERT INTO `favorites` SET ";
            foreach ($this->mDb->getCols('favorites', $temp) as $k => $v) {
                $sql .= ($k == 'id') ? "" : "`{$k}`='{$v}',";
            }
            $sql .= " `date_added` = '{$this->dateTime}' ";
//             echo $sql;die();
            $res = $this->mDb->query($sql);
            return $res;
        } else {
            return false;
        }
    }

    public function countFavorites() {

        $sql = "SELECT count(id)  FROM favorites   ";
        $sql .= " WHERE  `affiliator_id` = '" . AFFILIATOR['id'] . "'  AND `client_id` ='" . CLIENT['id'] . "' ";
        $res = $this->mDb->getOne($sql);

        return $res;
    }

    public function getFavoritesId($product_id) {
        $affiliator_id = AFFILIATOR['id'];
        $client_id = CLIENT['id'] ?? 0;
        $sql = "SELECT id  
                FROM favorites
                WHERE product_id = :product_id 
                    AND  affiliator_id = :affiliator_id
                    AND client_id = :client_id ";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':product_id', $product_id, PDO::PARAM_INT);
        $stmt->bindParam(':affiliator_id', $affiliator_id, PDO::PARAM_INT);
        $stmt->bindParam(':client_id', $client_id, PDO::PARAM_INT);
        $stmt->execute();
        $res = $stmt->fetchColumn(0);
        return $res ? $res : '0';
    }

    public function getSellerNameBySellerId($sellerId) {
        $affiliator_id = AFFILIATOR['id'];
        $sql = "SELECT seller_name  
                FROM store_sellers_affiliators ssa
                LEFT JOIN `stores` s ON s.id = ssa.store_id
                WHERE s.seller_id = :sellerId 
                AND  ssa.affiliator_id = :affiliator_id ";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':sellerId', $sellerId, PDO::PARAM_INT);
        $stmt->bindParam(':affiliator_id', $affiliator_id, PDO::PARAM_INT);
        $stmt->execute();
        $res = $stmt->fetchColumn(0);
        return $res ? $res : '';
    }

       public function getDetailsStoreExternalById($id) {
        $sql = "SELECT 
                    id,
                    name,
                    image,
                    secret_key,
                    shipping_method,
                    account_id  
                FROM import_api
                WHERE id= :id "
        ;
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':id', $id, PDO::PARAM_INT);
        $stmt->execute();
        $res = $stmt->fetch(PDO::FETCH_ASSOC);
        return $res ? $res : '';
    }

    public function getFavorites($start, $aItemsPerPage, $sort, $type) {
        $prod_ids = array();
        $sql = "SELECT product_id  FROM favorites   ";
        $sql .= " WHERE  `affiliator_id` = '" . AFFILIATOR['id'] . "'  AND `client_id` ='" . CLIENT['id'] . "' ";
//        echo $sql."<hr>";
        $ids = $this->mDb->getAll($sql);
        foreach ($ids as $k => $v) {
            array_push($prod_ids, $v['product_id']);
        }
        if (count($prod_ids)) {
            $res = $this->getProducts($start, $aItemsPerPage, $sort, $type, '', '', '', '', '', '', '', 'affiliators', '', array(), $prod_ids, '', '', '', array());
        }

        return $res['products'];
    }

    public function allBrowseProductHistory($start, $aItemsPerPage, $sort, $type) {

        $res = $this->getProducts($start, $aItemsPerPage, $sort, $type, '', '', '', '', '', '', '', 'affiliators', '', array(), array(), '', '', '', array(), true);

        return $res['products'];
    }

    public function getCountClientIdInBrowseProductHistory() {
        $sql = "SELECT count(id)  FROM browse_product_history   ";
        $sql .= " WHERE  `affiliator_id` = '" . AFFILIATOR['id'] . "'  AND `client_id` ='" . CLIENT['id'] . "' ";
        $sql .= " Group BY product_id ";
        return $this->mDb->getOne($sql);
    }

    public function deleteBrowseProductHistoryInGreaterThan100($limit = 0) {

        $sql = "DELETE FROM `browse_product_history` ";
        $sql .= " WHERE  `affiliator_id` = '" . AFFILIATOR['id'] . "'  AND `client_id` ='" . CLIENT['id'] . "' ";
        $sql .= " Group BY product_id ";
        $sql .= " ORDER BY id ASC LIMIT {$limit}";
//        echo $sql."<hr>";
        $res = $this->mDb->query($sql);

        return $res;
    }

    public function deleteBrowseProductHistory($data) {

        $sql = "DELETE FROM `browse_product_history` ";
        $sql .= " WHERE  `affiliator_id` = '" . AFFILIATOR['id'] . "'  AND `client_id` ='" . CLIENT['id'] . "' ";
        $sql .= " and product_id='{$data['product_id']}' ";
//        echo $sql."<hr>";
        $res = $this->mDb->query($sql);
        return $res;
    }

    public function deleteFavorites($data) {

        $sql = "DELETE FROM `favorites` ";
        $sql .= " WHERE  `affiliator_id` = '" . AFFILIATOR['id'] . "'  AND `client_id` ='" . CLIENT['id'] . "' ";
        $sql .= " and product_id='{$data['product_id']}' ";
//        echo $sql."<hr>";
        $res = $this->mDb->query($sql);
        return $res;
    }

    public function deleteAllBrowseProductHistory() {

        $sql = "DELETE FROM `browse_product_history` ";
        $sql .= " WHERE  `affiliator_id` = '" . AFFILIATOR['id'] . "'  AND `client_id` ='" . CLIENT['id'] . "' ";
//        echo $sql."<hr>";
        $res = $this->mDb->query($sql);
        return $res;
    }

// public function removeFromProduct_storesByOrder_id($order_id, $for_type, $value = false)
// {
//     $sql = "SELECT product_id FROM `product_stores` ";
//     $sql .= " WHERE `for_id` =  '{$order_id}'  AND `for_type` = '{$for_type}'    ";
//     $sql .= $value  ?  "  and `value` =  '{$value}'  " : " ";
//     $allProducts =  $this->mDb->getAll($sql);
//     // p($allProducts);
//     for ($i = 0; $i < count($allProducts); $i++) {
//         //**VIP***
//         // refresh Quantity To Open CART WITH STORE 1
//         $row =  $this->getStatisticsFroProduct($allProducts[$i]['product_id']);
//         $total  =  ($row['total_add_amount_product'] * 1) -  ($row['total_sell_amount_product'] * 1);
//         // $this->refreshQuantityProductToOpenCart($allProducts[$i]['product_id'], $total);
//         //**VIP***
//         # code...
//     }
//     $sql = "DELETE FROM `product_stores` ";
//     $sql .= " WHERE `for_id` =  '{$order_id}'  AND `for_type`  = '{$for_type}' ";
//     $sql .= $value  ?  "  and `value` =  '{$value}'  " : " ";
//     return $this->mDb->query($sql);
// }


    function addSearchProductReports($searchCategoryId, $searchKey, $count_results = 0) {
        $client_id = CLIENT['id'] ? CLIENT['id'] : '0';
        $sql = "INSERT `search_product_reports` SET   
        `searchCategoryId` ='{$searchCategoryId}' 
        , `searchKey` ='{$searchKey}'
        ,  `affiliator_id` =  " . AFFILIATOR['id'] . "
        ,  `client_id` =  " . $client_id . "
        ,  `count_results` =  " . $count_results . "
        ,  `set_from` =  '" . SETFROM . "'  , `date_added` = '{$this->dateTime}'";
// echo $sql."<hr>";
// die();
        return $this->mDb->query($sql);
    }

    public function getUnitData($unit_id) {
        $sql = "SELECT u.* , ul.title , ul.unit_id as id  FROM `units` u ";
        $sql .= " LEFT JOIN `unit_langs` ul ON u.id = ul.unit_id AND ul.lang_code = 'ar' ";
        $sql .= " WHERE u.id  ='{$unit_id}'     ";
        $res = $this->mDb->getRow($sql);
//  echo $sql;
//   die();
        return $res;
    }

//////// offers 


    public function getPR_SR_TR_IDs($id) {
        $sql = "SELECT b.*    
                FROM offers b
                WHERE b.id = :id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':id', $id);
        $stmt->execute();
        $res = $stmt->fetch(PDO::FETCH_ASSOC);
        if ($res) {
            $sql = "SELECT *   
                    FROM offer_x_y
                    WHERE offer_id = :id";
            $stmt = $this->mDb->connect()->prepare($sql);
            $stmt->bindParam(':id', $id);
            $stmt->execute();
            $res['x_y_type'] = $stmt->fetch(PDO::FETCH_ASSOC);
            if ($res['x_y_type']) {
                $res['x_y_type']['x_ids'] = substr($res['x_y_type']['x_ids'], 1);
                $res['x_y_type']['x_ids'] = substr($res['x_y_type']['x_ids'], 0, -1);
                if ($res['x_y_type']['x_types'] == 'products') {
                    $ret['types'] = 'products';
                    $ret['offer_products_ids'] = $res['x_y_type']['x_ids'];
                } else if ($res['x_y_type']['x_types'] == 'services') {
                    $ret['types'] = 'services';
                    $ret['offer_services_ids'] = $res['x_y_type']['x_ids'];
                } else if ($res['x_y_type']['x_types'] == 'trademarks') {
                    $ret['types'] = 'trademarks';
                    $ret['offer_trademarks_ids'] = $res['x_y_type']['x_ids'];
                } else if ($res['x_y_type']['x_types'] == 'tags') {
                    $ret['types'] = 'tags';
                    $ret['offer_tags_ids'] = $res['x_y_type']['x_ids'];
                } else if ($res['x_y_type']['x_types'] == 'product_group') {
                    $ret['types'] = 'product_group';
                    $ret['offer_product_group_ids'] = $res['x_y_type']['x_ids'];
                }
            } else {
                $sql = "SELECT *   
                        FROM offer_discount
                        WHERE offer_id = :id ";
                $stmt = $this->mDb->connect()->prepare($sql);
                $stmt->bindParam(':id', $id);
                $stmt->execute();
                $res['offer_discount'] = $stmt->fetch(PDO::FETCH_ASSOC);
                $res['offer_discount']['ids'] = substr($res['offer_discount']['ids'], 1);
                $res['offer_discount']['ids'] = substr($res['offer_discount']['ids'], 0, -1);
                if ($res['offer_discount']) {
                    if ($res['offer_discount']['apply_type_conditions'] == 'products') {
                        $ret['types'] = 'products';
                        $ret['offer_products_ids'] = $res['offer_discount']['ids'];
                    } else if ($res['offer_discount']['apply_type_conditions'] == 'services') {
                        $ret['types'] = 'services';
                        $ret['offer_services_ids'] = $res['offer_discount']['ids'];
                    } else if ($res['offer_discount']['apply_type_conditions'] == 'trademarks') {
                        $ret['types'] = 'trademarks';
                        $ret['offer_trademarks_ids'] = $res['offer_discount']['ids'];
                    } else if ($res['offer_discount']['apply_type_conditions'] == 'tags') {
                        $ret['types'] = 'tags';
                        $ret['offer_tags_ids'] = $res['offer_discount']['ids'];
                    } else if ($res['offer_discount']['apply_type_conditions'] == 'product_group') {
                        $ret['types'] = 'product_group';
                        $ret['offer_product_group_ids'] = $res['offer_discount']['ids'];
                    } else if ($res['offer_discount']['apply_type_conditions'] == 'cart') {
                        $ret['types'] = 'cart';
                    }
                }
            }
        }
        return $ret;
    }

//////// coupons 


    public function getCoupon_PR_SR_TR_IDs($id) {
        $sql_1 = " SELECT * FROM coupons
                    WHERE id = :id ";
        $stmt = $this->mDb->connect()->prepare($sql_1);
        $stmt->bindParam(':id', $id);
        $stmt->execute();
        $res = $stmt->fetch(PDO::FETCH_ASSOC);
        if ($res) {
            $sql1 = "SELECT *   
                    FROM coupon_discount
                    WHERE coupon_id = :id";
            $stmt = $this->mDb->connect()->prepare($sql1);
            $stmt->bindParam(':id', $id);
            $stmt->execute();
            $res['coupon_discount'] = $stmt->fetch(PDO::FETCH_ASSOC);
            $res['coupon_discount']['ids'] = substr($res['coupon_discount']['ids'], 1);
            $res['coupon_discount']['ids'] = substr($res['coupon_discount']['ids'], 0, -1);
            if ($res['coupon_discount']) {
                if ($res['coupon_discount']['apply_type_conditions'] == 'products') {
                    $ret['types'] = 'products';
                    $ret['coupon_products_ids'] = $res['coupon_discount']['ids'];
                } else if ($res['coupon_discount']['apply_type_conditions'] == 'services') {
                    $ret['types'] = 'services';
                    $ret['coupon_services_ids'] = $res['coupon_discount']['ids'];
                } else if ($res['coupon_discount']['apply_type_conditions'] == 'trademarks') {
                    $ret['types'] = 'trademarks';
                    $ret['coupon_trademarks_ids'] = $res['coupon_discount']['ids'];
                } else if ($res['coupon_discount']['apply_type_conditions'] == 'tags') {
                    $ret['types'] = 'tags';
                    $ret['coupon_tags_ids'] = $res['coupon_discount']['ids'];
                } else if ($res['coupon_discount']['apply_type_conditions'] == 'product_group') {
                    $ret['types'] = 'product_group';
                    $ret['coupon_product_group_ids'] = $res['coupon_discount']['ids'];
                } else if ($res['coupon_discount']['apply_type_conditions'] == 'cart') {
                    $ret['types'] = 'cart';
                }
            }
        }
        return $ret;
    }

    public function getAllPR_SR_TR() {
        $now = date('Y-m-d');
        $affiliator_id = AFFILIATOR['id'];
        $setfrom = SETFROM;
        $price_type = AFFILIATOR['price_type'];
        $sql = "SELECT p.*    
                FROM offers p
                WHERE   
                    p.active " . search_active('!=0') . "
                    AND (p.affiliator_id = :affiliator_id || ( p.affiliator_id = '0' AND p.price_type = :price_type ) )
                    AND (p.offer_start_date <= :now || p.offer_start_date is Null )
                    AND (p.offer_end_date >= :now || p.offer_end_date is Null )
                    AND ( p.show_on  = :set_from || p.show_on  = 'both')
                    Group by p.id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':affiliator_id', $affiliator_id);
        $stmt->bindParam(':price_type', $price_type);
        $stmt->bindParam(':now', $now);
        $stmt->bindParam(':set_from', $setfrom);
        $stmt->execute();
        $res = $stmt->fetchAll(PDO::FETCH_ASSOC);
        if ($res) {
            foreach ($res as $offer) {
                $sql = "SELECT *   
                        FROM offer_x_y
                        WHERE offer_id = :offer_id";
                $stmt = $this->mDb->connect()->prepare($sql);
                $stmt->bindParam(':offer_id', $offer['id']);
                $stmt->execute();
                $offer['x_y_type'] = $stmt->fetch(PDO::FETCH_ASSOC);
                if ($offer['x_y_type']) {
                    $offer['x_y_type']['x_ids'] = substr($offer['x_y_type']['x_ids'], 1);
                    $offer['x_y_type']['x_ids'] = substr($offer['x_y_type']['x_ids'], 0, -1);
                    if ($offer['x_y_type']['x_types'] == 'products') {
                        $ret['products'] = true;
                        $ret['offer_products_ids'] .= $ret['offer_products_ids'] ? ',' . $offer['x_y_type']['x_ids'] : $offer['x_y_type']['x_ids'];
                    } else if ($offer['x_y_type']['x_types'] == 'services') {
                        $ret['services'] = true;
                        $ret['offer_services_ids'] .= $ret['offer_services_ids'] ? ',' . $offer['x_y_type']['x_ids'] : $offer['x_y_type']['x_ids'];
                    } else if ($offer['x_y_type']['x_types'] == 'trademarks') {
                        $ret['trademarks'] = true;
                        $ret['offer_trademarks_ids'] .= $ret['offer_trademarks_ids'] ? ',' . $offer['x_y_type']['x_ids'] : $offer['x_y_type']['x_ids'];
                    } else if ($offer['x_y_type']['x_types'] == 'tags') {
                        $ret['tags'] = true;
                        $ret['offer_tags_ids'] .= $ret['offer_tags_ids'] ? ',' . $offer['x_y_type']['x_ids'] : $offer['x_y_type']['x_ids'];
                    } else if ($offer['x_y_type']['x_types'] == 'product_group') {
                        $ret['product_group'] = true;
                        $ret['offer_product_group_ids'] .= $ret['offer_product_group_ids'] ? ',' . $offer['x_y_type']['x_ids'] : $offer['x_y_type']['x_ids'];
                    }
                } else {
                    $sql = "SELECT *   
                            FROM offer_discount
                            WHERE offer_id = :offer_id";
                    $stmt = $this->mDb->connect()->prepare($sql);
                    $stmt->bindParam(':offer_id', $offer['id']);
                    $stmt->execute();
                    $offer['offer_discount'] = $stmt->fetch(PDO::FETCH_ASSOC);
                    $offer['offer_discount']['ids'] = substr($offer['offer_discount']['ids'], 1);
                    $offer['offer_discount']['ids'] = substr($offer['offer_discount']['ids'], 0, -1);
                    if ($offer['offer_discount']) {

                        if ($offer['offer_discount']['apply_type_conditions'] == 'products') {
                            $ret['products'] = true;
                            $ret['offer_products_ids'] .= $ret['offer_products_ids'] ? ',' . $offer['offer_discount']['ids'] : $offer['offer_discount']['ids'];
                        } else if ($offer['offer_discount']['apply_type_conditions'] == 'services') {
                            $ret['services'] = true;
                            $ret['offer_services_ids'] .= $ret['offer_services_ids'] ? ',' . $offer['offer_discount']['ids'] : $offer['offer_discount']['ids'];
                        } else if ($offer['offer_discount']['apply_type_conditions'] == 'trademarks') {
                            $ret['trademarks'] = true;
                            $ret['offer_trademarks_ids'] .= $ret['offer_trademarks_ids'] ? ',' . $offer['offer_discount']['ids'] : $offer['offer_discount']['ids'];
                        } else if ($offer['offer_discount']['apply_type_conditions'] == 'tags') {
                            $ret['tags'] = true;
                            $ret['offer_tags_ids'] .= $ret['offer_tags_ids'] ? ',' . $offer['offer_discount']['ids'] : $offer['offer_discount']['ids'];
                        } else if ($offer['offer_discount']['apply_type_conditions'] == 'product_group') {
                            $ret['product_group'] = true;
                            $ret['offer_product_group_ids'] .= $ret['offer_product_group_ids'] ? ',' . $offer['offer_discount']['ids'] : $offer['offer_discount']['ids'];
                        } else if ($offer['offer_discount']['apply_type_conditions'] == 'cart') {
                            $ret['types'] = 'cart';
                        }
                    }
                }
            }
        }

        return $ret;
    }

    public function addAFFiliatorPrice(
            $product_id, $price
    ) {

        $sql = "DELETE FROM `affiliator_prices` ";
        $sql .= " WHERE product_id='{$product_id}' and affiliator_id = '" . OWNER['id'] . "'  ";
        $this->mDb->query($sql);
        $sql = "INSERT `affiliator_prices` SET price = '{$price}', product_id='{$product_id}' , affiliator_id = '" . OWNER['id'] . "' ,`date_added` ='{$this->dateTime}'  ";
//  echo $sql; die() ;
        return $this->mDb->query($sql);
    }

    public function getFomsShapeByService_ids($service_ids, $mode = '') {
        $sql = "SELECT f.id  ,f.type  , fl.label FROM `form_shapes` f  ";
        $sql .= " LEFT JOIN `form_shape_services` fss ON f.id = fss.form_shape_id    ";
        $sql .= " LEFT JOIN `form_shape_langs` fl ON f.id = fl.form_shape_id  AND fl.lang_code = '{$this->lang_code}' ";
        $sql .= " where (f.type='select' || f.type='m_select' ) AND fss.`service_id` in  ({$service_ids})  and f.is_deleted = '0' and f.active = '1' ";
        $sql .= $mode == 'home' ? " and f.quick_access_page = '1' " : "";
        $sql .= " Group By f.id  ORDER BY f.sort ";

//        echo $sql."<hr>";
        $form_shape = $this->mDb->getAll($sql);

//	p($sql);

        for ($i = 0; $i < count($form_shape); $i++) {
            $sql = "SELECT  fo.id as value , fol.label   FROM `form_shape_options` fo ";
            $sql .= " LEFT JOIN `form_shape_option_langs` fol ON fo.id = fol.form_shape_option_id AND fol.lang_code = '{$this->lang_code}' ";
            $sql .= " WHERE fo.form_shape_id = '{$form_shape[$i]['id']}' and fo.is_deleted = '0' ";
            $sql .= " order by fo.sort asc ";
//          echo $sql."<hr>";
            $form_shape[$i]['options'] = $this->mDb->getAll($sql);
        }

        return $form_shape;
    }

    function addShareProductReports($Req) {
        for ($i = 0; $i < count($Req['product_id']); $i++) {
            if ($Req['product_id'][$i]) {
                $sql = "INSERT `product_share_reports` SET  ";
                $sql .= "`affiliator_id` =  " . AFFILIATOR['id'] . "";
                $sql .= ",`client_id` =  " . CLIENT['id'] . "";
                $sql .= ",`product_id` = '{$Req['product_id'][$i]}'";
                $sql .= ",`app_version` = '{$Req['app_version']}'";

                $sql .= ", `set_from` = '" . SETFROM . "', `date_added` = '{$this->dateTime}'";
                // echo $sql;
                // die();
                $res = $this->mDb->query($sql);
            }
        }
        return $res;
    }

//    public function getSearchInProductsByBarcode($params) {
//        $sql = "SELECT p.id, p.product_barcode, pl.name as product_name ";
//        $sql .= " FROM `products` p ";
//        $sql .= "LEFT JOIN `product_langs` pl ON pl.product_id = p.id AND pl.lang_code = '{$this->lang_code}' ";
//        $sql .= "WHERE  p.`product_barcode`='{$params['product_barcode']}' ";
//        $sql .= "GROUP BY p.id ";
//        $sql .= "ORDER BY p.id ASC ";
//        $sql .= "LIMIT 1 ";
//
////        echo $sql."<hr>";
//        $res = $this->mDb->getRow($sql);
//        if ($res) {
//            $res['images'] = $this->getProductimgs($res['id'], 1);
//            $res['image'] = $res['images'][0]['name'] ? $res['images'][0]['name'] : '';
//
//            $res['product_services'] = $this->getProduct_services($res['id']);
//            $res['store_amounts'] = $this->getProductStoreAmounts($res['id'], $params['store_id']);
//
//            $res['parent_expiration_date'] = '0';
//            for ($e = 0; $e < count($res['product_services']); $e++) {
//                if ($res['product_services'][$e]['parent_expiration_date'] == '1') {
//                    $res['parent_expiration_date'] = '1';
//                }
//            }
//        }
//        return $res;
//    }
    private function cleanSearchTerm($term) {
        $term = trim($term);
        $term = preg_replace('/\s+/', ' ', $term); // إزالة المسافات الزائدة
        $term = str_replace(['%', '_'], ['\%', '\_'], $term); // معالجة الرموز الخاصة
        return $term;
    }

    public function getSearchInProductsByBarcode($params) {
        try {
            // تحضير المعاملات الأساسية
            $bindings = [':lang_code' => $this->lang_code];

            // بناء الاستعلام الأساسي
            $sql = "SELECT 
                p.id, p.active, p.product_barcode, 
                p.price, p.commission, 
                p.price_multi, p.last_price_multi,
                p.price_one, p.last_price_one,
                p.api_id_to, p.cost,
                p.cost as real_cost,
                pl.name as product_name,
                ap.price as affiliator_price
            FROM products p 
            LEFT JOIN product_langs pl ON pl.product_id = p.id AND pl.lang_code = :lang_code 
            LEFT JOIN affiliator_prices ap ON ap.product_id = p.id  
            WHERE 1=1";

            // إضافة شرط الباركود
            if (!empty($params['product_barcode'])) {
                $sql .= " AND p.product_barcode = :barcode";
                $bindings[':barcode'] = $params['product_barcode'];
            }

            // معالجة وضع الجرد
            if ($params['mode'] === 'gard') {
                $sql .= " AND p.active " . search_active('!=2');

                if (!empty($params['product_ids'])) {
                    $ids = array_map('intval', explode(',', $params['product_ids']));
                    if (!empty($ids)) {
                        $placeholders = array_map(function ($i) {
                            return ":pid$i";
                        }, array_keys($ids));

                        $sql .= " OR (p.id IN (" . implode(',', $placeholders) . ")";

                        foreach ($ids as $i => $id) {
                            $bindings[":pid$i"] = $id;
                        }

                        if (!empty($params['product_barcode'])) {
                            $sql .= " AND p.product_barcode = :barcode";
                        }

                        $sql .= ")";
                    }
                }
            }

            // تحسين البحث
            if (!empty($params['searchKey'])) {
                $searchTerm = $this->cleanSearchTerm($params['searchKey']);

                $sql .= " AND (
                    pl.name LIKE :search_name OR 
                    p.product_code LIKE :search_code OR
                    p.product_barcode LIKE :search_barcode OR
                    p.key_words LIKE :search_keywords
                )";

                $searchKey = '%' . $searchTerm . '%';
                $bindings[':search_name'] = $searchKey;
                $bindings[':search_code'] = $searchKey;
                $bindings[':search_barcode'] = $searchKey;
                $bindings[':search_keywords'] = $searchKey;

                // ترتيب النتائج حسب الأهمية
                $sql .= " ORDER BY 
                    CASE 
                        WHEN pl.name LIKE :exact_match THEN 1
                        WHEN pl.name LIKE :start_match THEN 2
                        WHEN pl.name LIKE :contains_match THEN 3
                        ELSE 4 
                    END";

                $bindings[':exact_match'] = $searchTerm;
                $bindings[':start_match'] = $searchTerm . '%';
                $bindings[':contains_match'] = '%' . $searchTerm . '%';
            } else {
                $sql .= " ORDER BY p.id ASC";
            }

            $sql .= " LIMIT 25";

            // تحضير وتنفيذ الاستعلام
            $stmt = $this->mDb->connect()->prepare($sql);

            // ربط المعاملات
            foreach ($bindings as $key => $val) {
                $stmt->bindValue($key, $val,
                        is_int($val) ? PDO::PARAM_INT : PDO::PARAM_STR
                );
            }

            $stmt->execute();
//            echoSql($stmt);
            $results = $stmt->fetchAll(PDO::FETCH_ASSOC);

            // معالجة النتائج
            if ($results) {
                foreach ($results as &$product) {
                    $product['images'] = $this->getProductimgs($product['id'], 1);
                    $product['image'] = !empty($product['images'][0]['name']) ? $product['images'][0]['name'] : '';
                    $product['product_services'] = $this->getProduct_services($product['id']);
                    $product['store_amounts'] = $this->getProductStoreAmounts($product['id'], $params['store_id'] ?? '', '', '', $params['mode'] ?? '');
                    $product['stores'] = $this->getStoresInProductId(
                            $product['id'],
                            true,
                            $params['store_id'] ?? '',
                            $params['mode'] ?? ''
                    );

                    // معالجة parent_expiration_date
                    $product['parent_expiration_date'] = array_reduce(
                                    $product['product_services'],
                                    function ($carry, $service) {
                                        return $carry || $service['parent_expiration_date'] == '1';
                                    },
                                    false
                            ) ? '1' : '0';

                    // معالجة الأسعار
                    $product['last_price'] = null;

                    if (defined('AFFILIATOR') && isset($params['price_type'])) {
                        if ($params['price_type'] == 'price' && $product['affiliator_price'] > 0) {
                            $product['price'] = $product['affiliator_price'];
                        }

                        $product['affiliator_commission'] = $product['affiliator_price'] ? $product['price'] - $product['price_multi'] : $product['commission'];

                        if ($params['price_type'] == 'price_one' && $product['last_price_one'] > '0') {
                            $product['last_price'] = $product['price_one'];
                            $product['price_one'] = $product['last_price_one'];
                        }

                        if ($params['price_type'] == 'price_multi' && $product['last_price_multi'] > '0') {
                            $product['last_price'] = $product['price_multi'];
                            $product['price_multi'] = $product['last_price_multi'];
                        }

                        if ($product['last_price_multi'] > '0') {
                            $price_multi_last = $product['price_multi'];
                            $product['price_multi'] = $product['last_price_multi'];
                            $product['last_price_multi'] = $price_multi_last;
                        }

                        if ($product['api_id_to'] && $product['api_id_to'] != '0') {
                            if ($product['last_price_one'] > '0') {
                                $product['last_price'] = $product['price_one'];
                                $product['price_one'] = $product['last_price_one'];
                            }
                            $product['price'] = $product['price_one'];
                        } else {
                            $product['price'] = $product[$params['price_type']];
                        }
                    }
                }
            }

            return $results ?: [];
        } catch (PDOException $e) {
            error_log("خطأ في قاعدة البيانات في getSearchInProductsByBarcode: " . $e->getMessage());
            return [];
        } catch (Exception $e) {
            error_log("خطأ عام في getSearchInProductsByBarcode: " . $e->getMessage());
            return [];
        }
    }

//     public function getSearchInProductsByBarcode($params) {
//         // تحويل product_ids إلى مصفوفة من الأعداد
//         $productIdsArray = array_map('intval', explode(',', $params['product_ids'])); // تحويل كل ID إلى int لضمان الأمان
//         $productIds = implode(',', $productIdsArray); // تحويلها إلى سلسلة مفصولة بفواصل
//         $sql = "SELECT 
//             p.id, 
//             p.active,
//             p.product_barcode, 
//             p.price, 
//             p.commission, 
//             p.price_multi, p.last_price_multi,
//             p.price_one, p.last_price_one,
//             p.api_id_to,
//             p.cost,
//             p.cost as real_cost,
//             pl.name as product_name ,
//             ap.price as affiliator_price
//         FROM `products` p 
//         LEFT JOIN `product_langs` pl ON pl.product_id = p.id AND pl.lang_code = :lang_code 
//          LEFT JOIN `affiliator_prices` ap ON ap.product_id = p.id  
//         WHERE ( p.id > 0 ";
//         $sql .= $params['product_barcode'] ? " and p.product_barcode = :product_barcode" : "";
//         if ($params['mode'] === 'gard') {
//             $sql .= " AND p.active != '2' )";
//             if (!empty($productIds)) {
//                 $sql .= " OR (p.id IN ($productIds) ";
//                 $sql .= $params['product_barcode'] ? " AND p.product_barcode = :product_barcode" : "";
//                 $sql .= ")";
//             }
//         } else {
//             $sql .= ")";
//         }
//         // إضافة شروط البحث الإضافية إذا كانت `searchKey` موجودة
//         if ($params['searchKey']) {
//             $array = [
//                 'p.product_code',
//                 'p.product_barcode',
//                 'pl.name',
//                 'p.key_words',
//             ];
//             $sql .= search_word_in_column($array, $params['searchKey'], 'search_word');
//         }
//         $sql .= " ORDER BY p.id ASC LIMIT 25 ";
//         $stmt = $this->mDb->connect()->prepare($sql);
//         // ربط المعاملات الأخرى
//         $stmt->bindParam(':lang_code', $this->lang_code, PDO::PARAM_STR);
//         $params['product_barcode'] ? $stmt->bindValue(':product_barcode', $params['product_barcode'], PDO::PARAM_STR) : '';
//         $stmt->execute();
//  echoSql($stmt);
//         $res = $stmt->fetchAll(PDO::FETCH_ASSOC);
//         if ($res) {
//             foreach ($res as &$product) {
//                 $product['images'] = $this->getProductimgs($product['id'], 1);
//                 $product['image'] = !empty($product['images'][0]['name']) ? $product['images'][0]['name'] : '';
//                 $product['product_services'] = $this->getProduct_services($product['id']);
//                 $product['store_amounts'] = $this->getProductStoreAmounts($product['id'], $params['store_id'], '', '', $params['mode']);
//                 $product['stores'] = $this->getStoresInProductId($product['id'], true, $params['store_id'], $params['mode']);
//                 // التحقق من parent_expiration_date
//                 $product['parent_expiration_date'] = array_reduce($product['product_services'], function ($carry, $service) {
//                             return $carry || $service['parent_expiration_date'] == '1';
//                         }, false) ? '1' : '0';
//                 $product['last_price'] = null;
//                 if (AFFILIATOR['price_type'] == 'price' && $product['affiliator_price'] > 0) {
//                     $product['price'] = $product['affiliator_price'];
//                 }
//                 $product['affiliator_commission'] = $product['affiliator_price'] ? $product['price'] - $product['price_multi'] : $product['commission'];
//                 if (AFFILIATOR['price_type'] == 'price_one' && $product['last_price_one'] > '0') {
//                     $product['last_price'] = $product['price_one'];
//                     $product['price_one'] = $product['last_price_one'];
//                 }
//                 if (AFFILIATOR['price_type'] == 'price_multi' && $product['last_price_multi'] > '0') {
//                     $product['last_price'] = $product['price_multi'];
//                     $product['price_multi'] = $product['last_price_multi'];
//                 }
//                 if ($product['last_price_multi'] > '0') {
//                     $price_multi_last = $product['price_multi'];
//                     $product['price_multi'] = $product['last_price_multi'];
//                     $product['last_price_multi'] = $price_multi_last;
//                 }
//                 if ($product['api_id_to'] && $product['api_id_to'] != '0') {
//                     if ($product['last_price_one'] > '0') {
//                         $product['last_price'] = $product['price_one'];
//                         $product['price_one'] = $product['last_price_one'];
//                     }
//                     $product['price'] = $product['price_one'];
//                 } else {
//                     $product['price'] = $product[AFFILIATOR['price_type']];
//                 }
//             }
//         }
//         return $res;
//     }
//    public function getSearchInProductsByBarcode($params) {
//        // تحويل product_ids إلى مصفوفة من الأعداد
//        $productIdsArray = array_map('intval', explode(',', $params['product_ids'])); // تحويل كل ID إلى int لضمان الأمان
//        $productIds = implode(',', $productIdsArray); // تحويلها إلى سلسلة مفصولة بفواصل
//
//        $sql = "SELECT 
//            p.id, 
//            p.active,
//            p.product_barcode, 
//            p.price, 
//            p.commission, 
//            p.price_multi, p.last_price_multi,
//            p.price_one, p.last_price_one,
//            p.api_id_to,
//            p.cost,
//            p.cost as real_cost,
//            pl.name as product_name ,
//            ap.price as affiliator_price
//        FROM `products` p 
//        LEFT JOIN `product_langs` pl ON pl.product_id = p.id AND pl.lang_code = :lang_code 
//         LEFT JOIN `affiliator_prices` ap ON ap.product_id = p.id  
//        WHERE (p.product_barcode = :product_barcode";
//
//        if ($params['mode'] === 'gard') {
//            $sql .= " AND p.active != '2' )";
//
//            if (!empty($productIds)) {
//                $sql .= " OR (p.id IN ($productIds) AND p.product_barcode = :product_barcode)";
//            }
//        } else {
//            $sql .= ")";
//        }
//
//        // إضافة شروط البحث الإضافية إذا كانت `searchKey` موجودة
//        if ($params['searchKey']) {
//            $array = [
//                'p.product_code',
//                'p.product_barcode',
//                'pl.name',
//                'p.key_words',
////                'pssk.suggesstion',
////                'pfs.value',
////                'fsol.label'
//            ];
//            $sql .= search_word_in_column($array, $params['searchKey'], 'search_word');
//        }
//
//        $sql .= " ORDER BY p.id ASC LIMIT 1";
//        $stmt = $this->mDb->connect()->prepare($sql);
//
//        // ربط المعاملات الأخرى
//        $stmt->bindValue(':lang_code', $this->lang_code, PDO::PARAM_STR);
//        $stmt->bindValue(':product_barcode', $params['product_barcode'], PDO::PARAM_STR);
//
//        $stmt->execute();
//
//        $res = $stmt->fetch(PDO::FETCH_ASSOC);
//
//        if ($res) {
//            $res['images'] = $this->getProductimgs($res['id'], 1);
//            $res['image'] = !empty($res['images'][0]['name']) ? $res['images'][0]['name'] : '';
//
//            $res['product_services'] = $this->getProduct_services($res['id']);
//            $res['store_amounts'] = $this->getProductStoreAmounts($res['id'], $params['store_id'], '', '', $params['mode']);
//            $res['stores'] = $this->getStoresInProductId($res['id'], true, $params['store_id'], $params['mode']);
//
//            // التحقق من parent_expiration_date
//            $res['parent_expiration_date'] = array_reduce($res['product_services'], function ($carry, $service) {
//                        return $carry || $service['parent_expiration_date'] == '1';
//                    }, false) ? '1' : '0';
//
//            $res['last_price'] = null;
//
//            if (AFFILIATOR['price_type'] == 'price' && $res['affiliator_price'] > 0) {
//                $res['price'] = $res['affiliator_price'];
//            }
//
//            $res['affiliator_commission'] = $res['affiliator_price'] ? $res['price'] - $res['price_multi'] : $res['commission'];
//
//            if (AFFILIATOR['price_type'] == 'price_one' && $res['last_price_one'] > '0') {
//                $res['last_price'] = $res['price_one'];
//                $res['price_one'] = $res['last_price_one'];
//            }
//
//            if (AFFILIATOR['price_type'] == 'price_multi' && $res['last_price_multi'] > '0') {
//                $res['last_price'] = $res['price_multi'];
//                $res['price_multi'] = $res['last_price_multi'];
//            }
//
//            if ($res['last_price_multi'] > '0') {
//                $price_multi_last = $res['price_multi'];
//                $res['price_multi'] = $res['last_price_multi'];
//                $res['last_price_multi'] = $price_multi_last;
//            }
//
//            if ($res['api_id_to'] && $res['api_id_to'] != '0') {
//                if ($res['last_price_one'] > '0') {
//                    $res['last_price'] = $res['price_one'];
//                    $res['price_one'] = $res['last_price_one'];
//                }
//                $res['price'] = $res['price_one'];
//            } else {
//                $res['price'] = $res[AFFILIATOR['price_type']];
//            }
//        }
//
//        return $res;
//    }

    public function getSearchInAdjustShelvesByBarcode($params) {
        $sql = "SELECT sas.*, sl.title AS store_title ";
        $sql .= " FROM `store_adjust_shelves` sas ";
        $sql .= "LEFT JOIN `store_langs` sl ON sl.store_id = sas.store_id AND sl.lang_code = '{$this->lang_code}' ";
        $sql .= "WHERE  sas.`name`='{$params['barcode']}' ";
        $sql .= "GROUP BY sas.id ";
        $sql .= "ORDER BY sas.sort ASC ";
        $sql .= "LIMIT 1 ";

//        echo $sql."<hr>";
        $res = $this->mDb->getRow($sql);

        return $res;
    }

    function getIdsOfChidService($id) {
        $sql = "SELECT id FROM `services`";
        $sql .= " WHERE `parent` IN({$id}) ";
        $res = $this->mDb->getAll($sql);
        if ($res) {
            return fetchArrayValue_from_dataBase($res, 'id');
        }
    }

    public function getStoresInProductId($product_id, $fromDetails = '', $store_id = '', $mode = '') {

        $sql = "SELECT DISTINCT 
                    p.id,
                    p.product_id,
                    p.store_id,
                    p.quantity_on_shelf,
                    p.name,
                    p.expiration_date ,
                    sl.title as store_title 
                FROM `product_stores_amounts` p
                LEFT JOIN `store_langs` sl ON sl.store_id = p.store_id AND sl.lang_code = :lang_code 
                WHERE p.`product_id` = :product_id ";
        $sql .= $store_id ? " AND p.`store_id` IN(:store_id)" : "";
        $sql .= $fromDetails ? " Group BY p.`store_id`,p.`name`,p.`expiration_date` " : "  ";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindValue(':lang_code', $this->lang_code, PDO::PARAM_STR);
        $stmt->bindValue(':product_id', $product_id, PDO::PARAM_STR);
        $store_id ? $stmt->bindValue(':store_id', $store_id, PDO::PARAM_STR) : '';
        $stmt->execute();
        $res = $stmt->fetchAll(PDO::FETCH_ASSOC);
        if ($res) {
            for ($i = 0; $i < count($res); $i++) {
                $res[$i]['store_amounts_product'] = $this->getProductStoreAmounts($res[$i]['product_id'], $res[$i]['store_id'], $res[$i]['name'], $res[$i]['expiration_date'], $mode);
                $res[$i]['quantity_on_shelf_product'] = $this->getProductQuantityOnShelf($res[$i]['product_id'], $res[$i]['store_id'], $res[$i]['name'], $res[$i]['expiration_date']);
//                if ($mode == 'AddInvoice') {
//                    $res[$i]['store_amounts_product'] = strval($res[$i]['store_amounts_product']);
//                    $res[$i]['quantity_on_shelf_product'] = strval($res[$i]['quantity_on_shelf_product']);
//                }
            }
        } else {
            $res = array();
            $storeIds = explode(",", $store_id);
            for ($s = 0; $s < count($storeIds); $s++) {
                array_push($res, [
                    "id" => strval(rand(123, 130)),
                    "product_id" => $product_id,
                    "name" => "الافتراضي",
                    "store_amounts_product" => 0,
                    "store_id" => $storeIds[$s],
                    "store_title" => $this->getStoreTitle($storeIds[$s]),
                    "expiration_date" => null,
                ]);
            }
        }
        return $res;
    }

    public function getStoreTitle($id) {
        $sql = "SELECT  title FROM `store_langs` ";
        $sql .= " WHERE  `store_id` = '{$id}'  AND lang_code = '{$this->lang_code}'  ";
        $res = $this->mDb->getOne($sql);
        return $res;
    }

//    public function getStoresInProductId($product_id, $fromDetails = '', $store_id = '') {
//
//
//        $sql = "SELECT DISTINCT p.id,p.product_id,p.store_id,p.name,p.expiration_date ,sl.title as store_title FROM `product_stores_amounts` p";
//
//        $sql .= " LEFT JOIN `store_langs` sl ON sl.store_id = p.store_id   AND sl.lang_code = '{$this->lang_code}' ";
//
//        $sql .= " WHERE p.`product_id` =   '{$product_id}' ";
//
//        $sql .= $store_id ? " AND p.`store_id` IN({$store_id})" : "";
//        $sql .= $fromDetails ? " Group BY p.`store_id`,p.`name`,p.`expiration_date` " : "  ";
//
//        $sql .= $sort ? " ORDER BY p.{$sort} {$type}" : " ";
//        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
////      echo $sql . "<hr>";
//        $res = $this->mDb->getAll($sql);
//        if ($res) {
//         
//            for ($i = 0; $i < count($res); $i++) {
//                $res[$i]['store_amounts_product'] = $this->getProductStoreAmounts($res[$i]['product_id'], $res[$i]['store_id'], $res[$i]['name'], $res[$i]['expiration_date']);
//            }
//        } else {
//            $res = array();
//            $storeIds = explode(",", $store_id);
//            for ($s = 0; $s < count($storeIds); $s++) {
//                array_push($res, [
//                    "id" => rand(123, 130),
//                    "product_id" => $product_id,
//                    "name" => "الافتراضي",
//                    "store_amounts_product" => 0,
//                    "store_id" => $storeIds[$s],
//                    "store_title" => $this->getStoreTitle($storeIds[$s]),
//                    "expiration_date" => null,
//                ]);
//            }
//        }
//
//        return $res;
//    }

    public function getProductsAndAddInvoice($aStart, $aLimit, $sort, $type, $searchServiceId, $searchTrademark_id, $searchStore_id, $product_ids) {





        if ($searchServiceId) {
            $chidIds = $this->getIdsOfChidService($searchServiceId);
            if ($chidIds) {
                $searchServiceId .= ',' . $chidIds;
// p($searchServiceId);
            }
        }






        $sql = "SELECT DISTINCT p.*  ,ul.title as unit_title  ,pl.name   , tl.title as trademark_title ";

        $sql .= "   FROM `products` p";
        $sql .= " LEFT JOIN `product_services` ps ON ps.product_id = p.id ";
//        $sql .= " LEFT JOIN `expiration_date` ed ON ed.product_id = p.id  and ed.checked='1'";
        $sql .= " LEFT JOIN `product_langs` pl ON pl.product_id = p.id  AND  pl.lang_code = '{$this->lang_code}'";
        $sql .= " LEFT JOIN `trademark_langs` tl ON tl.trademark_id = p.trademark_id  AND  tl.lang_code = '{$this->lang_code}'";
        $sql .= " LEFT JOIN `unit_langs` ul ON ul.unit_id = p.unit_id  AND  ul.lang_code = '{$this->lang_code}'";
//        $sql .= " LEFT JOIN `product_stores_amounts` pst ON pst.product_id = p.id  ";

        $sql .= " WHERE p.id >  0 and p.api_dealer_id='0' ";
        $sql .= $product_ids ? " and (p.active " . search_active('!=2') . "  || p.id IN({$product_ids}) ) " : " and  p.active " . search_active('!=2');
//        echo $sql."<hr>";
//        echo search_word_in_column('pl.`name`',$searchKey)."<hr>";
//        $sql .= $searchStore_id ? " AND pst.`store_id` =  '{$searchStore_id}'" : "";
        $sql .= $searchServiceId ? " AND ps.`service_id` in  ({$searchServiceId})  " : "";

        $sql .= $searchTrademark_id != '' ? " AND p.`trademark_id` IN({$searchTrademark_id})  " : "";
        $sql .= " group by  p.id ";
        $sql .= "  ORDER BY {$sort} {$type} ";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
//      echo $sql . "<hr>";
// die();
        $res = $this->mDb->getAll($sql);
        if ($res) {
            for ($i = 0; $i < count($res); $i++) {
                $res[$i]['product_services'] = $this->getProduct_services($res[$i]['id']);

                $res[$i]['parent_expiration_date'] = '0';
                for ($e = 0; $e < count($res[$i]['product_services']); $e++) {
                    if ($res[$i]['product_services'][$e]['parent_expiration_date'] == '1') {
                        $res[$i]['parent_expiration_date'] = '1';
                    }
                }
                $res[$i]['diffrent_price_one'] = 0;
                $res[$i]['diffrent_price_multi'] = 0;

                $res[$i]['store_amounts'] = $this->getProductStoreAmounts($res[$i]['id']);
                $res[$i]['store_amounts'] = strval($res[$i]['store_amounts']);
                $res[$i]['stores'] = $this->getStoresInProductId($res[$i]['id'], true, $searchStore_id, 'gard');
                $res[$i]['stores_string'] = fetchArrayValue_from_dataBase($res[$i]['stores'], 'store_title');
                $res[$i]['ser_name'] = $this->getAllServicesNameOfProductById($res[$i]['id']);
                $res[$i]['product_types'] = $this->getProduct_types($res[$i]['id']);
                $res[$i]['images'] = $this->getProductimgs($res[$i]['id']);
                $res[$i]['image'] = $res[$i]['images'][0]['name'];

                $res[$i]['price_cost_virtual_currency'] = floatval($res[$i]['price_cost_virtual_currency']);
                if ($res[$i]['show_cost']) {
                    $res[$i]['cost'] = floatval($res[$i]['cost']);
                } else if ($res[$i]['show_cost_in_currencys']) {
                    $res[$i]['cost'] = $res[$i]['price_cost_virtual_currency'];
                }


//                $this->updateProductsActive($res[$i]['id']);
            }
# code...
        }
        return $res;
    }

    public function getAllServicesNameOfProductById($id, $limit = '') {

        $sql = "SELECT sl.ser_name FROM product_services  ps ";
        $sql .= " LEFT JOIN `service_langs` sl ON sl.service_id = ps.service_id  AND  sl.lang_code = '{$this->lang_code}'  ";
        $sql .= " WHERE ps.`product_id` = '{$id}'   ";
        $sql .= $limit ? " Limit  1 " : " ";

// echo  $sql ;die();

        $res = $this->mDb->getAll($sql);
        return fetchArrayValue_from_dataBase($res, 'ser_name');
    }

    public function getProduct_types($id, $name = '') {
        $sql = "SELECT   name, store_id,SUM(store_amounts)  as store_amounts,SUM(quantity_on_shelf)  as quantity_on_shelf   FROM product_stores_amounts   ";
        $sql .= " WHERE  `product_id` = '{$id}'    ";
        $sql .= $name ? " AND  `name` = '{$name}' " : '';
        $sql .= "   group by name ";
        $res = $this->mDb->getAll($sql);
        for ($i = 0; $i < count($res); $i++) {
            $res[$i]['store_amounts'] = intval($res[$i]['store_amounts']);
# code...
        }
        return $res;
    }

    public function updateProductsActive($id) {
        $sql = "UPDATE   `products` SET active='2' ";
        $sql .= " WHERE `id` ='{$id}' ";

        $res = $this->mDb->query($sql);
        if ($res) {
            $this->updateSharingApiProductsAllByProductId($id);
        }
        return $res;
    }

    public function updateSharingApiProductsAllByProductId($product_id) {
        $sql = "UPDATE `sharing_api_products` SET ";
        $sql .= " `edit`='1' ";
        $sql .= " WHERE `product_id` = '{$product_id}' ";
//             echo $sql."<hr>";
        $res = $this->mDb->query($sql);
        return $res ? $res : '';
    }

    public function GetGroupData($id) {
        $affiliator_id = AFFILIATOR['id'];
        $sql = "SELECT 
                    gl.name,
                    ga.delivery_price,
                    ga.order_price,
                    g.id,
                    gal.img,
                    gal.description
                FROM products_groups pg
                INNER JOIN `groups` g ON pg.group_id = g.id AND g.type = 'products' AND g.active = '1'
                INNER JOIN groups_langs gl ON g.id = gl.p_id AND gl.lang_code = :lang_code
                INNER JOIN groups_affiliate ga ON g.id = ga.group_id AND ga.active = '1' AND ga.affiliator_id = :affiliator_id
                INNER JOIN groups_affiliate_langs gal ON ga.id = gal.p_id AND gal.lang_code = :lang_code
                WHERE pg.product_id = :id ";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':id', $id, PDO::PARAM_INT);
        $stmt->bindParam(':lang_code', $this->lang_code, PDO::PARAM_STR);
        $stmt->bindParam(':affiliator_id', $affiliator_id, PDO::PARAM_INT);
        $stmt->execute();
        $res = $stmt->fetch(PDO::FETCH_ASSOC);
        return $res ? $res : NULL;
    }

    public function getProductTags($product_id) {
        $sql = "SELECT 
                    tl.label as name,
                    t.id
                FROM product_tags pt
                LEFT JOIN `tags` t ON pt.tag_id = t.id AND t.active = '1'
                LEFT JOIN tags_langs tl ON t.id = tl.tag_id AND tl.lang_code = :lang_code
                WHERE pt.product_id = :id
                ";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':id', $product_id, PDO::PARAM_INT);
        $stmt->bindParam(':lang_code', $this->lang_code, PDO::PARAM_STR);
        $stmt->execute();
        $res = $stmt->fetchAll(PDO::FETCH_ASSOC);
        return $res ? $res : NULL;
    }

    public function getOfferDiscount(
            $product_id,
            $trademark_id,
            $product_services,
            $product_group_id,
            $product_tags,
            $now,
            $affiliator_id,
            $setfrom,
            $price_type
    ) {
        $sql = "SELECT 
                    p.id,
                    p.priority
                FROM `offers` p
                LEFT JOIN `offer_discount` od ON p.id = od.offer_id
                WHERE 
                    p.active != '0'
                    AND (p.affiliator_id = :affiliator_id OR p.affiliator_id = '0')
                    AND p.price_type = :price_type
                    AND (p.offer_start_date <= :now OR p.offer_start_date IS NULL)
                    AND (p.offer_end_date >= :now OR p.offer_end_date IS NULL)
                    AND (p.show_on = :setfrom OR p.show_on = 'both')
                    AND (
                        od.apply_type_conditions = 'cart'
                        OR (od.`ids` LIKE :product_id AND od.apply_type_conditions = 'products')
                        OR (od.`ids` LIKE :trademark_id AND od.apply_type_conditions = 'trademarks')
                        OR (od.`ids` LIKE :product_group_id AND od.apply_type_conditions = 'product_group')
                        OR (
                            od.`ids` LIKE '%,-1,%'
                            ) ";
        if ($product_services) {
            $sql .= "OR(";
        }

        foreach ($product_services as $index => $service) {
            $param = ":service_id_{$index}";
            $sql .= " (od.ids LIKE $param) OR";
        }
        $sql = rtrim($sql, 'OR');
        if ($product_services) {
            $sql .= " AND od.apply_type_conditions = 'services' ) ";
        }
        $sql .= $product_tags ? " OR (" : '';
        if ($product_tags) {
            foreach ($product_tags as $index => $tag) {
                $param = ":product_tag_{$index}";
                $sql .= "(od.ids LIKE $param) OR";
            }
            $sql = rtrim($sql, 'OR');
        } else {
            $sql .= ")";
        }
        $product_tags ? $sql .= " AND od.apply_type_conditions = 'tags' )
            )" : '';
        $sql .= " ORDER BY p.priority DESC LIMIT 1";
        $stmt = $this->mDb->connect()->prepare($sql);

        $stmt->bindValue(':product_id', '%,' . $product_id . ',%');
        $stmt->bindValue(':affiliator_id', $affiliator_id);
        $stmt->bindValue(':price_type', $price_type);
        $stmt->bindValue(':setfrom', $setfrom);
        $stmt->bindValue(':trademark_id', '%,' . $trademark_id . ',%');
        $stmt->bindValue(':product_group_id', '%,' . $product_group_id . ',%');
        $stmt->bindValue(':now', $now);

        foreach ($product_services as $index => $service) {
            $param = ":service_id_{$index}";
            $stmt->bindValue($param, '%,' . $service['service_id'] . ',%');
        }
        if ($product_tags) {
            foreach ($product_tags as $index => $tag) {
                $param = ":product_tag_{$index}";
                $stmt->bindValue($param, '%,' . $tag['id'] . ',%');
            }
        }
        $stmt->execute();
        return $stmt->fetchAll(PDO::FETCH_ASSOC);
    }

    public function getoffer_x_y(
            $product_id,
            $trademark_id,
            $product_services,
            $product_group_id,
            $product_tags,
            $now,
            $affiliator_id,
            $setfrom,
            $price_type
    ) {
        $sql = "SELECT 
                    p.id  ,
                    p.priority  
                FROM `offers` p
                LEFT JOIN `offer_x_y` oxy ON p.id = oxy.offer_id
                WHERE   p.active  != '0' 
                    AND (p.affiliator_id = :affiliator_id || p.affiliator_id = '0' ) 
                    AND p.price_type = :price_type
                    AND (p.offer_start_date <= :now ||  p.offer_start_date is Null)
                    AND( p.offer_end_date >= :now  ||  p.offer_end_date is Null)
                    AND ( p.show_on  = :setfrom  ||  p.show_on  = 'both')
                    AND ( 
                           (oxy.x_ids LIKE :product_id AND oxy.x_types = 'products' )
                        OR (oxy.y_ids LIKE :product_id AND oxy.y_types = 'products' )
                        OR (oxy.x_ids LIKE :trademark_id AND oxy.x_types = 'trademarks' )
                        OR (oxy.y_ids LIKE :trademark_id AND oxy.y_types = 'trademarks' )
                        OR (oxy.x_ids LIKE :product_group_id AND oxy.x_types = 'product_group')
                        OR (oxy.y_ids LIKE :product_group_id AND oxy.y_types = 'product_group')
                        OR (oxy.x_ids LIKE '%,-1,%')  
                        OR (oxy.y_ids LIKE '%,-1,%')  
                        ";
        //! services x_types
        if ($product_services) {
            $sql .= "OR(";
        }
        foreach ($product_services as $index => $service) {
            $param = ":service_id_{$index}";
            $sql .= " (oxy.x_ids LIKE $param) OR";
        }
        $sql = rtrim($sql, 'OR');
        if ($product_services) {
            $sql .= " AND oxy.x_types = 'services' ) ";
        }
        //! services y_types
        if ($product_services) {
            $sql .= "OR(";
        }
        foreach ($product_services as $index => $service) {
            $param = ":service_id_{$index}";
            $sql .= " (oxy.y_ids LIKE $param) OR";
        }
        $sql = rtrim($sql, 'OR');
        if ($product_services) {
            $sql .= " AND oxy.y_types = 'services' ) ";
        }


        $sql .= $product_tags ? " OR (" : '';
        //! tags x_types
        if ($product_tags) {
            foreach ($product_tags as $index => $tag) {
                $param = ":product_tag_{$index}";
                $sql .= "(oxy.x_ids LIKE $param) OR";
            }
            $sql = rtrim($sql, 'OR');
        }
        $product_tags ? $sql .= " AND oxy.x_types = 'tags' ) OR(" : '';

        //! tags y_types
        if ($product_tags) {
            foreach ($product_tags as $index => $tag) {
                $param = ":product_tag_{$index}";
                $sql .= "(oxy.y_ids LIKE $param) OR";
            }
            $sql = rtrim($sql, 'OR');
        }
        $product_tags ? $sql .= " AND oxy.y_types = 'tags' )" : '';
        $sql .= " ) ORDER BY p.priority DESC LIMIT 1";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindValue(':product_id', '%,' . $product_id . ',%');
        $stmt->bindValue(':affiliator_id', $affiliator_id);
        $stmt->bindValue(':price_type', $price_type);
        $stmt->bindValue(':setfrom', $setfrom);
        $stmt->bindValue(':trademark_id', '%,' . $trademark_id . ',%');
        $stmt->bindValue(':product_group_id', '%,' . $product_group_id . ',%');
        $stmt->bindValue(':now', $now);

        foreach ($product_services as $index => $service) {
            $param = ":service_id_{$index}";
            $stmt->bindValue($param, '%,' . $service['service_id'] . ',%');
        }
        if ($product_tags) {
            foreach ($product_tags as $index => $tag) {
                $param = ":product_tag_{$index}";
                $stmt->bindValue($param, '%,' . $tag['id'] . ',%');
            }
        }
        $stmt->execute();
        return $stmt->fetchAll(PDO::FETCH_ASSOC);
    }

    public function getUserClientGroup($id) {
        $Affiliator_id = AFFILIATOR['id'];
        $sql = "SELECT 
                    gl.name,
                    g.id,
                    gal.description,
                    gal.img
                FROM users_groups ug
                LEFT JOIN `groups` g ON ug.group_id = g.id AND g.active = '1' AND g.type = 'clients'
                LEFT JOIN groups_langs gl ON g.id = gl.p_id AND gl.lang_code = :lang_code
                INNER JOIN groups_affiliate ga 
                    ON g.id = ga.group_id 
                    AND ga.active = '1' 
                    AND ga.affiliator_id = :affiliator_id
                LEFT JOIN groups_affiliate_langs gal ON ga.id = gal.p_id AND gal.lang_code = :lang_code
                WHERE ug.user_id = :id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':id', $id);
        $stmt->bindParam(':lang_code', $this->lang_code);
        $stmt->bindParam(':affiliator_id', $Affiliator_id);
        $stmt->execute();
        return $stmt->fetch(PDO::FETCH_ASSOC);
    }

    public function getProductByTags($tags) {
        $tags_ids = trim($tags, ',');
        $array = getPlaceHolders($tags_ids);
        $sql = "SELECT pt.product_id
                FROM product_tags pt
                INNER JOIN tags t ON t.id = pt.tag_id AND t.active = '1'
                WHERE  pt.tag_id in ({$array['placeholders']})";
        $stmt = $this->mDb->connect()->prepare($sql);
        foreach ($array['ids'] as $key => $id) {
            $stmt->bindValue(":id$key", trim($id), PDO::PARAM_INT);
        }
        $stmt->execute();
        $res = $stmt->fetchAll(PDO::FETCH_COLUMN);
        return implode(',', $res);
    }

 
     public function getProductByProduct_Group($product_group) {
        $affiliator_id = AFFILIATOR['id'];
        $product_group = trim($product_group, ',');
        $array = getPlaceHolders($product_group);
        $sql = "SELECT pg.product_id
                FROM products_groups pg
                INNER JOIN `groups` g ON g.id = pg.group_id AND g.active = '1'
                INNER JOIN groups_affiliate ga ON g.id = ga.group_id AND ga.active = '1' AND ga.affiliator_id = :affiliator_id
                WHERE pg.group_id in ({$array['placeholders']})";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindValue(":affiliator_id", $affiliator_id, PDO::PARAM_INT);
        foreach ($array['ids'] as $key => $id) {
            $stmt->bindValue(":id$key", trim($id), PDO::PARAM_INT);
        }
        $stmt->execute();
        return $stmt->fetchAll(PDO::FETCH_COLUMN);
    }
    
    public function getProductByServices($services) {
        $service_ids = trim($services, ',');
        $array = getPlaceHolders($service_ids);
        $sql = "SELECT ps.product_id
                FROM product_services ps
                INNER JOIN services s ON s.id =  ps.service_id AND s.active = '1'
                WHERE ps.service_id in ({$array['placeholders']})";
        $stmt = $this->mDb->connect()->prepare($sql);
        foreach ($array['ids'] as $key => $id) {
            $stmt->bindValue(":id$key", trim($id), PDO::PARAM_INT);
        }
        $stmt->execute();
        $res = $stmt->fetchAll(PDO::FETCH_COLUMN);
        return implode(',', $res);
    }
    
       public function getProductByTrademarks($trademarks) {
        $affiliator_id = AFFILIATOR['id'];
        $active = ',' . $affiliator_id . '_1,';
        $trademark_ids = trim($trademarks, ',');
        $array = getPlaceHolders($trademark_ids);
        $sql = "SELECT p.id
                FROM products p
                INNER JOIN product_services ps ON p.id = ps.product_id
                INNER JOIN services s ON s.id = ps.service_id AND s.active = '1'
                WHERE ps.trademark_id in ({$array['placeholders']})
                AND p.active LIKE :active";
        $stmt = $this->mDb->connect()->prepare($sql);
        foreach ($array['ids'] as $key => $id) {
            $stmt->bindValue(":id$key", trim($id), PDO::PARAM_INT);
        }
        $stmt->bindValue(":active", '%' . $active . '%', PDO::PARAM_STR);
        $stmt->execute();
        $res = $stmt->fetchAll(PDO::FETCH_COLUMN);
        return implode(',', $res);
    }
    
    
}
