<?php

$secretApi = new secretApi();

class secretApi {
    public $mDb;
    public $masterDb;
    public $mConfig;
    public $dateTime;
    public $lang_code;

    public function __construct() {
        global $Config;
        $this->mDb = new iplus();
        $this->mConfig = $Config;
        $this->dateTime = date('Y-m-d H:i:s');
        $this->lang_code = LANGUAGE;
    }

    public function getSecretKeyDetails($secret_key) {

        $sql = "SELECT  sa.id,sa.active,sa.archive_products,sa.share_quantity_products,sa.secret_key,sa.dealer_id,sa.excluded_products  FROM `setting_api` sa ";
        $sql .= " WHERE sa.`secret_key` = '{$secret_key}' and sa.active='1' ";
        $res = $this->mDb->getRow($sql);
        if ($res) {
            $res['sections'] = $this->getAllImportApiSections($res['id']);
            $res['stores'] = $this->getAllImportApiStores($res['id']);
            $secretKeyArray = explode('-', $res["secret_key"]);
            $res['dealer_name_from'] = $secretKeyArray[0];
        }

        return $res;
    }

    public function getAllImportApiSections($p_id) {
        $sql = "SELECT  sas.id,sas.parent AS api_parent,sas.cat_id AS api_cat_id,sas.deleted, sl.ser_name cat_name ,sl2.ser_name as parent_name  FROM `{$this->mPrefix}setting_api_sections` sas  ";
        $sql .= " LEFT JOIN `service_langs` sl ON sas.cat_id = sl.service_id ";
        $sql .= " LEFT JOIN `service_langs` sl2 ON sas.parent = sl2.service_id ";
        $sql .= " WHERE   sas.p_id = '{$p_id}' ";
        $sql .= " Group by sas.id ";
        $res = $this->mDb->getAll($sql);
        return $res ? $res : array();
    }

    public function getAllImportApiStores($p_id) {
        $sql = "SELECT  sas.*,s.code,sl.title,sl.title_share  FROM `{$this->mPrefix}setting_api_stores` sas  ";
        $sql .= " LEFT JOIN `stores` s ON sas.store_id = s.id ";
        $sql .= " LEFT JOIN `store_langs` sl ON s.id = sl.store_id ";
        $sql .= "WHERE   sas.p_id = '{$p_id}' ";
        $res = $this->mDb->getAll($sql);
        return $res ? $res : array();
    }

    public function getProductsBySectionsAndStores($aStart, $aLimit, $sort, $type, $searchKey, $searchServiceId, $searchStore_id, $product_ids) {

        $sql = "SELECT  p.id as product_id,p.product_barcode ,pl_ar.name as product_name ";
        $sql .=" FROM `products` p";
        $sql .= " LEFT JOIN `product_services` ps ON ps.product_id = p.id ";
        $sql .= " LEFT JOIN `product_langs` pl_ar ON pl_ar.product_id = p.id  AND  pl_ar.lang_code = 'ar'";
        $sql .= " LEFT JOIN `product_langs` pl_en ON pl_en.product_id = p.id  AND  pl_en.lang_code = 'en'";
        $sql .= " LEFT JOIN `product_stores` pst ON pst.product_id = p.id  ";
        $sql .= " LEFT JOIN `product_suggesstion_search_keys` pssk ON pssk.product_id = p.id ";
        $sql .= " WHERE p.id >  0  and p.api_dealer_id='0'  ";

        $sql .= $searchKey ? ' AND ( ' . search_word_in_column('p.`product_code`', $searchKey) . ' OR ' . search_word_in_column('p.`product_barcode`', $searchKey) . ' OR ' . search_word_in_column('pl_ar.`name`', $searchKey) . ' OR  ' . search_word_in_column('pl_en.`name`', $searchKey) . ' OR ' . search_word_in_column('p.`key_words`', $searchKey) . '  OR ' . search_word_in_column('pssk.`suggesstion`', $searchKey) . ')' : " ";
        $sql .= $searchServiceId ? " AND ps.`service_id` in  ({$searchServiceId})  " : "";
        $sql .= " AND  p.`active` !=  '0'  ";
        $sql .= $searchStore_id ? " AND pst.`store_id` in ({$searchStore_id})  " : "";
        $sql .= $product_ids ? " AND p.`id` NOT IN ({$product_ids})  " : "";

        $sql .= " group by  p.id ";
        $sql .= "  ORDER BY p.{$sort} {$type} ";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
//       echo $sql . "<hr>";
// die();
        $res = $this->mDb->getAll($sql);
        if ($res) {
            for ($i = 0; $i < count($res); $i++) {
                $res[$i]['images'] = $this->getProductimgs($res[$i]['product_id'], 1);
                $res[$i]['image'] = $res[$i]['images'][0]['name'];
                $res[$i]['stores'] = $this->getStoresByProductId($res[$i]['product_id']);
                $res[$i]['sections'] = $this->getSectionsByProductId($res[$i]['product_id']);
            }
# code...
        }
        return $res;
    }

    public function getProductimgs($id, $aLimit = '') {
        $sql = "SELECT name ,type ,size  FROM product_medias  ";
        $sql .= " WHERE `product_id` = '{$id}'   ";
        $sql .= $aLimit ? " LIMIT  0, {$aLimit} " : '';

        return $this->mDb->getAll($sql);
    }

    public function getStoresByProductId($product_id) {

        $sql = "SELECT DISTINCT p.store_id FROM `product_stores` p";
        $sql .= " WHERE p.`product_id` = '{$product_id}' and p.is_deleted = '0' ";
        $sql .=" Group BY p.`store_id` ";
        $res = $this->mDb->getAll($sql);

        return $res;
    }

    public function getSectionsByProductId($id) {
        $sql = "SELECT  ps.service_id as cat_id FROM product_services ps ";
        $sql .= " WHERE ps.`product_id` = '{$id}' Group by ps.service_id";
        return $this->mDb->getAll($sql);
    }

    public function getAccountDetails($id) {

        $sql = "SELECT  u.id,u.user_name,u.drop_shipping  FROM `users` u ";
        $sql .= " WHERE u.`id` = '{$id}' and u.active='1' ";
        $res = $this->mDb->getRow($sql);
        if ($res) {
            $res['count_addresses'] = $this->getCountAddress($res['id']);
        }

        return $res ? $res : false;
    }

    public function getCountAddress($client_id) {

        $sql = "SELECT  count(id)    FROM `{$this->mPrefix}client_addresses`   ";
        $sql .= "WHERE  client_id = '{$client_id}' ";
        $res = $this->mDb->getOne($sql);

        return $res;
    }

    public function addSharingStoresAndSections($temp) {


        $DataNew['dealer_id_to'] = $temp['dealer_id_to'];
        $DataNew['dealer_id_from'] = $temp['dealer_id_from'];
        $DataNew['dealer_name_from'] = $temp['dealer_name_from'];
        $DataNew['dealer_name_to'] = $temp['dealer_name_to'];
        $DataNew['secret_key'] = trim($temp['secret_key']);
        $DataNew['api_id_from'] = $temp['api_id_from'];
        $DataNew['api_id_to'] = $temp['api_id_to'];
        $DataNew['active_from'] = $temp['active_from'] ? '1' : '0';
        $DataNew['active_to'] = $temp['active_to'] ? '1' : '0';
        $DataNew['share_quantity_products'] = $temp['share_quantity_products'];
        $DataNew['archive_products'] = $temp['archive_products'];
        $DataNew['excluded_products_from'] = $temp['excluded_products_from'];
        $DataNew['excluded_products_to'] = $temp['excluded_products_to'];
        $DataNew['edit'] = '1';


        $temp['p_id'] = $this->getSharingApiByData($temp);
        if (!$temp['p_id']) {
            $sql = "INSERT INTO `sharing_api` SET ";
            foreach ($this->mDb->getCols('sharing_api', $DataNew) as $k => $v) {
                $sql .= ($k == 'date_added' ) ? "" : "`{$k}`='{$v}',";
            }
            $sql .= " `date_added` = '{$this->dateTime}'";
            // echo "$sql";die();
            $temp['p_id'] = $this->mDb->queryreturnlastid($sql);
        } else {
            $temp['active_to'] = $temp['active_to'] ? '1' : '0';
            $sql = "UPDATE `sharing_api` SET ";
            $sql .= " `excluded_products_to`='{$temp['excluded_products_to']}', ";
            $sql .= " `archive_products`='{$temp['archive_products']}', ";
            $sql .= " `active_from`='{$temp['active_from']}',`active_to`='{$temp['active_to']}',`edit`='1' ";
            $sql .= " WHERE `id` = '{$temp['p_id']}'";
//            echo $sql . "<hr>";
            $res = $this->mDb->query($sql);
        }


        if ($temp['p_id']) {

            if (count($temp['stores']) > 0) {
                foreach ($temp['stores'] as $k => $v) {
                    $Row_id = $this->getSharingStoresByData($v, $temp);
                    $v['active'] = $v['active'] ? "1" : "0";
                    if ($v['active'] == '1') {
                        if (!$Row_id) {
                            $this->addSharingStoresByData($v, $temp);
                        } else {
                            $this->updateSharingStoresByData($Row_id, $v['deleted_to'], $v['deleted']);
                        }
                    } else {
                        if ($Row_id) {
                            $this->updateSharingStoresByData($Row_id, '1', $v['deleted']);
                        }
                    }
                }
            }
            if (count($temp['sections']) > 0) {
                foreach ($temp['sections'] as $k => $v) {
                    $Row_id = $this->getSharingSectionsByData($v, $temp);
                    if ($v['cat_id'] != '0') {
                        if (!$Row_id) {
                            $this->addSharingSectionsByData($v, $temp);
                        } else {
                            $this->updateSharingSectionsByData($Row_id, $v['deleted_to'], $v['deleted']);
                        }
                    } else {
                        if ($Row_id) {
                            $this->updateSharingSectionsByData($Row_id, '1', $v['deleted']);
                        }
                    }
                }
            }
        }
        return $temp;
    }

    public function getSharingApiByData($temp) {
        $sql = "SELECT  sa.id FROM `sharing_api` sa ";
        $sql .= " WHERE sa.`dealer_id_to` = '{$temp['dealer_id_to']}' and sa.api_id_from='{$temp['api_id_from']}' and sa.api_id_to='{$temp['api_id_to']}'  ";
//       echo $sql . "<hr>";
        $res = $this->mDb->getOne($sql);

        return $res ? $res : '';
    }

    public function getSharingStoresByData($data, $temp) {
        $sql = "SELECT  ss.id FROM `sharing_api_stores` ss ";
        $sql .= " WHERE ss.`p_id` = '{$temp['p_id']}' and ss.store_id_from='{$data['store_id']}' and ss.store_id_to='{$data['store_id_to']}'  ";
//        echo $sql . "<hr>";
        $res = $this->mDb->getOne($sql);

        return $res ? $res : '';
    }

    public function addSharingStoresByData($Data, $temp) {
        $DataNew['deleted'] = '0';
        $DataNew['edit'] = '1';
        $DataNew['store_id_from'] = $Data['store_id'];
        $DataNew['store_id_to'] = $Data['store_id_to'];
        $DataNew['p_id'] = $temp['p_id'];




        $sql = "INSERT INTO `sharing_api_stores` SET ";
        foreach ($this->mDb->getCols('sharing_api_stores', $DataNew) as $k => $v) {
            $sql .= ($k == 'date_added' ) ? "" : "`{$k}`='{$v}',";
        }
        $sql .= " `date_added` = '{$this->dateTime}'";
        // echo "$sql";die();
        $id = $this->mDb->queryreturnlastid($sql);

        return $id ? $id : '';
    }

    public function deleteSharingApi($api_id_to) {
        $sql = "UPDATE `sharing_api` SET ";
        $sql .= "`deleted_to`='1',`edit`='1' ";
        $sql .= " WHERE `api_id_to` = '{$api_id_to}'";
//            echo $sql."<hr>";
        $res = $this->mDb->query($sql);
        return $res ? $res : '';
    }

    public function updateSharingStoresByData($id, $deleted_to = '1', $deleted = '0') {


        $sql = "UPDATE `sharing_api_stores` SET ";
        $sql .= "`deleted_to`='{$deleted_to}',`deleted`='{$deleted}',`edit`='1' ";
        $sql .= " WHERE `id` = '{$id}'";
//            echo $sql."<hr>";
        $res = $this->mDb->query($sql);
        return $res ? $res : '';
    }

    public function getSharingSectionsByData($data, $temp) {
        $sql = "SELECT  ss.id FROM `sharing_api_sections` ss ";
        $sql .= " WHERE ss.`p_id` = '{$temp['p_id']}' and ss.parent_from='{$data['api_parent']}' and ss.cat_id_from='{$data['api_cat_id']}'    ";
        $sql .=$data['parent'] && $data['cat_id'] ? "   and ss.parent_to='{$data['parent']}' and ss.cat_id_to='{$data['cat_id']}'    " : "";
//        $sql .= " and ss.deleted_to ='0'";
//        echo $sql . "<hr>";
        $res = $this->mDb->getOne($sql);

        return $res ? $res : '';
    }

    public function addSharingSectionsByData($Data, $temp) {
        $DataNew['deleted'] = '0';
        $DataNew['edit'] = '1';
        $DataNew['parent_from'] = $Data['api_parent'];
        $DataNew['cat_id_from'] = $Data['api_cat_id'];
        $DataNew['parent_to'] = $Data['parent'];
        $DataNew['cat_id_to'] = $Data['cat_id'];
        $DataNew['p_id'] = $temp['p_id'];




        $sql = "INSERT INTO `sharing_api_sections` SET ";
        foreach ($this->mDb->getCols('sharing_api_sections', $DataNew) as $k => $v) {
            $sql .= ($k == 'date_added' ) ? "" : "`{$k}`='{$v}',";
        }
        $sql .= " `date_added` = '{$this->dateTime}'";
        // echo "$sql";die();
        $id = $this->mDb->queryreturnlastid($sql);

        return $id ? $id : '';
    }

    public function updateSharingSectionsByData($id, $deleted_to = '1', $deleted = '0') {


        $sql = "UPDATE `sharing_api_sections` SET ";
        $sql .= "`deleted_to`='{$deleted_to}',`deleted`='{$deleted}',`edit`='1'  ";
//        $sql .= $data['cat_id_to'] ? "  ,cat_id_to='{$data['cat_id']}' ,parent_to='{$data['parent']}'  " : "";
        $sql .= " WHERE `id` = '{$id}'";
//        echo $sql . "<hr>";
        $res = $this->mDb->query($sql);
        return $res ? $res : '';
    }

}
