<?php

$bannersObj = new banners();

class banners {

    var $mDb;
    var $mConfig;
    var $dateTime;
    var $lang_code;

    function __construct() {
        global $Config;
        $this->mDb = new iplus();
        $this->mConfig = $Config;
        $this->dateTime = date('Y-m-d H:i:s');
        $this->lang_code = LANGUAGE;
    }

    function getBanners($aStart, $aLimit, $sort, $type, $searchTitle, $searchAffiliator_id, $searchServiceId) {
   $time = time();
        if ($searchServiceId) {
            $chidIds = $this->getIdsOfChidService($searchServiceId);
            if ($chidIds) {
                $searchServiceId .= ',' . $chidIds;
                // p($searchServiceId);
            }
        }

        $sql = "SELECT 	 p.banner_height
		,p.banner_width
		,p.date_added
		,p.id
		,p.image
		,p.image_en
		,p.type
		,p.url_type
		,p.url,pl.title FROM banners p";
        $sql .= " LEFT JOIN `banner_langs` pl ON p.id = pl.banner_id  AND pl.lang_code ='{$this->lang_code}' ";
        $sql .= " LEFT JOIN `banner_services` ps ON ps.banner_id = p.id ";

        $sql .= " WHERE p.active = '1' ";

        $sql .= $searchTitle ? ' AND pl.title like "%' . $searchTitle . '%" ' : '';
        $sql .= $searchAffiliator_id ? " AND p.`affiliator_id` ='{$searchAffiliator_id}' " : " ";
        $sql .= $searchServiceId ? " AND ps.`service_id` in  ({$searchServiceId})  " : "";

        $sql .= " ORDER BY p.{$sort} {$type}";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';

        // echo $sql;
        // die();


        $res = $this->mDb->getAll($sql);

        if ($res) {
            for ($i = 0; $i < count($res); $i++) {
                $res[$i]['ser_name'] = $this->getAllServicesNameOfBannerById($res[$i]['id']);
                if ($res[$i]['url_type'] == 'product') {
                    $trademark = $this->getTrademarkDataInProductId($res[$i]['url']);
                    $res[$i]['trademark_image'] = $trademark['image'];
                } else {
                    $res[$i]['trademark_image'] = null;
                }
                if ($this->lang_code == 'ar') {
                    $res[$i]['image'] = $res[$i]['image']. "?t=" . $time;;
                } else if ($this->lang_code == 'en') {
                    $res[$i]['image'] = $res[$i]['image_en']. "?t=" . $time;;
                }
                unset($res[$i]['image_en']);
            }
        }
        return $res;
    }

       public function getTrademarkDataInProductId($productId) {
        $sql = "SELECT t.image   
                FROM trademarks t
                LEFT JOIN `products` p ON t.id = p.trademark_id
                WHERE p.id = :id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':id', $productId, PDO::PARAM_INT);
        $stmt->execute();
        return $stmt->fetch(PDO::FETCH_ASSOC);
    }

    function getIdsOfChidService($id) {
        $sql = "SELECT id FROM `services`";
        $sql .= " WHERE `parent` = '{$id}' ";
        $res = $this->mDb->getAll($sql);
        if ($res) {
            return fetchArrayValue_from_dataBase($res, 'id');
        }
    }

    public function getAllServicesNameOfBannerById($id, $limit = '') {

        $sql = "SELECT sl.ser_name FROM banner_services  ps ";
        $sql .= " LEFT JOIN `service_langs` sl ON sl.service_id = ps.service_id  AND  sl.lang_code = '{$this->lang_code}'  ";
        $sql .= " WHERE ps.`banner_id` = '{$id}'   ";
        $sql .= $limit ? " Limit  1 " : " ";

        // echo  $sql ;die();

        $res = $this->mDb->getAll($sql);
        return fetchArrayValue_from_dataBase($res, 'ser_name');
    }

}
